﻿----------------------------------------------------------
--<< Start of non-funtion block to start-up the AddOn >>--
----------------------------------------------------------

FS = {}
local adj = {}
local _, playerClass = UnitClass("player")
local unitLevel = UnitLevel("player")
local lang = GetCVar("locale")
local reload = true

-- Don´t load the AddOn unless player is a Hunter
if playerClass == "HUNTER" and unitLevel == 80 then
	FS.version = "0.9.7b4"
	FS.events = {}				
	FS.baseFrame = CreateFrame("Frame")	-- The BaseFrame to which all the events will be registered
	FS.baseFrame:RegisterEvent("ADDON_LOADED")
	FS.baseFrame:SetScript("OnEvent", function(this, event, ...) FS.events[event](...) end)
else
	return false
end

-- Initialize some frequently (re)used variables
local now, first, str, tarGUID, tarTTL
local msCritChance, aimsCritChance, asCritChance, ssCritChance, esCritChance, ksCritChance
local rangedAP, baseAP, rangedTSAAP, actualAP, actualTSAAP, possibleAP
local allDmgAdj, constDmgAdj, refreshDmgAdj, instantDmgAdj
local critChance, critAdj, critMfDAdj, critSerpAdj
local psAdj, armorPen, baseArmor, effectiveArmor, avrResist, effResist
local baseMin, critMin, baseMax, critMax, baseDMG, critDMG
local minTick, critMinTick, maxTick, critMaxTick, baseTick, critTick, baseCSSPS, csSerp
local spsTick, spsRefreshTick, spsCritTick, spsCritRefreshTick
local minESTick, maxESTick, critMinESTick, critMaxESTick, esTick, critESTick
local baTick
local d, G, s, m, t

-----------------------------------------
--<< Start of utility funtions block >>--
-----------------------------------------

-- Calculate the current damage adjustments
function FS:GetAdjustments()
	table.wipe(adj)
	
	-- Passive Talents
	if FS.talents[FS.tn["Focused Fire"]] > 0 and UnitExists("pet") then
		adj["ff"] = {["mod"] = 1 + FS.talents[FS.tn["Focused Fire"]] * 0.01, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Improved Tracking"]] > 0 and FS:IsTrackable(UnitCreatureType("target")) then
		adj["it"] = {["mod"] = 1 + FS.talents[FS.tn["Improved Tracking"]] * 0.01, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Ranged Weapon Specialization"]] > 0 then
		adj["rws"] = {["mod"] = 1 + (floor(FS.talents[FS.tn["Ranged Weapon Specialization"]] * 5 / 3)) / 100, ["affects"] = {["ss"] = true, ["ms"] = true, ["aims"] = true, ["as"] = true, ["es"] = true, ["cs"] = true, ["ks"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Barrage"]] > 0 then
		adj["bar"] = {["mod"] = 1 + FS.talents[FS.tn["Barrage"]] * 0.04, ["affects"] = {["ms"] = true, ["aims"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Improved Stings"]] > 0 then
		adj["is"] = {["mod"] = 1 + FS.talents[FS.tn["Improved Stings"]] * 0.1, ["affects"] = {["sps"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Noxious Stings"]] > 0 then
		adj["spsns"] = {["mod"] = 1 + FS.talents[FS.tn["Noxious Stings"]] * 0.01, ["affects"] = {["sps"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["T.N.T."]] > 0 then
		adj["tnt"] = {["mod"] = 1 + FS.talents[FS.tn["T.N.T."]] * 0.02, ["affects"] = {["es"] = true, ["ba"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Trap Mastery"]] > 0 then
		adj["tm"] = {["mod"] = 1 + FS.talents[FS.tn["Trap Mastery"]] * 0.1, ["affects"] = {["ba"] = true}, ["refresh"] = "const"}
	end
	if FS.talents[FS.tn["Improved Arcane Shot"]] > 0 then
		adj["ias"] = {["mod"] = 1 + FS.talents[FS.tn["Improved Arcane Shot"]] * 0.05, ["affects"] = {["as"] = true}, ["refresh"] = "const"}
	end
	-- Buffs
	if FS.buffs[FS.sn["The Beast Within"]] then
		adj["tbw"] = {["mod"] = 1.1, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Sniper Training"]] then
		adj["st"] = {["mod"] = 1 + FS.talents[FS.tn["Sniper Training"]] * 0.02, ["affects"] = {["ss"] = true, ["aims"] = true, ["ba"] = true, ["es"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Improved Steady Shot"]] then
		adj["iss"] = {["mod"] = 1.15, ["affects"] = {["aims"] = true, ["as"] = true, ["cs"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Ferocious Inspiration"]] then
		adj["fi"] = {["mod"] = 1.03, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Arcane Empowerment"]] then
		adj["ae"] = {["mod"] = 1.03, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Culling the Herd"]] then
		adj["cth"] = {["mod"] = 1.03, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Exploit Weakness"]] then
		adj["ew"] = {["mod"] = 1.15, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Tricks of the Trade"]] then
		adj["tott"] = {["mod"] = 1.15, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Strength of Wrynn"]] or FS.buffs[FS.sn["Hellscream's Warsong"]] then
		adj["tott"] = {["mod"] = 1.05, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Aspect of the Viper"]] then
		adj["aotv"] = {["mod"] = 0.5, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.buffs[FS.sn["Hysteria"]] then
		adj["hyst"] = {["mod"] = 1.2, ["affects"] = {["ss"] = true, ["ms"] = true, ["aims"] = true, ["ks"] = true}, ["refresh"] = "const"}
	end
	if FS.pdebuffs[FS.sn["Essence of the Blood Queen"]] then
		adj["ebq"] = {["mod"] = 2, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	if FS.pdebuffs[FS.sn["Shadow Crash"]] then
		adj["sc"] = {["mod"] = 2, ["affects"] = {["as"] = true, ["sps"] = true, ["ba"] = true, ["es"] = true, ["cs"] = true}, ["refresh"] = "const"}
	end
	if FS.pdebuffs[FS.sn["Rune of Power"]] then
		adj["rop"] = {["mod"] = 1.5, ["affects"] = {["all"] = true}, ["refresh"] = "const"}
	end
	-- Debuffs
	if FS.debuffs[FS.sn["Curse of Elements"]] or FS.debuffs[FS.sn["Earth and Moon"]] or FS.debuffs[FS.sn["Ebon Plaguebringer"]] then
		adj["spell"] = {["mod"] = 1.13, ["affects"] = {["as"] = true, ["sps"] = true, ["ba"] = true, ["es"] = true, ["cs"] = true}, ["refresh"] = "instant"}
	end
	if FS.debuffs[FS.sn["Black Arrow"]] then
		adj["ba"] = {["mod"] = 1.06, ["affects"] = {["ss"] = true, ["ms"] = true, ["aims"] = true, ["as"] = true, ["sps"] = true, ["es"] = true, ["cs"] = true, ["ks"] = true}, ["refresh"] = "instant"}
	end
	if FS.debuffs[FS.sn["Serpent Sting"]] and FS.talents[FS.tn["Noxious Stings"]] > 0 then
		adj["ns"] = {["mod"] = 1 + FS.talents[FS.tn["Noxious Stings"]] * 0.01, ["affects"] = {["ss"] = true, ["ms"] = true, ["aims"] = true, ["ba"] = true, ["as"] = true, ["es"] = true, ["cs"] = true,  ["ks"] = true}, ["refresh"] = "instant"}
	end
	if FS.debuffs[FS.sn["Hunter's Mark"]] and FS.talents[FS.tn["Marked for Death"]] > 0 then
		adj["mfd"] = {["mod"] = 1 + FS.talents[FS.tn["Marked for Death"]] * 0.01, ["affects"] = {["ss"] = true, ["ms"] = true, ["aims"] = true, ["as"] = true, ["ba"] = true, ["es"] = true, ["cs"] = true, ["ks"] = true},	["refresh"] = "const"}
	end
	if FS.debuffs[FS.sn["Singed"]] then
		adj["spell"] = {["mod"] = 1 + 0.02 * FS.debuffs[FS.sn["Singed"]]["CNT"], ["affects"] = {["as"] = true, ["sps"] = true, ["ba"] = true, ["es"] = true, ["cs"] = true}, ["refresh"] = "instant"}
	end
	-- Glyphs
	if FS.usedGlyphs["Serpent Sting"] then
		adj["spsglyph"] = {["mod"] = 1.4, ["affects"] = {["sps"] = true}, ["refresh"] = "ticks"}
	end
	if FS.usedGlyphs["Steady Shot"] and FS.debuffs[FS.sn["Serpent Sting"]] then
		adj["ssglyph"] = {["mod"] = 1.1, ["affects"] = {["ss"] = true}, ["refresh"] = "const"}
	end
	-- Misc
	if FS.data.t8Items >= 2 then
		adj["spsT8"] = {["mod"] = 1.1, ["affects"] = {["sps"] = true}, ["refresh"] = "const"}
	end
	if FS.data.stbug and FS.talents[FS.tn["Sniper Training"]] > 0 then
		adj["stbug"] = {["mod"] = 1.06, ["affects"] = {["ss"] = true, ["aims"] = true, ["es"] = true}, ["refresh"] = "instant"}
	end
	if FS.debuffs[FS.sn["Serpent Sting"]] and FS.talents[FS.tn["Sniper Training"]] > 0 then
		adj["spsbug"] = {["mod"] = 1.04, ["affects"] = {["ss"] = true, ["aims"] = true, ["es"] = true}, ["refresh"] = "instant"}
	end
end

-- Calculate shot damage
function FS:GetCombatStats()
	if FS.TSLU.combatStats == 0 then return
	else FS.TSLU.combatStats = 0
	end
	now = GetTime()
	tarGUID = FS.data.unitGUID
	tarTTL = FS.data.tarTTL[tarGUID]["TTL"] - now
	
	-- Check for delayed processing due to slow combatrating update
	if FS.data.checkStatsAt <= now and FS.data.checkStatsAt > 0 then FS.data.checkStatsAt = 0 end

	-- Base Stats used in the shot formulas
	-- Target level. If level is below 70 calculate as if it was 70
	local level = UnitLevel("target")
	if level == -1 then level = 83
	elseif level < 70 then level = 70
	end
	
	-- Ranged AP
	local base, posBuff, negBuff = UnitRangedAttackPower("player")
	rangedAP = base + posBuff + negBuff
	baseAP = rangedAP
	rangedTSAAP = rangedAP
	actualAP, actualTSAAP, possibleAP = 500, 500, 500
	if FS.debuffs[FS.sn["Hunter's Mark"]] and FS.debuffs[FS.sn["Hunter's Mark"]]["SRC"] == "player" then
		if FS.talents[FS.tn["Improved Hunter's Mark"]] > 0 then actualAP = actualAP + (50 * FS.talents[FS.tn["Improved Hunter's Mark"]]) end
		if FS.usedGlyphs["Hunter's Mark"] then actualAP = actualAP + 100 end
	end
	if FS.talents[FS.tn["Improved Hunter's Mark"]] > 0 then possibleAP = possibleAP + (50 * FS.talents[FS.tn["Improved Hunter's Mark"]]) end
	if FS.usedGlyphs["Hunter's Mark"] then possibleAP = possibleAP + 100 end
	actualTSAAP = actualAP
	if FS.buffs[FS.sn["Trueshot Aura"]] or FS.buffs[FS.sn["Abomination's Might"]] or FS.buffs[FS.sn["Unleashed Rage"]] then actualAP = actualAP * 1.1 end
	if FS.debuffs[FS.sn["Hunter's Mark"]] then
		rangedTSAAP = rangedAP + actualTSAAP
		rangedAP = rangedAP + actualAP
	end
	
	-- Critchance
	critChance = (GetRangedCritChance() / 100)
	if level == 83 then critChance = critChance - 0.048
	elseif level == 82 then critChance = critChance - 0.004
	elseif level == 81 then critChance = critChance - 0.002
	elseif level >= 70 then critChance = critChance + 0.002 * (80 - level)
	end
	FS.data.critChance_now = critChance
	msCritChance, aimsCritChance, asCritChance, ssCritChance, esCritChance, ksCritChance = critChance, critChance, critChance, critChance, critChance, critChance
	local critBonus = 0
	if FS.talents[FS.tn["Improved Barrage"]] > 0 then
		msCritChance = msCritChance + FS.talents[FS.tn["Improved Barrage"]] * 0.04
		aimsCritChance = aimsCritChance + FS.talents[FS.tn["Improved Barrage"]] * 0.04
	end
	if FS.talents[FS.tn["Survival Instincts"]] > 0 then
		asCritChance = asCritChance + FS.talents[FS.tn["Survival Instincts"]] * 0.02
		ssCritChance = ssCritChance + FS.talents[FS.tn["Survival Instincts"]] * 0.02
		esCritChance = esCritChance + FS.talents[FS.tn["Survival Instincts"]] * 0.02
	end
	if FS.talents[FS.tn["Sniper Training"]] > 0 then
		ksCritChance = ksCritChance + FS.talents[FS.tn["Sniper Training"]] * 0.05
	end
	if FS.buffs[FS.sn["Trueshot Aura"]] and FS.usedGlyphs["Trueshot Aura"] then
		aimsCritChance = aimsCritChance + 0.1
	end
	if FS.usedGlyphs["Explosive Shot"] then
		esCritChance = esCritChance + 0.04
	end

	-- Damage adjustments
	FS:GetAdjustments()
	allDmgAdj, constDmgAdj, refreshDmgAdj, instantDmgAdj = 1, 1, 1, 1
	
	-- Crit damage adjustments
	critAdj = 1 + FS.talents[FS.tn["Mortal Shots"]] * 0.06
	critMfDAdj = critAdj + FS.talents[FS.tn["Marked for Death"]] * 0.02
	critSerpAdj = 1
	if FS.data.critMeta then
		critAdj = critAdj * 1.06
		critMfDAdj = critMfDAdj * 1.06
		critSerpAdj = 1.09
	end
	critAdj = critAdj + 1
	critMfDAdj = critMfDAdj + 1
	critSerpAdj = critSerpAdj * (1 + FS.talents[FS.tn["Mortal Shots"]] * 0.03) + 1
	critSerpAdj = critSerpAdj
	
	-- Piercing Shots
	psAdj = 1
	if FS.talents[FS.tn["Piercing Shots"]] > 0 then
		psAdj = FS.talents[FS.tn["Piercing Shots"]] * 0.1
		if FS.debuffs[FS.sn["Mangle (Cat)"]] or FS.debuffs[FS.sn["Mangle (Bear)"]] or FS.debuffs[FS.sn["Trauma"]] then
			psAdj = 1 + psAdj * 1.3
		elseif FS.debuffs[FS.sn["Stampede"]] then
			psAdj = 1 + psAdj * 1.25
		else
			psAdj = 1 + psAdj
		end
	end
	
	-- Armor
	armorPen = (GetArmorPenetration() / 100)
	baseArmor = 10643
	if level == 82 then baseArmor = 10333
	elseif level == 81 then baseArmor = 10038
	elseif level == 80 then baseArmor = 9729
	elseif level == 79 then baseArmor = 9426
	elseif level == 78 then baseArmor = 9124
	elseif level == 77 then baseArmor = 8822
	elseif level == 76 then baseArmor = 8520
	elseif level == 75 then baseArmor = 8219
	elseif level == 74 then baseArmor = 7918
	elseif level == 73 then baseArmor = 7618
	elseif level == 72 then baseArmor = 7318
	elseif level == 71 then baseArmor = 7018
	elseif level == 70 then baseArmor = 6719
	end
	if FS.debuffs[FS.sn["Sunder Armor"]] then
		baseArmor = baseArmor * (1 - (4 * FS.debuffs[FS.sn["Sunder Armor"]]["CNT"]) / 100)
	elseif FS.debuffs[FS.sn["Expose Armor"]] then
		baseArmor = baseArmor * (1 - (4 * FS.debuffs[FS.sn["Expose Armor"]]["CNT"]) / 100)
	elseif FS.debuffs[FS.sn["Acid Spit"]] then
		baseArmor = baseArmor * (1 - (10 * FS.debuffs[FS.sn["Acid Spit"]]["CNT"]) / 100)
	end
	if FS.debuffs[FS.sn["Curse of Weakness"]] or FS.debuffs[FS.sn["Faerie Fire"]] or FS.debuffs[FS.sn["Faerie Fire (Feral)"]] or FS.debuffs[FS.sn["Sting"]] then
		baseArmor = baseArmor * 0.95
	end
	effectiveArmor = baseArmor - armorPen * (baseArmor + 15232.5) / 3
	dmgReduce = 1 - (effectiveArmor / (effectiveArmor + 15232.5))
	adj["armor"] = {["mod"] = dmgReduce, ["affects"] = {["ss"] = true, ["aims"] = true, ["ms"] = true, ["ks"] = true}, ["refresh"] = "instant"}
	
	-- Partial Resists
	avrResist = (level - 80) * 0.02
	effResist = 1 - ((5 * avrResist * 0.1) + (2.5 * avrResist * 0.1))
	if effResist > 1 then effResist = 1 end
	
	-- Damage range and average shot damage used for the priority system
	-- Steady Shot damage range
	baseMin = 252 + (FS.data.ammoDPS * 2.8) + ((FS.data.minDMG / FS.data.weaponSpeed) * 2.8) + (rangedAP * 0.1)
	baseMax = 252 + (FS.data.ammoDPS * 2.8) + ((FS.data.maxDMG / FS.data.weaponSpeed) * 2.8) + (rangedAP * 0.1)
	if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseMin).." - "..FS:Round(baseMax).."\nRAP: base = "..baseAP.." / actual = "..rangedAP.."\nAdj.: " end
	allDmgAdj, first = 1, true
	adjType = next(adj)
	while(adjType) do
		if adj[adjType]["affects"]["ss"] or adj[adjType]["affects"]["all"] then
			allDmgAdj = allDmgAdj * adj[adjType]["mod"]
			if FS.calcFeedback then
				if first then first = false else str = str.." / " end
				str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			end
		end
		adjType = next(adj, adjType)
	end
	baseMin = baseMin * allDmgAdj
	baseMax = baseMax * allDmgAdj
	critMin = baseMin * critMfDAdj
	critMax = baseMax * critMfDAdj
	if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: critMfD = "..FS:Round(critMfDAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." - "..FS:Round(baseMax, 1).." (hit) / "..FS:Round(critMin, 1).." - "..FS:Round(critMax, 1).." (crit)" FS.shots[FS.sn["Steady Shot"]]["FB"] = str end
	FS.shots[FS.sn["Steady Shot"]]["MIN"] = baseMin
	FS.shots[FS.sn["Steady Shot"]]["MAX"] = baseMax
	FS.shots[FS.sn["Steady Shot"]]["CRITMIN"] = critMin
	FS.shots[FS.sn["Steady Shot"]]["CRITMAX"] = critMax
	-- Steady Shot average damage
	baseDMG = (baseMin + baseMax) / 2
	critDMG = ((critMin + critMax) / 2) * psAdj
	FS.shots[FS.sn["Steady Shot"]]["DMG"] = (1 - ssCritChance) * baseDMG + ssCritChance * critDMG
	if FS.data.SScastingTime and FS.data.SScastingTime > 1.5 then
		FS.shots[FS.sn["Steady Shot"]]["DMG"] = FS.shots[FS.sn["Steady Shot"]]["DMG"] * 1.5 / FS.data.SScastingTime
	end

	-- Multi-Shot damage range
	baseMin = 408 + (FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.minDMG + (rangedTSAAP / 14 * 2.8)
	baseMax = 408 + (FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.maxDMG + (rangedTSAAP / 14 * 2.8)
	if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseMin).." - "..FS:Round(baseMax).."\nRAP: base = "..baseAP.." / actual = "..rangedTSAAP.."\nAdj.: " end
	allDmgAdj, first = 1, true
	adjType = next(adj)
	while(adjType) do
		if adj[adjType]["affects"]["ms"] or adj[adjType]["affects"]["all"] then
			allDmgAdj = allDmgAdj * adj[adjType]["mod"]
			if FS.calcFeedback then
				if first then first = false else str = str.." / " end
				str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			end
		end
		adjType = next(adj, adjType)
	end
	baseMin = baseMin * allDmgAdj
	baseMax = baseMax * allDmgAdj
	critMin = baseMin * critAdj
	critMax = baseMax * critAdj
	if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: crit = "..FS:Round(critAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." - "..FS:Round(baseMax, 1).." (hit) / "..FS:Round(critMin, 1).." - "..FS:Round(critMax, 1).." (crit)" FS.shots[FS.sn["Multi-Shot"]]["FB"] = str end
	FS.shots[FS.sn["Multi-Shot"]]["MIN"] = baseMin
	FS.shots[FS.sn["Multi-Shot"]]["MAX"] = baseMax
	FS.shots[FS.sn["Multi-Shot"]]["CRITMIN"] = critMin
	FS.shots[FS.sn["Multi-Shot"]]["CRITMAX"] = critMax
	-- Multi-Shot average damage
	baseDMG = (baseMin + baseMax) / 2
	critDMG = (critMin + critMax) / 2
	FS.shots[FS.sn["Multi-Shot"]]["DMG"] = (1 - msCritChance) * baseDMG + msCritChance * critDMG
	
	--Aimed Shot damage range
	if FS.talents[FS.tn["Aimed Shot"]] > 0 then
		baseMin = 408 + (FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.minDMG + (rangedTSAAP / 14 * 2.8)
		baseMax = 408 + (FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.maxDMG + (rangedTSAAP / 14 * 2.8)
		if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseMin).." - "..FS:Round(baseMax).."\nRAP: base = "..baseAP.." / actual = "..rangedTSAAP.."\nAdj.: " end
		allDmgAdj, first = 1, true
		adjType = next(adj)
		while(adjType) do
			if adj[adjType]["affects"]["aims"] or adj[adjType]["affects"]["all"] then
				allDmgAdj = allDmgAdj * adj[adjType]["mod"]
				if FS.calcFeedback then
					if first then first = false else str = str.." / " end
					str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
				end
			end
			adjType = next(adj, adjType)
		end
		baseMin = baseMin * allDmgAdj
		baseMax = baseMax * allDmgAdj
		critMin = baseMin * critMfDAdj
		critMax = baseMax * critMfDAdj
		if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: critMfD = "..FS:Round(critMfDAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." - "..FS:Round(baseMax, 1).." (hit) / "..FS:Round(critMin, 1).." - "..FS:Round(critMax, 1).." (crit)" end
		FS.shots[FS.sn["Aimed Shot"]]["FB"] = str
		FS.shots[FS.sn["Aimed Shot"]]["MIN"] = baseMin
		FS.shots[FS.sn["Aimed Shot"]]["MAX"] = baseMax
		FS.shots[FS.sn["Aimed Shot"]]["CRITMIN"] = critMin
		FS.shots[FS.sn["Aimed Shot"]]["CRITMAX"] = critMax
	-- Aimed Shot average damage
		baseDMG = (baseMin + baseMax) / 2
		critDMG = ((critMin + critMax) / 2) * psAdj
		FS.shots[FS.sn["Aimed Shot"]]["DMG"] = (1 - aimsCritChance) * baseDMG + aimsCritChance * critDMG
	end
	
	-- Arcane Shot
	baseDMG = 492 + (rangedAP * 0.15)
	if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseDMG).."\nRAP: base = "..baseAP.." / actual = "..rangedAP.."\nAdj.: " end
	allDmgAdj, first = 1, true
	adjType = next(adj)
	while(adjType) do
		if adj[adjType]["affects"]["as"] or adj[adjType]["affects"]["all"] then
			allDmgAdj = allDmgAdj * adj[adjType]["mod"]
			if FS.calcFeedback then
				if first then first = false else str = str.." / " end
				str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			end
		end
		adjType = next(adj, adjType)
	end
	baseMin = baseDMG * allDmgAdj
	critMin = baseMin * critMfDAdj
	if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: critMfD = "..FS:Round(critMfDAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." (hit) / "..FS:Round(critMin, 1).." (crit)" FS.shots[FS.sn["Arcane Shot"]]["FB"] = str end
	FS.shots[FS.sn["Arcane Shot"]]["MIN"] = baseMin
	FS.shots[FS.sn["Arcane Shot"]]["CRITMIN"] = critMin
	baseDMG = baseMin * effResist
	critDMG = critMin * effResist
	FS.shots[FS.sn["Arcane Shot"]]["DMG"] = (1 - asCritChance) * baseDMG + asCritChance * critDMG
	
	-- Serpent Sting
	baseTick = (1210 + (rangedAP * 0.2)) / 5
	baseCSSPS = 1210 + (rangedTSAAP * 0.2)
	constDmgAdj, instantDmgAdj, first = 1, 1, true
	adjType = next(adj)
	while(adjType) do
		if adj[adjType]["affects"]["sps"] or adj[adjType]["affects"]["all"] then
			if adj[adjType]["refresh"] == "const" then constDmgAdj = constDmgAdj * adj[adjType]["mod"] end
			if adj[adjType]["refresh"] == "instant" then instantDmgAdj = instantDmgAdj * adj[adjType]["mod"] end
			if FS.calcFeedback and (adj[adjType]["refresh"] == "const" or adj[adjType]["refresh"] == "instant") then
				if first then first = false FS.data.spsAdjStr_now[tarGUID] = "" else FS.data.spsAdjStr_now[tarGUID] = FS.data.spsAdjStr_now[tarGUID].." / " end
				FS.data.spsAdjStr_now[tarGUID] = FS.data.spsAdjStr_now[tarGUID]..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			end
		end
		adjType = next(adj, adjType)
	end
	FS.data.baseSpSTick_now[tarGUID] = baseTick
	FS.data.constSpSAdj_now[tarGUID] = constDmgAdj
	FS.data.instantSpSAdj = instantDmgAdj
	if FS.debuffs[FS.sn["Serpent Sting"]] == false then
		FS.data.refreshSpSCrit[tarGUID] = critChance
		FS.data.baseSpSTick[tarGUID] = baseTick
		FS.data.constSpSAdj[tarGUID] = constDmgAdj
		if FS.calcFeedback then FS.data.spsAdjStr[tarGUID] = FS.data.spsAdjStr_now[tarGUID] end
	end
	if FS.data.refreshSpSCrit[tarGUID] == nil then FS.data.refreshSpSCrit[tarGUID] = critChance end
	if FS.data.constSpSAdj[tarGUID] == nil then FS.data.constSpSAdj[tarGUID] = FS.data.constSpSAdj_now[tarGUID] end
	if FS.data.baseSpSTick[tarGUID] == nil then FS.data.baseSpSTick[tarGUID] = FS.data.baseSpSTick_now[tarGUID] end
	spsTick = baseTick * FS.data.constSpSAdj_now[tarGUID] * instantDmgAdj
	spsRefreshTick = baseTick * FS.data.constSpSAdj[tarGUID] * instantDmgAdj
	spsCritTick = spsTick * critSerpAdj
	spsCritRefreshTick = spsRefreshTick * critSerpAdj
	if FS.calcFeedback then
		if FS.data.spsAdjStr[tarGUID] == nil then FS.data.spsAdjStr[tarGUID] = FS.data.spsAdjStr_now[tarGUID] end
		str = "Calculations:\nBase Tick damage: "..FS:Round(FS.data.baseSpSTick[tarGUID]).."\nRAP: base = "..baseAP.." / actual = "..rangedAP.."\n"
		str = str.."Adj.: "..FS.data.spsAdjStr[tarGUID].." -> "..FS:Round(FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj, 3).."\n"
		str = str.."Crit. adj.: critSerp = "..FS:Round(critSerpAdj, 3).."\nAdj. dmg: "..FS:Round(FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj, 1).." (hit)"
		if FS.data.t9Items >= 2 then str = str.." / "..FS:Round(FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj * critSerpAdj, 1).." (crit)" end
		FS.shots[FS.sn["Serpent Sting"]]["FB"] = str
	end
	FS.shots[FS.sn["Serpent Sting"]]["SPSTICK"] = spsTick
	FS.shots[FS.sn["Serpent Sting"]]["SPSCRITTICK"] = spsCritTick
	FS.shots[FS.sn["Serpent Sting"]]["CSTICK"] = spsRefreshTick
	FS.shots[FS.sn["Serpent Sting"]]["CSCRITTICK"] = spsCritRefreshTick
	if FS.data.t9Items >= 2 then spsDP3 = ((1 - critChance) * spsTick + critChance * spsCritTick) * effResist
	else spsDP3 = spsTick * effResist
	end
	csDP3 = ((1 - FS.data.refreshSpSCrit[tarGUID]) * spsRefreshTick + FS.data.refreshSpSCrit[tarGUID] * spsCritRefreshTick) * effResist
	FS.shots[FS.sn["Serpent Sting"]]["SPSDP3"] = spsDP3
	FS.shots[FS.sn["Serpent Sting"]]["CSDP3"] = csDP3

	-- Black Arrow
	if FS.talents[FS.tn["Black Arrow"]] > 0 then
		baseTick = ((2765 + (rangedAP * 0.1)) * (1 + rangedAP / 225000)) / 5
		constDmgAdj, instantDmgAdj, first = 1, 1, true
		if adj["st"] then constDmgAdj = constDmgAdj + adj["st"]["mod"] - 1 end
		if adj["tnt"] then constDmgAdj = constDmgAdj + adj["tnt"]["mod"] - 1 end
		if adj["tm"] then constDmgAdj = constDmgAdj + adj["tm"]["mod"] - 1 end
		if FS.calcFeedback then
			if adj["st"] then
				first = false
				FS.data.baAdjStr_now[tarGUID] = "st = "..FS:Round(adj["st"]["mod"], 2)
			end
			if adj["tnt"] then
				if first then first = false FS.data.baAdjStr_now[tarGUID] = ""
				else FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID].." / "
				end
				FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID].." / tnt = "..FS:Round((adj["tnt"]["mod"] - 1), 2)
			end
			if adj["tm"] then
				if first then first = false FS.data.baAdjStr_now[tarGUID] = ""
				else FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID].." / "
				end
				FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID].."tm = "..FS:Round(adj["tm"]["mod"], 2)
			end
		end
		adjType = next(adj)
		while(adjType) do
			if (adj[adjType]["affects"]["ba"] or adj[adjType]["affects"]["all"]) and adjType ~= "st" and adjType ~= "tnt" and adjType ~= "tm" then
				if adj[adjType]["refresh"] == "const" then constDmgAdj = constDmgAdj * adj[adjType]["mod"] end
				if adj[adjType]["refresh"] == "instant" then instantDmgAdj = instantDmgAdj * adj[adjType]["mod"] end
				if FS.calcFeedback and (adj[adjType]["refresh"] == "const" or adj[adjType]["refresh"] == "instant") then
					if first then first = false FS.data.baAdjStr_now[tarGUID] = "" else FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID].." / " end
					FS.data.baAdjStr_now[tarGUID] = FS.data.baAdjStr_now[tarGUID]..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
				end
			end
			adjType = next(adj, adjType)
		end
		FS.data.instantBAAdj = instantDmgAdj
		FS.data.constBAAdj_now[tarGUID] = constDmgAdj
		if FS.debuffs[FS.sn["Black Arrow"]] == false then
			FS.data.baseBATick[tarGUID] = baseTick
			FS.data.constBAAdj[tarGUID] = constDmgAdj
			if FS.calcFeedback then FS.data.baAdjStr[tarGUID] = FS.data.baAdjStr_now[tarGUID] end
		end
		if FS.data.constBAAdj[tarGUID] == nil then FS.data.constBAAdj[tarGUID] = FS.data.constBAAdj_now[tarGUID] end
		baTick = baseTick * constDmgAdj * instantDmgAdj
		if FS.calcFeedback then
			if FS.data.baAdjStr[tarGUID] == nil then FS.data.baAdjStr[tarGUID] = FS.data.baAdjStr_now[tarGUID] end
			str = "Calculations:\nBase Tick damage: "..FS:Round(FS.data.baseBATick[tarGUID]).."\nRAP: base = "..baseAP.." / actual = "..rangedAP.."\n"
			str = str.."Adj.: "..FS.data.baAdjStr[tarGUID].." -> "..FS:Round(FS.data.constBAAdj[tarGUID] * FS.data.instantBAAdj, 3).."\n"
			str = str.."Adj. dmg: "..FS:Round(FS.data.baseBATick[tarGUID] * FS.data.instantBAAdj * FS.data.constBAAdj[tarGUID], 1)
			FS.shots[FS.sn["Black Arrow"]]["FB"] = str
		end
		FS.shots[FS.sn["Black Arrow"]]["TICK"] = baTick
		FS.shots[FS.sn["Black Arrow"]]["DP3"] = baTick * effResist
	end

	-- Explosive Shot
	if FS.talents[FS.tn["Explosive Shot"]] > 0 then
		minTick = 386 + (rangedAP * 0.14)
		maxTick = 464 + (rangedAP * 0.14)
		constDmgAdj, instantDmgAdj, first = 1, 1, true
		adjType = next(adj)
		while(adjType) do
			if adj[adjType]["affects"]["es"] or adj[adjType]["affects"]["all"] then
				if adj[adjType]["refresh"] == "const" then constDmgAdj = constDmgAdj * adj[adjType]["mod"] end
				if adj[adjType]["refresh"] == "instant" then instantDmgAdj = instantDmgAdj * adj[adjType]["mod"] end
				if FS.calcFeedback and (adj[adjType]["refresh"] == "const" or adj[adjType]["refresh"] == "instant") then
					if first then first = false FS.data.esAdjStr_now[tarGUID] = "" else FS.data.esAdjStr_now[tarGUID] = FS.data.esAdjStr_now[tarGUID].." / " end
					FS.data.esAdjStr_now[tarGUID] = FS.data.esAdjStr_now[tarGUID]..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
				end
			end
			adjType = next(adj, adjType)
		end
		FS.data.instantESAdj = instantDmgAdj
		FS.data.constESAdj_now[tarGUID] = constDmgAdj
		if FS.debuffs[FS.sn["Explosive Shot"]] == false or FS.debuffs[FS.sn["Explosive Shot"]]["SRC"] ~= "player" then
			FS.data.minESTick[tarGUID] = minTick
			FS.data.maxESTick[tarGUID] = maxTick
			FS.data.constESAdj[tarGUID] = constDmgAdj
			if FS.calcFeedback then FS.data.esAdjStr[tarGUID] = FS.data.esAdjStr_now[tarGUID] end
		end
		if FS.data.constESAdj[tarGUID] == nil then FS.data.constESAdj[tarGUID] = FS.data.constESAdj_now[tarGUID] end
		minESTick = minTick * constDmgAdj * instantDmgAdj
		maxESTick = maxTick * constDmgAdj * instantDmgAdj
		critMinESTick = minESTick * critAdj
		critMaxESTick = maxESTick * critAdj
		esTick = (minESTick + maxESTick) / 2
		critESTick = (critMinESTick + critMaxESTick) / 2
		if FS.calcFeedback then
			if FS.data.esAdjStr[tarGUID] == nil then FS.data.esAdjStr[tarGUID] = FS.data.esAdjStr_now[tarGUID] end
			str = "Calculations:\nBase Tick damage: "..FS:Round(FS.data.minESTick[tarGUID]).." - "..FS:Round(FS.data.maxESTick[tarGUID]).."\nRAP: base = "..baseAP.." / actual = "..rangedAP.."\n"
			str = str.."Adj.: "..FS.data.esAdjStr[tarGUID].." -> "..FS:Round(FS.data.constESAdj[tarGUID] * FS.data.instantESAdj, 3).."\n"
			str = str.."Crit. adj.: crit = "..FS:Round(critAdj, 3).."\n"
			str = str.."Adj. dmg: "..FS:Round(FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj, 1).." - "..FS:Round(FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj, 1).." (hit) / "..FS:Round(FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj, 1).." - "..FS:Round(FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj, 1).." (crit)"
			FS.shots[FS.sn["Explosive Shot"]]["FB"] = str
		end
		FS.shots[FS.sn["Explosive Shot"]]["MINTICK"] = minESTick
		FS.shots[FS.sn["Explosive Shot"]]["MAXTICK"] = maxESTick
		FS.shots[FS.sn["Explosive Shot"]]["CRITMINTICK"] = critMinESTick
		FS.shots[FS.sn["Explosive Shot"]]["CRITMAXTICK"] = critMaxESTick
		baseDMG = esTick * effResist * 3
		critDMG = critESTick * effResist * 3
		FS.shots[FS.sn["Explosive Shot"]]["DMG"] = (1 - esCritChance) * baseDMG + esCritChance * critDMG
	end
	
	-- Chimera Shot
	if FS.talents[FS.tn["Chimera Shot"]] > 0 then
		baseMin = ((FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.minDMG + (rangedTSAAP / 14 * 2.8)) * 1.25
		baseMax = ((FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.minDMG + (rangedTSAAP / 14 * 2.8)) * 1.25
		if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseMin).." - "..FS:Round(baseMax).."\nRAP: base = "..baseAP.." / actual = "..rangedTSAAP.."\nAdj.: " end
		allDmgAdj, first = 1, true
		adjType = next(adj)
		while(adjType) do
			if adj[adjType]["affects"]["cs"] or adj[adjType]["affects"]["all"] then
				allDmgAdj = allDmgAdj * adj[adjType]["mod"]
				if FS.calcFeedback then
					if first then first = false else str = str.." / " end
					str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
				end
			end
			adjType = next(adj, adjType)
		end
		baseMin = baseMin * allDmgAdj
		baseMax = baseMax * allDmgAdj
		critMin = baseMin * critMfDAdj
		critMax = baseMax * critMfDAdj
		if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: critMfD = "..FS:Round(critMfDAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." - "..FS:Round(baseMax, 1).." (hit) / "..FS:Round(critMin, 1).." - "..FS:Round(critMax, 1).." (crit)" FS.shots[FS.sn["Chimera Shot"]]["FB"] = str end
		FS.shots[FS.sn["Chimera Shot"]]["MIN"] = baseMin
		FS.shots[FS.sn["Chimera Shot"]]["MAX"] = baseMax
		FS.shots[FS.sn["Chimera Shot"]]["CRITMIN"] = critMin
		FS.shots[FS.sn["Chimera Shot"]]["CRITMAX"] = critMax
		baseDMG = ((baseMin + baseMax) / 2) * effResist
		critDMG = ((critMin + critMax) / 2) * effResist * psAdj
		baseDMG = (1 - critChance) * baseDMG + critChance * critDMG
		FS.shots[FS.sn["Chimera Shot"]]["DMG"] = baseDMG
		--CS-Serpent
		if FS.debuffs[FS.sn["Serpent Sting"]] then
			if FS.usedGlyphs["Serpent Sting"] then baseDMG = baseCSSPS * adj["spsglyph"]["mod"] * 0.4
			else baseDMG = baseCSSPS * 0.4
			end
			critDMG = baseDMG * critAdj
			FS.shots[FS.sn["Chimera Shot"]]["CSSPS"] = baseDMG
			FS.shots[FS.sn["Chimera Shot"]]["CRITCSSPS"] = critDMG
			baseDMG = ((1 - critChance) * baseDMG + critChance * critDMG) * effResist
			FS.shots[FS.sn["Chimera Shot"]]["DMG"] = FS.shots[FS.sn["Chimera Shot"]]["DMG"] + baseDMG
		end
	end
	
	-- Kill Shot
	baseMin = 650 + (rangedAP * 0.4) + ((FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.minDMG + (rangedAP / 14 * FS.data.weaponSpeed)) * 2
	baseMax = 650 + (rangedAP * 0.4) + ((FS.data.ammoDPS * FS.data.weaponSpeed) + FS.data.maxDMG + (rangedAP / 14 * FS.data.weaponSpeed)) * 2
	if FS.calcFeedback then	str = "Calculations:\nBase damage: "..FS:Round(baseMin).." - "..FS:Round(baseMax).."\nRAP: base = "..baseAP.." / actual = "..rangedTSAAP.."\nAdj.: " end
	allDmgAdj, first = 1, true
	adjType = next(adj)
	while(adjType) do
		if adj[adjType]["affects"]["ks"] or adj[adjType]["affects"]["all"] then 
			allDmgAdj = allDmgAdj * adj[adjType]["mod"]
			if FS.calcFeedback then
				if first then first = false else str = str.." / " end
				str = str..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			end
		end
		adjType = next(adj, adjType)
	end
	baseMin = baseMin * allDmgAdj
	baseMax = baseMax * allDmgAdj
	critMin = baseMin * critAdj
	critMax = baseMax * critAdj
	if FS.calcFeedback then str = str.." -> "..FS:Round(allDmgAdj, 3).."\nCrit. adj.: crit = "..FS:Round(critAdj, 3).."\nAdj. dmg: "..FS:Round(baseMin, 1).." - "..FS:Round(baseMax, 1).." (hit) / "..FS:Round(critMin, 1).." - "..FS:Round(critMax, 1).." (crit)" FS.shots[FS.sn["Kill Shot"]]["FB"] = str end
	FS.shots[FS.sn["Kill Shot"]]["MIN"] = baseMin
	FS.shots[FS.sn["Kill Shot"]]["MAX"] = baseMax
	FS.shots[FS.sn["Kill Shot"]]["CRITMIN"] = critMin
	FS.shots[FS.sn["Kill Shot"]]["CRITMAX"] = critMax
	baseDMG = (baseMin + baseMax) / 2
	critDMG = (critMin + critMax) / 2
	FS.shots[FS.sn["Kill Shot"]]["DMG"] = (1 - ksCritChance) * baseDMG + ksCritChance * critDMG
	
	-- Hunter's Mark
	FS.shots[FS.sn["Hunter's Mark"]]["DPS"] = possibleAP * 0.5 * FS.data.numHunters

	-- DEBUG CODE ------------------------------------------
	if tarGUID == nil then
		FS.data.unitGUID = UnitGUID("target")
		tarGUID = FS.data.unitGUID
		print("DEBUG: GCS FS.data.unitGUID == nil / FS.data.startState == "..FS.data.startState)
	end
	
	if FS.data.constSpSAdj_now[tarGUID] == nil then
		print("DEBUG: GCS FS.data.constSpSAdj_now[tarGUID] == nil. / FS.data.startState == "..FS.data.startState)
	end

	if FS.data.constSpSAdj[tarGUID] == nil then
		print("DEBUG: GCS FS.data.constSpSAdj[tarGUID] == nil. / FS.data.startState == "..FS.data.startState)
	end
	-- DEBUG CODE ------------------------------------------
	
	-- DEBUG
	if FS.statsFrame and FS.statsFrame:IsShown() then
		
		local sfs = "Version: "..FS.version.." - Last update at "..now
	
		sfs = sfs.."\n\nRAP: "..rangedAP
		sfs = sfs.."\nCritchance: "..FS:Round(critChance*100, 2).."%"
		sfs = sfs.."\nDamage Adjustment: "
		adjType = next(adj)
		local i = 0
		while(adjType) do
			i = i + 1
			sfs = sfs..adjType.." = "..FS:Round(adj[adjType]["mod"], 2)
			adjType = next(adj, adjType)
			if i <= 8 and adjType then
				sfs = sfs.." / "
			else
				i = 0
				sfs = sfs.."\n"
			end
		end
		sfs = sfs.."Crit Adjustment: "..FS:Round(critAdj, 2).." ("..FS:Round(critMfDAdj, 2).." MfD / "..FS:Round(critSerpAdj, 2).." SerpS)"
		if FS.data.unitGUID then sfs = sfs.."\nEstimated Mob TTL: "..(FS:Round((tarTTL), 0)).."s" end
		
		-- Steady
		sfs = sfs.."\n\nSteady Shot: "..FS:Round(FS.shots[FS.sn["Steady Shot"]]["MIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Steady Shot"]]["MAX"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Steady Shot"]]["CRITMIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Steady Shot"]]["CRITMAX"], 1).." (crit)"
		if FS.talents[FS.tn["Piercing Shots"]] > 0 then sfs = sfs.." / Piercing Shot Dot: "..FS:Round((FS.shots[FS.sn["Steady Shot"]]["CRITMIN"] * (psAdj - 1)), 1).." - "..FS:Round((FS.shots[FS.sn["Steady Shot"]]["CRITMAX"] * (psAdj - 1)), 1).." ("..FS:Round((FS.shots[FS.sn["Steady Shot"]]["CRITMIN"] * (psAdj - 1) * 0.125), 1).." - "..FS:Round((FS.shots[FS.sn["Steady Shot"]]["CRITMAX"] * (psAdj - 1) * 0.125), 1).." per Tick)" end
		sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Steady Shot"]]["DMG"], 0)
		
		--Multi
		sfs = sfs.."\nMulti-Shot: "..FS:Round(FS.shots[FS.sn["Multi-Shot"]]["MIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Multi-Shot"]]["MAX"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Multi-Shot"]]["CRITMIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Multi-Shot"]]["CRITMAX"], 1).." (crit)"
		sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Multi-Shot"]]["DMG"], 0)

		--Aimed
		if FS.talents[FS.tn["Aimed Shot"]] > 0 then
			sfs = sfs.."\nAimed Shot: "..FS:Round(FS.shots[FS.sn["Aimed Shot"]]["MIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Aimed Shot"]]["MAX"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Aimed Shot"]]["CRITMIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Aimed Shot"]]["CRITMAX"], 1).." (crit)"
			if FS.talents[FS.tn["Piercing Shots"]] > 0 then sfs = sfs.." / Piercing Shot Dot: "..FS:Round((FS.shots[FS.sn["Aimed Shot"]]["CRITMIN"] * (psAdj - 1)), 1).." - "..FS:Round((FS.shots[FS.sn["Aimed Shot"]]["CRITMAX"] * (psAdj - 1)), 1).." ("..FS:Round((FS.shots[FS.sn["Aimed Shot"]]["CRITMIN"] * (psAdj - 1) * 0.125), 1).." - "..FS:Round((FS.shots[FS.sn["Aimed Shot"]]["CRITMAX"] * (psAdj - 1) * 0.125), 1).." per Tick)" end
			sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Aimed Shot"]]["DMG"], 0)
		end
		
		--Acane
		sfs = sfs.."\nArcane Shot: "..FS:Round(FS.shots[FS.sn["Arcane Shot"]]["MIN"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Arcane Shot"]]["CRITMIN"], 1).." (crit)"
		sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Arcane Shot"]]["DMG"], 0)

		--Serpent
		spsTick = FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj
		critTick = spsTick * critSerpAdj
		baseDMG = baseTick * effResist * 5
		critDMG = critTick * effResist * 5
		if adj["spsglyph"] then
			baseDMG = baseDMG * 1.4
			critDMG = critDMG * 1.4
		end
		baseDMG = ((1 - FS.data.refreshSpSCrit[tarGUID]) * baseDMG + FS.data.refreshSpSCrit[tarGUID] * critDMG) * effResist
		sfs = sfs.."\nSerpent Sting: "..FS:Round(baseDMG , 2)
		if FS.data.t9Items >= 2 then
			sfs = sfs.." ("..FS:Round(spsTick, 1).." non-crit / "..FS:Round(critTick, 1).." crit per Tick)"
		else
			sfs = sfs.." ("..FS:Round(spsTick, 1).." per Tick)"
		end
		if FS.data.unitGUID then
			local timeLeft = 0
			local duration = 15	if FS.usedGlyphs["Serpent Sting"] then duration = 21 end 
			-- SpS is already on target mob
			if FS.debuffs[FS.sn["Serpent Sting"]] then
				-- Mob is going to die before SpS runs out
				if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] then
					timeLeft = 0
				-- SpS damage potential equals duration minus the amount the old SpS is still running on the mob
				else
					timeLeft = now + duration - FS.debuffs[FS.sn["Serpent Sting"]]["EXP"]
				end
			-- SpS not on mob yet
			else
				-- Mob is going to die before a new SpS would run out
				if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + duration) then
					timeLeft = tarTTL
				-- Mob is going to life longer than the SpS
				else
					timeLeft = duration
				end
			end
			if timeLeft < 0 then timeLeft = 0 end
			sfs = sfs.." / "..FS:Round((FS.shots[FS.sn["Serpent Sting"]]["SPSDP3"] * floor(timeLeft / 3)), 1).." over "..(floor(timeLeft / 3) * 3).."s"
		end
		
		--Black Arrow		
		if FS.talents[FS.tn["Black Arrow"]] > 0 then
			baTick = FS.data.baseBATick[tarGUID] * FS.data.constBAAdj[tarGUID] * FS.data.instantBAAdj
			baseDMG = baTick * effResist * 5
			sfs = sfs.."\nBlack Arrow: "..FS:Round(baseDMG, 1).." ("..FS:Round(baTick, 1).." per Tick)"
			local timeLeft = 0
			-- BA is already on target mob
			if FS.data.unitGUID then
				if FS.debuffs[FS.sn["Black Arrow"]] then
					-- Mob is going to die before BA runs out
					if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Black Arrow"]]["EXP"] then
						timeLeft = 0
					-- SpS damage potential equals duration minus the amount the old SpS is still running on the mob
					else
						timeLeft = now + 15 - FS.debuffs[FS.sn["Black Arrow"]]["EXP"]
					end
				-- SpS not on mob yet
				else
					-- Mob is going to die before a new SpS would run out
					if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 15) then
						timeLeft = tarTTL
					-- Mob is going to life longer than the SpS
					else
						timeLeft = 15
					end
				end
				if timeLeft < 0 then timeLeft = 0 end
				sfs = sfs.." / "..FS:Round((FS.shots[FS.sn["Black Arrow"]]["DP3"] * floor(timeLeft / 3)), 0).." over "..(floor(timeLeft / 3) * 3).."s"
			end
		end
		
		--Explosive
		if FS.talents[FS.tn["Explosive Shot"]] > 0 then
			sfs = sfs.."\nExplosive Shot: "..FS:Round(FS.shots[FS.sn["Explosive Shot"]]["MINTICK"], 1).." - "..FS:Round(FS.shots[FS.sn["Explosive Shot"]]["MAXTICK"], 1).." (non-crit Tick) / "..FS:Round(FS.shots[FS.sn["Explosive Shot"]]["CRITMINTICK"], 1).." - "..FS:Round(FS.shots[FS.sn["Explosive Shot"]]["CRITMAXTICK"], 1).." (crit Tick)"
			sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Explosive Shot"]]["DMG"], 0)
		end
		
		--Chimera
		if FS.talents[FS.tn["Chimera Shot"]] > 0 then
			sfs = sfs.."\nChimera Shot: "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["MIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["MAX"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["CRITMIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["CRITMAX"], 1).." (crit)"
			if FS.talents[FS.tn["Piercing Shots"]] > 0 then sfs = sfs.." / Piercing Shot Dot: "..FS:Round((FS.shots[FS.sn["Chimera Shot"]]["CRITMIN"] * (psAdj - 1)), 1).." - "..FS:Round((FS.shots[FS.sn["Chimera Shot"]]["CRITMAX"] * (psAdj - 1)), 1).." ("..FS:Round((FS.shots[FS.sn["Chimera Shot"]]["CRITMIN"] * (psAdj - 1) * 0.125), 1).." - "..FS:Round((FS.shots[FS.sn["Chimera Shot"]]["CRITMAX"] * (psAdj - 1) * 0.125), 1).." per Tick)" end
			--CS-Serpent
			if FS.debuffs[FS.sn["Serpent Sting"]] then
				sfs = sfs.."\nCS-Serpent: "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["CSSPS"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["CRITCSSPS"], 1).." (crit)"
			end
			sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Chimera Shot"]]["DMG"], 0)
		end
		
		--Kill Shot
		sfs = sfs.."\nKill Shot: "..FS:Round(FS.shots[FS.sn["Kill Shot"]]["MIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Kill Shot"]]["MAX"], 1).." (norm) / "..FS:Round(FS.shots[FS.sn["Kill Shot"]]["CRITMIN"], 1).." - "..FS:Round(FS.shots[FS.sn["Kill Shot"]]["CRITMAX"], 1).." (crit)"
		sfs = sfs.." / avrg: "..FS:Round(FS.shots[FS.sn["Kill Shot"]]["DMG"], 0)
		
		--Hunter's Mark (assuming 0.5 DPS per AP)
		sfs = sfs.."\nHunter's Mark: "..FS:Round(FS.shots[FS.sn["Hunter's Mark"]]["DPS"], 1).." estimated DPS gain. "
		if FS.data.unitGUID then
			local timeLeft = 0
			-- HM is already on target mob
			if FS.debuffs[FS.sn["Hunter's Mark"]] then
				-- Mob is going to die before HM runs out
				if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"] then
					timeLeft = 0
				-- HM damage potential equals 300s minus the amount the old HM is still running on the mob
				else
					timeLeft = now + 300 - FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"]
				end
			-- HM not on mob yet
			else
				-- Mob is going to die before a new HM would run out
				if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 300) then
					timeLeft = tarTTL
				-- Mob is going to life longer than the HM
				else
					timeLeft = 300
				end
			end
			if timeLeft < 0 then timeLeft = 0 end
			sfs = sfs..FS:Round((timeLeft*FS.shots[FS.sn["Hunter's Mark"]]["DPS"]), 1).." additional damage over "..FS:Round(timeLeft, 0).."s."
		end
		
		-- Output
		FS.statsFrame.text:SetText(sfs)
	end
end

-- Check if any of the spells recently sent to the server didn´t get a response yet
function FS:CheckSpellList()
	now = GetTime()
	FS.data.checkCastAt = 0
	local interrupted = false
	local name = next(FS.data.spellList)
	if not name then return false end
	while(name) do
		if FS.data.latency == nil then FS.data.latency = 0.5 end
		if now >= (FS.data.spellList[name] + FS.data.latency) then
			FS.data.spellList[name] = nil
			interrupted = true
			if FS.shots[name] then FS.shots[name]["CD"] = -1 end
			FS.data.nextSpellTime = now + FS.data.GCD
		elseif FS.data.checkCastAt > (FS.data.spellList[name] + FS.data.latency) then
			FS.data.checkCastAt = (FS.data.spellList[name] + FS.data.latency)
		end
		name = next(FS.data.spellList, name)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CSL)!")
			break
		end
	end
	return interrupted
end

-- Check for all known Buffs on player
function FS:CheckBuffs()
	now = GetTime()
	local checklist = {}
	local index = 1
	local changed = false

	while(true) do
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitBuff("player", index)
		index = index + 1

		-- if name is nil CheckBuffs has finished going through all buffs and breaks the loop
		if name == nil then
			break
		
		-- if FS.buffs[name] == false it´s one of the buffs CheckBuffs is supposed to watch
		elseif FS.buffs[name] == false then
			FS.buffs[name] = {}
			FS.buffs[name]["NEW"] = true
			FS.buffs[name]["EXP"] = expires
			checklist[name] = caster
			changed = true
		
		-- if FS.buffs[name] is true it´s either just been created or still on target
		elseif FS.buffs[name] then
			FS.buffs[name]["NEW"] = false
			FS.buffs[name]["EXP"] = expires
			checklist[name] = caster
		end
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CB1)!")
			break
		end
	end
	
	-- set all buffs not found to false
	index = next(FS.buffs)
	while index do
		if not checklist[index] then 
			if FS.buffs[index] then
				changed = true
			end
			FS.buffs[index] = false
		end
		index = next(FS.buffs, index)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CB2)!")
			break
		end
	end	

	checklist = {}
	index = 1
	
	while(true) do
		name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitDebuff("player", index)
		index = index + 1

		-- if name is nil CheckBuffs has finished going through all buffs and breaks the loop
		if name == nil then
			break
		
		-- if FS.pdebuffs[name] == false it´s one of the buffs CheckBuffs is supposed to watch
		elseif FS.pdebuffs[name] == false then
			FS.pdebuffs[name] = {}
			FS.pdebuffs[name]["EXP"] = expires
			checklist[name] = caster
			changed = true
		
		-- if FS.pdebuffs[name] is true it´s either just been created or still on target
		elseif FS.pdebuffs[name] then
			FS.pdebuffs[name]["EXP"] = expires
			checklist[name] = caster
		end
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CPDB1)!")
			break
		end
	end
	
	-- set all player debuffs not found to false
	index = next(FS.pdebuffs)
	while index do
		if not checklist[index] then 
			if FS.pdebuffs[index] then
				changed = true
			end
			FS.pdebuffs[index] = false
		end
		index = next(FS.pdebuffs, index)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CB2)!")
			break
		end
	end
	return changed
end

-- Check for all known Debuffs on target
function FS:CheckDebuffs()
	now = GetTime()
	local checklist = {}
	local index = 1
	local changed = false

	while(true) do
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitDebuff("target", index)
		index = index + 1
		
		if caster == nil then caster = "notplayer" end

		-- if name is nil CheckDebuffs has finished going through all buffs and breaks the loop
		if name == nil then
			break
		
		-- if variable doesn´t exist it doesn´t have to be watched
		elseif FS.debuffs[name] == nil then
		
		-- if debuff is either Serpent Sting or Black Arrow but doesn´t belong to the player it can be ignored
		elseif caster ~= "player" and (name == FS.sn["Serpent Sting"] or name == FS.sn["Black Arrow"]) then
			
		-- if FS.debuffs[name] == false it´s one of the debuffs CheckDebuffs is supposed to watch
		elseif FS.debuffs[name] == false then
			FS.debuffs[name] = {}
			FS.debuffs[name]["SET"] = now
			FS.debuffs[name]["EXP"] = expires
			FS.debuffs[name]["SRC"] = caster
			FS.debuffs[name]["CNT"] = count
			checklist[name] = caster
			changed = true
		
		-- if FS.debuffs[name] already exists refresh only if the same debuff from the player hasn´t already been updated this call
		elseif (not checklist[name] or checklist[name] ~= "player") then
			FS.debuffs[name]["EXP"] = expires
			FS.debuffs[name]["SRC"] = caster
			FS.debuffs[name]["CNT"] = count
			checklist[name] = caster
		end
		
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CDB1)!")
			break
		end
	end
	
	-- set all buffs not found to false
	index = next(FS.debuffs)
	while index do
		-- if buff hasn´t been found on target
		if not checklist[index] then
			if FS.debuffs[index] then
				if FS.debuffs[index]["SET"] then
					if (FS.debuffs[index]["SET"] + 1) < now then
						changed = true
						FS.debuffs[index] = false
					end
				else
					changed = true
					FS.debuffs[index] = false
				end
			end
		end
		index = next(FS.debuffs, index)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (CDB2)!")
			break
		end
	end

	return changed
end

-- Hide frames and go into idle state or show frames and start scheduler
function FS:ChangeFrameVisibility(show)
	if show then
		FS.data.startState = "reEvaluate"
		FS.data.endState = "reEvaluate"
		if FaceShooterdb.enableShots then FS.nextShot:Show() end
		if FaceShooterdb.enableShots and FaceShooterdb.displayMethod == "rotating" then FS.lastShot:Show() end
		if FaceShooterdb.enableTTL then FS.ttlFrame:Show() end
		if FaceShooterdb.enableAspects then FS.aspectsFrame:Show() end
		if FaceShooterdb.enableSniper and FS.talents[FS.tn["Sniper Training"]] > 0 then FS.sniperFrame:Show() end
		if FaceShooterdb.enableChimera and FS.talents[FS.tn["Chimera Shot"]] > 0 then FS.chimeraFrame:Show() end
		if FS.calcFeedback then FS.baseFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") end
		FS.baseFrame:RegisterEvent("UNIT_AURA")
		FS.baseFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
		FS.baseFrame:RegisterEvent("UNIT_SPELLCAST_START")
		FS.baseFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		FS.baseFrame:RegisterEvent("COMBAT_RATING_UPDATE")
		FS.baseFrame:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		FS:Scheduler()
	else
		FS.data.startState = "idle"
		FS.data.endState = "idle"
		if FaceShooterdb.enableShots then FS.nextShot:Hide() end
		if FaceShooterdb.enableShots and FaceShooterdb.displayMethod == "rotating" then FS.lastShot:Hide() end
		if FaceShooterdb.enableTTL then FS.ttlFrame:Hide() end
		if FaceShooterdb.enableAspects then FS.aspectsFrame:Hide() end
		if FaceShooterdb.enableSniper then FS.sniperFrame:Hide() end
		if FaceShooterdb.enableChimera then FS.chimeraFrame:Hide() end
		if FS.calcFeedback then FS.baseFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED") end
		FS.baseFrame:UnregisterEvent("UNIT_AURA")
		FS.baseFrame:UnregisterEvent("UNIT_SPELLCAST_SENT")
		FS.baseFrame:UnregisterEvent("UNIT_SPELLCAST_SENT")
		FS.baseFrame:UnregisterEvent("UNIT_SPELLCAST_START")
		FS.baseFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		FS.baseFrame:UnregisterEvent("COMBAT_RATING_UPDATE")
		FS.baseFrame:UnregisterEvent("SPELL_UPDATE_COOLDOWN")
	end
end

-- Calculates the average deviation of the last 10 Shots
function FS:CalcDeviation(spellName, crithit, damage, amount, blocked, resisted)
	now = GetTime()
	tarGUID = FS.data.unitGUID
	local lastValue
	local lastIndex
	local deviation
	local baseSpSTick, critSpSTick
	local baseBATick
	local minESTick, maxESTick
	local critMinESTick, critMaxESTick

	-- calculate the percentual deviation from the expected average
	local minhit, maxhit, tick, mintick, maxtick = "MIN", "MAX", "TICK", "MINTICK", "MAXTICK"
	if crithit == "crit" then
		minhit, maxhit, tick, mintick, maxtick = "CRITMIN", "CRITMAX", "CRITTICK", "CRITMINTICK", "CRITMAXTICK"
	end
	
	if spellName == FS.sn["Serpent Sting"] and crithit == "hit" then
		spsTick = FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj
		deviation = damage / spsTick
	elseif spellName == FS.sn["Serpent Sting"] and crithit == "crit" then
		critSpSTick = FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj * critSerpAdj
		deviation = damage / critSpSTick
	elseif spellName == FS.sn["Black Arrow"] then
		baTick = FS.data.baseBATick[tarGUID] * FS.data.constBAAdj[tarGUID] * FS.data.instantBAAdj
		deviation = damage / baTick
	elseif spellName == FS.sn["Explosive Shot"] and crithit == "hit" then
		minESTick = FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj
		maxESTick = FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj
		deviation = damage / ((minESTick + maxESTick) / 2)
	elseif spellName == FS.sn["Explosive Shot"] and crithit == "crit" then
		critMinESTick = FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj
		critMaxESTick = FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj
		deviation = damage / ((critMinESTick + critMaxESTick) / 2)
	elseif spellName == FS.sn["Arcane Shot"] then
		deviation = damage / FS.shots[spellName][minhit]
	else
		deviation = damage / ((FS.shots[spellName][minhit] + FS.shots[spellName][maxhit]) / 2)
	end
	
	-- set all tables to nil that haven´t been updated for more than 35s
	local GUID = next(FS.data.tarDeviation)
	while GUID do
		lastTValue = FS.data.tarDeviation[GUID]["time"]
		if (now - lastTValue) > 35 then FS.data.tarDeviation[GUID] = nil end
		GUID = next(FS.data.tarDeviation, GUID)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (DEV1)!")
			break
		end
	end

	-- create an average deviation table for current target and...
	if not FS.data.tarDeviation[tarGUID] then
		FS.data.tarDeviation[tarGUID] = {}
	end
	-- ...spell if required
	if not FS.data.tarDeviation[tarGUID][spellName] then
		FS.data.tarDeviation[tarGUID][spellName] = { ["time"] = now }
	end

	-- fill the table
	FS.data.tarDeviation[tarGUID]["time"] = now
	table.insert(FS.data.tarDeviation[tarGUID][spellName], 1, deviation)
	
	-- delete the last value if there're more than 3 values stored in the table
	local lastIndex = table.maxn(FS.data.tarDeviation[tarGUID][spellName])
	local count = lastIndex
	if spellName == FS.sn["Serpent Sting"] or spellName == FS.sn["Black Arrow"] then count = count / 5
	elseif spellName == FS.sn["Explosive Shot"] then count = count / 3
	end
	if count > 5 then
		table.remove(FS.data.tarDeviation[tarGUID][spellName])
		lastIndex = lastIndex - 1
		count = 5
	end
	
	-- calculate the average deviation
	local sumDeviation = 0
	local index = next(FS.data.tarDeviation[tarGUID][spellName])
	while index do
		if index ~= "time" then sumDeviation = sumDeviation + FS.data.tarDeviation[tarGUID][spellName][index] end
		index = next(FS.data.tarDeviation[tarGUID][spellName], index)
	end
	FS.shots[spellName]["DEVIATION"] = sumDeviation / lastIndex

	if FS.calcFeedback then
		-- Save all Buffs on player and target and save them to a string
		local index = 1
		local buffStr, debuffStr = "", ""
		local first = true
		while(true) do
			local name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitBuff("player", index)
			index = index + 1
			if name == nil then break end
			if first then first = false else buffStr = buffStr.." / " end
			buffStr = buffStr..name
		end
		if buffStr ~= "" then buffStr = "\nBuffs: "..buffStr else buffStr = "\nBuffs: -" end
		index = 1
		local first = true
		while(true) do
			local name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitDebuff("target", index)
			index = index + 1
			if name == nil then break end
			if first then first = false else debuffStr = debuffStr.." / " end
			debuffStr = debuffStr..name
		end
		if debuffStr ~= "" then debuffStr = "\nDebuffs: "..debuffStr else debuffStr = "\nDebuffs: -" end

		-- Display the feedback if a given amount of deviations have been recorded
		if (count % 1) ~= 0 then count = 0 end
		if count > 4 then
			local str = "FS: ------ "..spellName.." deviated at least "..count.." times in a row! ------\nActual recorded damage: "..amount.." ("..crithit..")"
			if blocked then str = str.." ("..blocked.." blocked) " end
			if resisted then str = str.." ("..resisted.." resisted) " end
			print(str.."\n"..FS.shots[spellName]["FB"].."\nDeviation: "..FS:Round(deviation, 2).." / Avrg deviation: "..FS:Round(FS.shots[spellName]["DEVIATION"], 2)..buffStr..debuffStr)
		end
	end
end

-- Function to estimate the time to life for current target
function FS:EstimateTTL()
	FS.TSLU.estimateTTL = 0

	tarGUID = FS.data.unitGUID
	local curhp = UnitHealth("target")
	now = GetTime()
	local lastTValue = nil
	local lastHValue = nil
	local lastIndex = nil
	
	-- set all tables to nil that haven´t been updated for more than 35s
	local GUID = next(FS.data.tarTTL)
	while GUID do
		lastIndex = table.maxn(FS.data.tarTTL[GUID]["time"])
		lastTValue = FS.data.tarTTL[GUID]["time"][lastIndex]
		if (now - lastTValue) > 35 then FS.data.tarTTL[GUID] = nil end
		GUID = next(FS.data.tarTTL, GUID)
		if (GetTime() - now) > 0.1 then
			print("DEBUG: breaking loop to prevent a deadlock (TTL)!")
			break
		end
	end

	-- create an time and health table 
	if not FS.data.tarTTL[tarGUID] then
		FS.data.tarTTL[tarGUID] = { ["time"] = {}, ["health"] = {} }
	end
	
	-- fill the tables
	lastIndex = table.maxn(FS.data.tarTTL[tarGUID]["time"])
	if lastIndex then
		lastHValue = FS.data.tarTTL[tarGUID]["health"][lastIndex]
		if lastHValue == curhp then
			table.remove(FS.data.tarTTL[tarGUID]["time"])
			table.remove(FS.data.tarTTL[tarGUID]["health"])
		end
		table.insert(FS.data.tarTTL[tarGUID]["time"], 1, now)
		table.insert(FS.data.tarTTL[tarGUID]["health"], 1, curhp)
	end
	
	-- delete the last value if it´s older than 20s
	lastIndex = table.maxn(FS.data.tarTTL[tarGUID]["time"])
	lastTValue = FS.data.tarTTL[tarGUID]["time"][lastIndex]
	if now - lastTValue > 20 then
		table.remove(FS.data.tarTTL[tarGUID]["time"])
		table.remove(FS.data.tarTTL[tarGUID]["health"])
	end
	
	-- calculate the time and health delta between now and the oldest values
	lastIndex = table.maxn(FS.data.tarTTL[tarGUID]["time"])
	lastTValue = FS.data.tarTTL[tarGUID]["time"][lastIndex]
	lastHValue = FS.data.tarTTL[tarGUID]["health"][lastIndex]
	local deltaT = now - lastTValue
	local deltaH = lastHValue - curhp
	
	-- if we have at least 3s time delta we calculate the dps
	if deltaT >= 5 then
		FS.data.tarTTL[tarGUID]["DPS"] = deltaH / deltaT
	
	-- otherwise we try to ballmark estimate raid dps as 2/3 of the raiders doing 6000 dps
	else
		FS.data.tarTTL[tarGUID]["DPS"] = FS:Round(FS.data.numPlayers * (2 / 3)) * 6000
	end
	
	-- for dps > 0 the actual TTL is the targets health divided by the current dps on it
	if FS.data.tarTTL[tarGUID]["DPS"] > 0 then
		FS.data.tarTTL[tarGUID]["TTL"] = now + (curhp / FS.data.tarTTL[tarGUID]["DPS"])
	
	-- if dps == 0 the TTL is set to 1h
	else
		FS.data.tarTTL[tarGUID]["TTL"] = now + 3600
	end
	
	local dps = "-"
	local ttl = "-"
	if FaceShooterdb.practiseMode then
		local find = false
		find = string.find(GetUnitName("target"), "Dummy")
		if find then FS.data.tarTTL[tarGUID]["TTL"] = now + 3600 end
	end
	if FaceShooterdb.enableTTL then
		if FS.data.tarTTL[tarGUID]["TTL"] < (now + 3600) and deltaT >= 5 then ttl = FS:Round((FS.data.tarTTL[tarGUID]["TTL"] - now), 0).."s" end
		if FS.data.tarTTL[tarGUID]["DPS"] > 0 and deltaT >= 5 then dps = FS:Round(FS.data.tarTTL[tarGUID]["DPS"], 0) end
		if dps ~= "-" and dps >= 10000 then dps = (FS:Round((dps/100), 0)/10).."k" end
		FS.ttlFrame.text:SetText("DPS: "..dps.." TTL: "..ttl)
	end
end

-- Function to estimate your average mana consumption
function FS:EstimateMPS()
	FS.TSLU.estimateMPS = 0

	now = GetTime()
	local curmp = UnitMana("player")
	local lastTValue = nil
	local lastHValue = nil
	local lastIndex = nil
	
	-- create an time and health table 
	if not FS.data.mps then
		FS.data.mps = { ["time"] = {}, ["mana"] = {}, ["MPS"] = 0 }
	end
	
	-- fill the tables
	lastIndex = table.maxn(FS.data.mps["time"])
	if lastIndex > 0 then
		lastMValue = FS.data.mps["mana"][lastIndex]
		if lastMValue == curmp then
			table.remove(FS.data.mps["time"])
			table.remove(FS.data.mps["mana"])
		elseif FS.data.mps["mana"][1] < curmp then
			FS.data.mps["time"] = {}
			FS.data.mps["mana"] = {}
		end
	end
	table.insert(FS.data.mps["time"], 1, now)
	table.insert(FS.data.mps["mana"], 1, curmp)

	-- delete the last value if it´s older than 30s
	lastIndex = table.maxn(FS.data.mps["time"])
	lastTValue = FS.data.mps["time"][lastIndex]
	if now - lastTValue > 30 then
		table.remove(FS.data.mps["time"])
		table.remove(FS.data.mps["mana"])
	end
	
	-- calculate the time and health delta between now and the oldest values
	lastIndex = table.maxn(FS.data.mps["time"])
	lastTValue = FS.data.mps["time"][lastIndex]
	lastMValue = FS.data.mps["mana"][lastIndex]
	local deltaT = now - lastTValue
	local deltaM = lastMValue - curmp
	
	-- if we have at least 10s time delta we calculate the dps
	if deltaT >= 10 then
		FS.data.mps["MPS"] = deltaM / deltaT
	end
end

-- Check if sniper training is up and how long it's still running
function FS:SniperCheck()
	FS.TSLU.sniperFrame = 0

	now = GetTime()
	local name, _, icon, _, _, _, expirationTime, _, _ = UnitAura("player", FS.sn["Sniper Training"])
	
	if name == nil then
		FS.textureList["sniperFrame"]:SetTexture(nil)
	elseif ((expirationTime-now) < 7) then
		FS.textureList["sniperFrame"]:SetTexture("Interface\\Icons\\Ability_Hunter_LongShots")
		FS.textureList["sniperFrame"]:SetVertexColor(1, 0.15, 0.15)
	elseif ((expirationTime-now) > 14) then
		FS.textureList["sniperFrame"]:SetTexture("Interface\\Icons\\Ability_Hunter_LongShots")
		FS.textureList["sniperFrame"]:SetVertexColor(0.15, 1, 0.15)
	else
		FS.textureList["sniperFrame"]:SetTexture("Interface\\Icons\\Ability_Hunter_LongShots")
		FS.textureList["sniperFrame"]:SetVertexColor(1, 1, 1)
	end
end

-- check which damage buffs are running and if current adjustments would be an improvement
function FS:ChimeraCheck()
	FS.TSLU.chimeraFrame = 0
	tarGUID = FS.data.unitGUID
	
	-- DEBUG CODE ------------------------------------------
	if tarGUID == nil then
		FS.data.unitGUID = UnitGUID("target")
		tarGUID = FS.data.unitGUID
		print("DEBUG: FS.data.unitGUID == nil / FS.data.startState == "..FS.data.startState)
	end
	
	if FS.data.constSpSAdj_now[tarGUID] == nil then
		print("DEBUG: FS.data.constSpSAdj_now[tarGUID] == nil. / FS.data.startState == "..FS.data.startState)
	end

	if FS.data.constSpSAdj[tarGUID] == nil then
		print("DEBUG: FS.data.constSpSAdj[tarGUID] == nil. / FS.data.startState == "..FS.data.startState)
	end
	-- DEBUG CODE ------------------------------------------

	-- if current sps multiplier is greater than the old multiplier show the chimera frame
	if FS.data.constSpSAdj_now[tarGUID] > FS.data.constSpSAdj[tarGUID] then
	
		-- Estimate dps gain by reapplying sps with current multiplier
		if FS.data.tarTTL[tarGUID]["DPS"] > 0 then
			now = GetTime()
			tarTTL = FS.data.tarTTL[tarGUID]["TTL"] - now
			d, G, s, m, t = 0, 0, 0, 0, 0
			if FS.data.t9Items >= 2 then s = (((1 - critChance) * FS.shots[FS.sn["Serpent Sting"]]["CSTICK"] + critChance * FS.shots[FS.sn["Serpent Sting"]]["CSCRITTICK"]) * effResist) / 3
			else s = (FS.shots[FS.sn["Serpent Sting"]]["CSTICK"] * effResist) / 3
			end
			d = FS.data.tarTTL[tarGUID]["DPS"] / FS:Round(FS.data.numPlayers * (2 / 3))
			s = s / d
			G = FS.shots[FS.sn["Steady Shot"]]["DMG"]
			m = FS.data.constSpSAdj_now[tarGUID] / FS.data.constSpSAdj[tarGUID]
			t = G / ((s * d * m + (1 - s) * d) - d)
			if t < tarTTL then FS.data.suggestSpS = true else FS.data.suggestSpS = false end
		end
		FS.textureList["chimeraFrame"]:SetTexture("Interface\\Icons\\Ability_hunter_quickshot")
		if FS.data.suggestSpS then FS.chimeraFrame.text:SetTextColor(0.15, 1, 0.15, 1) else FS.chimeraFrame.text:SetTextColor(1, 0.15, 0.15, 1) end
		FS.chimeraFrame.text:SetText("+"..FS:Round(((FS.data.constSpSAdj_now[tarGUID] / FS.data.constSpSAdj[tarGUID] - 1) * 100)).."%")
		
	-- else hide it
	else
		FS.textureList["chimeraFrame"]:SetTexture(nil)
		FS.chimeraFrame.text:SetText(nil)
	end
end

-- Check for aspect thresholds
function FS:AspectsCheck()
	FS.TSLU.aspectsFrame = 0
	now = GetTime()
	local mana = (UnitPower("player") / UnitPowerMax("player")) * 100
	local playerTTOOM = nil
	tarTTL = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - now

	if FS.data.mps and FS.data.mps["MPS"] and FS.data.mps["MPS"] > 0 then playerTTOOM = UnitMana("player") / FS.data.mps["MPS"] end
	
	-- if players mana is above the set threashold and AotV is still active -> AotDH
	if mana >= FaceShooterdb.maxThresholdAspects and FS.buffs[FS.sn["Aspect of the Viper"]] then
		FS.textureList["aspectsFrame"]:SetTexture(GetSpellTexture(FS.sn["Aspect of the Dragonhawk"]))
	
	-- if players TTOOM has been calculated and it is longer than targets TTL and AotV is active -> AotDH
	elseif playerTTOOM and (playerTTOOM + 5) >= tarTTL and FS.buffs[FS.sn["Aspect of the Viper"]] then
		FS.textureList["aspectsFrame"]:SetTexture(GetSpellTexture(FS.sn["Aspect of the Dragonhawk"]))
		
	-- if players TTOOM has been calculated and it is shorter than targets TTL and players mana is below the set threshold -> AotV
	elseif playerTTOOM and (playerTTOOM - 5) < tarTTL and mana <= FaceShooterdb.minThresholdAspects and not FS.buffs[FS.sn["Aspect of the Viper"]] then
		FS.textureList["aspectsFrame"]:SetTexture(GetSpellTexture(FS.sn["Aspect of the Viper"]))
		
	-- if players TTOOM has not yet been calculated and players mana is below the set threshold -> AotV
	elseif not playerTTOOM and mana <= FaceShooterdb.minThresholdAspects and not FS.buffs[FS.sn["Aspect of the Viper"]] then
		FS.textureList["aspectsFrame"]:SetTexture(GetSpellTexture(FS.sn["Aspect of the Viper"]))
		
	-- if none of the above conditions are met -> empty frame
	else
		FS.textureList["aspectsFrame"]:SetTexture(nil)
	end
end

-- Evaluates the next spell to cast
function FS:SpellFind()
	FS.TSLU.spellFind = 0
	now = GetTime()
	tarTTL = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - now
	local nameList = {}
	local dmgList = {}
	local tarIsStinged = false
	local noESallowed = false
	local stingTTL = 0
	local i = 1

	-- check if there´s a sting running on target
	if FS.debuffs[FS.sn["Serpent Sting"]] then
		tarIsStinged = true
		stingTTL = FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] - now
	elseif FS.debuffs[FS.sn["Viper Sting"]] and FS.debuffs[FS.sn["Viper Sting"]]["SRC"] == "player" then
		tarIsStinged = true
		stingTTL = FS.debuffs[FS.sn["Viper Sting"]]["EXP"] - now
	elseif FS.debuffs[FS.sn["Scorpid Sting"]] and FS.debuffs[FS.sn["Scorpid Sting"]]["SRC"] == "player" then
		tarIsStinged = true
		stingTTL = FS.debuffs[FS.sn["Scorpid Sting"]]["EXP"] - now
	elseif FS.debuffs[FS.sn["Wyvern Sting"]] and FS.debuffs[FS.sn["Wyvern Sting"]]["SRC"] == "player" then
		tarIsStinged = true
		stingTTL = FS.debuffs[FS.sn["Wyvern Sting"]]["EXP"] - now
	end
	
	-- if player OOC and no Hunter's Mark on target => cast Hunter's Mark
	if FS.data.OOC and (not FS.debuffs[FS.sn["Hunter's Mark"]] or FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"] < (now + 10)) then
		FS.data.nextSpellName = FS.sn["Hunter's Mark"]
		
	-- if player is MM specced, there´s no sting on target and TTL is sufficiant to cast at least Serpent Sting and Chimera Shot suggest serpent
	elseif FS.talents[FS.tn["Chimera Shot"]] > 0 and not tarIsStinged and tarTTL >= 3 and (tarTTL + now) > FS.shots[FS.sn["Chimera Shot"]]["CD"] then
		FS.data.nextSpellName = FS.sn["Serpent Sting"]
	
	-- else create a priority list based on availability and damage of the shots
	else
		-- Kill Shot
		if FS.data["tarHealthPercent"] <= 0.2 and FS.shots[FS.sn["Kill Shot"]]["CD"] <= (now + FS.data["GCD"] + (FaceShooterdb.maxWaitDelay / 10)) then
			nameList[i] = FS.sn["Kill Shot"]
			dmgList[i] = FS.shots[FS.sn["Kill Shot"]]["DMG"]
			i = i + 1
		end
		-- Explosive Shot
		if FS.talents[FS.tn["Explosive Shot"]] > 0 and FS.shots[FS.sn["Explosive Shot"]]["CD"] <= (now + FS.data["GCD"] + (FaceShooterdb.maxWaitDelay / 10)) then
			nameList[i] = FS.sn["Explosive Shot"]
			dmgList[i] = FS.shots[FS.sn["Explosive Shot"]]["DMG"]
			i = i + 1
		end
		-- Chimera Shot
		if FS.talents[FS.tn["Chimera Shot"]] > 0 and (FS.shots[FS.sn["Chimera Shot"]]["CD"] <= (now + FS.data["GCD"] + (FaceShooterdb.maxWaitDelay / 10)) and (tarIsStinged or tarTTL <= 3)) then
			nameList[i] = FS.sn["Chimera Shot"]
			dmgList[i] = FS.shots[FS.sn["Chimera Shot"]]["DMG"]
			i = i + 1
		end
		-- Black Arrow
		if FS.talents[FS.tn["Black Arrow"]] > 0 and FS.shots[FS.sn["Black Arrow"]]["CD"] <= (now + FS.data["GCD"]) then
			nameList[i] = FS.sn["Black Arrow"]
			dmgList[i] = FS.shots[FS.sn["Black Arrow"]]["DMG"]
			i = i + 1
		end
		-- Serpent Sting
		if not tarIsStinged or (stingTTL <= 3 and FS.talents[FS.tn["Chimera Shot"]] == 0) then
			nameList[i] = FS.sn["Serpent Sting"]
			dmgList[i] = FS.shots[FS.sn["Serpent Sting"]]["DMG"]
			i = i + 1
		end
		-- Aimed Shot
		if FS.talents[FS.tn["Aimed Shot"]] > 0 and FS.shots[FS.sn["Aimed Shot"]]["CD"] <= (now + FS.data["GCD"]) and (not FS.buffs[FS.sn["Improved Steady Shot"]] or not (FS.talents[FS.tn["Chimera Shot"]] > 0) or FS.shots[FS.sn["Chimera Shot"]]["CD"] >= FS.buffs[FS.sn["Improved Steady Shot"]]["EXP"] or not FaceShooterdb.saveISS) then
			nameList[i] = FS.sn["Aimed Shot"]
			dmgList[i] = FS.shots[FS.sn["Aimed Shot"]]["DMG"]
			i = i + 1
		end
		-- Multi-Shot
		if FS.shots[FS.sn["Multi-Shot"]]["CD"] <= (now + FS.data["GCD"]) then
			nameList[i] = FS.sn["Multi-Shot"]
			dmgList[i] = FS.shots[FS.sn["Multi-Shot"]]["DMG"]
			i = i + 1
		end
		-- Arcane Shot
		if not FaceShooterdb.ignoreArcaneShot and FS.shots[FS.sn["Arcane Shot"]]["CD"] <= (now + FS.data["GCD"]) and (not FS.buffs[FS.sn["Improved Steady Shot"]] or not (FS.talents[FS.tn["Chimera Shot"]] > 0) or FS.shots[FS.sn["Chimera Shot"]]["CD"] >= FS.buffs[FS.sn["Improved Steady Shot"]]["EXP"] or not FaceShooterdb.saveISS) then
			nameList[i] = FS.sn["Arcane Shot"]
			dmgList[i] = FS.shots[FS.sn["Arcane Shot"]]["DMG"]
			i = i + 1
		end
		-- Hunter's Mark
		if not FaceShooterdb.ignoreHuntersMark and (FaceShooterdb.minHMTTL <= tarTTL) and (not FS.debuffs[FS.sn["Hunter's Mark"]] or FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"] <= (now + 5)) then
			nameList[i] = FS.sn["Hunter's Mark"]
			dmgList[i] = FS.shots[FS.sn["Hunter's Mark"]]["DMG"]
			i = i + 1
		end
		-- Steady Shot
		nameList[i] = FS.sn["Steady Shot"]
		dmgList[i] = FS.shots[FS.sn["Steady Shot"]]["DMG"]
		
		local changed = true
		while(changed) do
			changed = false
			local n = i - 1
			for i = 1, n do
				if dmgList[i] < dmgList[i+1] then
					dmgList[i], dmgList[i+1] = dmgList[i+1], dmgList[i]
					nameList[i], nameList[i+1] = nameList[i+1], nameList[i]
					changed = true
				end
			end
			n = n - 1
			if (GetTime() - now) > 0.1 then
				print("DEBUG: breaking loop to prevent a deadlock (SF)!")
				break
			end
		end
		
		-- Prevent Explosive shot from overwriting the DoT
		if FS.data.startState ~= "fail" and nameList[1] == FS.sn["Explosive Shot"] and FS.shots[FS.sn["Explosive Shot"]]["SET"] and (FS.shots[FS.sn["Explosive Shot"]]["SET"] + 2) > (now + FS.data["GCD"]) and FS.data.noESUnit == FS.data.GUID then
			if FaceShooterdb.weaveLnL then
				if nameList[2] ~= FS.sn["Arcane Shot"] then FS.data.nextSpellName = nameList[2]
				else FS.data.nextSpellName = nameList[3]
				end
			else FS.data.nextSpellName = nil
		end
		
		-- Otherwise pick the spell with the highest damage
		else
			FS.data.nextSpellName = nameList[1]
		end
	end
end

-- Calculates the current GCD
function FS:GetGCD(now)
	local start, duration, _ = GetSpellCooldown(FS.sn["Steady Shot"]);
	FS.data["GCD"] = duration + start - now
	if FS.data["GCD"] <= 0 then FS.data["GCD"] = 0 end
	return FS.data["GCD"]
end

-- Collects various data relevant for the decision which shot to show next
function FS:CollectData()
	FS.TSLU.dataCollect = 0

	now = GetTime()
	local TSLS = now - FS.data.lastSpellTime
	
	-- Basics
	FS.data["myManaPercent"] = UnitPower("player")/UnitPowerMax("player")
	FS.data["tarHealthPercent"] = UnitHealth("target")/UnitHealthMax("target")
	
	if FS.data.endState == "busy" then
		FS:GetGCD(now)
	end
	
	-- Serpent Sting
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Serpent Sting"] then
		FS.debuffs[FS.sn["Serpent Sting"]] = {}
		FS.debuffs[FS.sn["Serpent Sting"]]["SET"] = now
		if FS.usedGlyphs["Serpent Sting"] then FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] = now + 21 else FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] = now + 15 end
		FS.debuffs[FS.sn["Serpent Sting"]]["SRC"] = "player"
	end
	
	-- Viper Sting
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Viper Sting"] then
		FS.debuffs[FS.sn["Viper Sting"]] = {}
		FS.debuffs[FS.sn["Viper Sting"]]["SET"] = now
		FS.debuffs[FS.sn["Viper Sting"]]["EXP"] = now + 15
		FS.debuffs[FS.sn["Viper Sting"]]["SRC"] = "player"
	end
	
	-- Scorpid Sting
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Scorpid Sting"] then
		FS.debuffs[FS.sn["Scorpid Sting"]] = {}
		FS.debuffs[FS.sn["Scorpid Sting"]]["SET"] = now
		FS.debuffs[FS.sn["Scorpid Sting"]]["EXP"] = now + 20
		FS.debuffs[FS.sn["Scorpid Sting"]]["SRC"] = "player"
	end
	
	-- Hunter's Mark
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Hunter's Mark"] then
		FS.debuffs[FS.sn["Hunter's Mark"]] = {}
		FS.debuffs[FS.sn["Hunter's Mark"]]["SET"] = now
		FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"] = now + 300
		FS.debuffs[FS.sn["Hunter's Mark"]]["SRC"] = "player"
	end

	-- Chimera Shot
	if FS.talents[FS.tn["Chimera Shot"]] > 0 then
		if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Chimera Shot"] then
			if FS.usedGlyphs["Chimera Shot"] then FS.shots[FS.sn["Chimera Shot"]]["CD"] = now + 9 else FS.shots[FS.sn["Chimera Shot"]]["CD"] = now + 10 end
			FS.shots[FS.sn["Chimera Shot"]]["SET"] = now
			if FS.debuffs[FS.sn["Serpent Sting"]] then
				FS.debuffs[FS.sn["Serpent Sting"]] = {}
				FS.debuffs[FS.sn["Serpent Sting"]]["SET"] = now
				if FS.usedGlyphs["Serpent Sting"] then FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] = now + 21 else FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] = now + 15 end
				FS.debuffs[FS.sn["Serpent Sting"]]["SRC"] = "player"
			end
			if FS.debuffs[FS.sn["Viper Sting"]] and FS.debuffs[FS.sn["Viper Sting"]]["SRC"] == "player" then
				FS.debuffs[FS.sn["Viper Sting"]] = {}
				FS.debuffs[FS.sn["Viper Sting"]]["SET"] = now
				FS.debuffs[FS.sn["Viper Sting"]]["EXP"] = now + 15
				FS.debuffs[FS.sn["Viper Sting"]]["SRC"] = "player"
			end
			if FS.debuffs[FS.sn["Scorpid Sting"]] and FS.debuffs[FS.sn["Scorpid Sting"]]["SRC"] == "player" then
				FS.debuffs[FS.sn["Scorpid Sting"]] = {}
				FS.debuffs[FS.sn["Scorpid Sting"]]["SET"] = now
				FS.debuffs[FS.sn["Scorpid Sting"]]["EXP"] = now + 20
				FS.debuffs[FS.sn["Scorpid Sting"]]["SRC"] = "player"
			end
		else
			local start, duration, _ = GetSpellCooldown(FS.sn["Chimera Shot"])
			if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Chimera Shot"]]["CD"] = start + duration end 
		end
	end
	
	-- Black Arrow
	if FS.talents[FS.tn["Black Arrow"]] > 0 then
		if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Black Arrow"] then
			FS.shots[FS.sn["Black Arrow"]]["CD"] = now + 30 - FS.talents[FS.tn["Resourcefulness"]] * 2
			FS.shots[FS.sn["Black Arrow"]]["SET"] = now
		else
			local start, duration, _ = GetSpellCooldown(FS.sn["Black Arrow"])
			if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Black Arrow"]]["CD"] = start + duration end 
		end
	end
	
	-- Aimed Shot
	if FS.talents[FS.tn["Aimed Shot"]] > 0 then
		if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Aimed Shot"] then
			if FS.usedGlyphs["Aimed Shot"] then FS.shots[FS.sn["Aimed Shot"]]["CD"] = now + 8 else FS.shots[FS.sn["Aimed Shot"]]["CD"] = now + 10 end
			FS.shots[FS.sn["Aimed Shot"]]["SET"] = now
		else
			local start, duration, _ = GetSpellCooldown(FS.sn["Aimed Shot"])
			if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Aimed Shot"]]["CD"] = start + duration end 
		end
	end
	
	-- Multi Shot
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Multi-Shot"] then
		if FS.usedGlyphs["Multi-Shot"] then FS.shots[FS.sn["Multi-Shot"]]["CD"] = now + 9 else FS.shots[FS.sn["Multi-Shot"]]["CD"] = now + 10 end
		FS.shots[FS.sn["Multi-Shot"]]["SET"] = now
	else
		local start, duration, _ = GetSpellCooldown(FS.sn["Multi-Shot"])
		if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Multi-Shot"]]["CD"] = start + duration end 
	end
	
	-- Aimed Shot and Multi-Shot share the same CD
	if FS.talents[FS.tn["Aimed Shot"]] > 0 then
		if FS.data.startState == "fail" and (FS.shots[FS.sn["Aimed Shot"]]["CD"] == -1 or FS.shots[FS.sn["Multi-Shot"]]["CD"] == -1) then
			FS.shots[FS.sn["Aimed Shot"]]["CD"], FS.shots[FS.sn["Multi-Shot"]]["CD"] = -1, -1
		elseif FS.shots[FS.sn["Aimed Shot"]]["CD"] > FS.shots[FS.sn["Multi-Shot"]]["CD"] then
			FS.shots[FS.sn["Multi-Shot"]]["CD"] = FS.shots[FS.sn["Aimed Shot"]]["CD"]
		else
			FS.shots[FS.sn["Aimed Shot"]]["CD"] = FS.shots[FS.sn["Multi-Shot"]]["CD"]
		end
	end
	
	-- Explosive Shot
	if FS.talents[FS.tn["Explosive Shot"]] > 0 then
		if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Explosive Shot"] then
			if FS.buffs[FS.sn["Lock and Load"]] then FS.shots[FS.sn["Explosive Shot"]]["CD"] = now
			else FS.shots[FS.sn["Explosive Shot"]]["CD"] = now + 6
			end
			FS.shots[FS.sn["Explosive Shot"]]["SET"] = now
			FS.data.noESUnit = FS.data.GUID
		else
			local start, duration, _ = GetSpellCooldown(FS.sn["Explosive Shot"])
			if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Explosive Shot"]]["CD"] = start + duration end 
		end
	end

	-- Arcane Shot
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Arcane Shot"] then
		FS.shots[FS.sn["Arcane Shot"]]["CD"] = now + 6
		FS.shots[FS.sn["Arcane Shot"]]["SET"] = now
	else
		local start, duration, _ = GetSpellCooldown(FS.sn["Arcane Shot"])
		if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Arcane Shot"]]["CD"] = start + duration end 
	end
	
	-- Explosive Shot and Arcane Shot share the same CD
	if FS.talents[FS.tn["Explosive Shot"]] > 0 then
		if FS.data.startState == "fail" and (FS.shots[FS.sn["Explosive Shot"]]["CD"] == -1 or FS.shots[FS.sn["Arcane Shot"]]["CD"] == -1) then
			FS.shots[FS.sn["Explosive Shot"]]["CD"], FS.shots[FS.sn["Arcane Shot"]]["CD"] = -1, -1
		elseif FS.shots[FS.sn["Explosive Shot"]]["CD"] > FS.shots[FS.sn["Arcane Shot"]]["CD"] then
			FS.shots[FS.sn["Arcane Shot"]]["CD"] = FS.shots[FS.sn["Explosive Shot"]]["CD"]
		else
			FS.shots[FS.sn["Explosive Shot"]]["CD"] = FS.shots[FS.sn["Arcane Shot"]]["CD"]
		end
	end
	
	-- Kill Shot
	if FS.data.startState == "spellCast" and FS.data["lastSpellName"] == FS.sn["Kill Shot"] then
		if FS.usedGlyphs["Kill Shot"] then FS.shots[FS.sn["Kill Shot"]]["CD"] = now + 9 else FS.shots[FS.sn["Kill Shot"]]["CD"] = now + 15 end
		FS.shots[FS.sn["Kill Shot"]]["SET"] = now
	else
		local start, duration, _ = GetSpellCooldown(FS.sn["Kill Shot"])
		if start > 0 and duration > FS.data.GCD then FS.shots[FS.sn["Kill Shot"]]["CD"] = start + duration end 
	end
	
	-- Hunter's Mark effective damage
	local timeLeft = 0
	if not FS.debug then FS.debug = {} end
	-- HM is already on target mob
	if FS.debuffs[FS.sn["Hunter's Mark"]] then
		-- Mob is going to die before HM runs out
		if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"] then
			FS.debug.HM = "HM is already on target mob and Mob is going to die before HM runs out / timeLeft == "..timeLeft
			timeLeft = 0
		-- HM will run out before Mob dies
		else
			-- Mob dies before new HM would run out
			if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 300) then
				timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"]
				FS.debug.HM = "HM is already on target mob and HM will run out before Mob dies and Mob dies before new HM would run out / timeLeft == "..timeLeft
			-- New HM will be used completely
			else
				timeLeft = now + 300 - FS.debuffs[FS.sn["Hunter's Mark"]]["EXP"]
				FS.debug.HM = "HM is already on target mob and HM will run out before Mob dies and New HM will be used completely / timeLeft == "..timeLeft
			end
		end
	-- HM not on mob yet
	else
		-- Mob is going to die before a new HM would run out
		if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 300) then
			timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - now
			FS.debug.HM = "HM not on mob yet and Mob is going to die before a new HM would run out / timeLeft == "..timeLeft
		-- Mob is going to life longer than the HM
		else
			timeLeft = 300
			FS.debug.HM = "HM not on mob yet and Mob is going to life longer than the HM / timeLeft == "..timeLeft
		end
	end
	FS.shots[FS.sn["Hunter's Mark"]]["DMG"] = FS.shots[FS.sn["Hunter's Mark"]]["DPS"] * timeLeft
	FS.debug.HM = FS.debug.HM.." / dps == "..FS.shots[FS.sn["Hunter's Mark"]]["DPS"].." / dmg == "..FS.shots[FS.sn["Hunter's Mark"]]["DMG"]
	
	-- Serpent Stings effective damage
	local timeLeft = 0
	local duration = 15	if FS.usedGlyphs["Serpent Sting"] then duration = 21 end 
	if FS.debuffs[FS.sn["Serpent Sting"]] then
		if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Serpent Sting"]]["EXP"] then
			timeLeft = 0
		else
			if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + duration) then
				timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - FS.debuffs[FS.sn["Serpent Sting"]]["EXP"]
			else
				timeLeft = now + duration - FS.debuffs[FS.sn["Serpent Sting"]]["EXP"]
			end
		end
	else
		if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + duration) then
			timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - now
		else
			timeLeft = duration
		end
	end
	FS.shots[FS.sn["Serpent Sting"]]["DMG"] = FS.shots[FS.sn["Serpent Sting"]]["SPSDP3"] * floor(timeLeft / 3) + FS.talents[FS.tn["Noxious Stings"]] * 40 * timeLeft
	
	-- Black Arrows effective damage
	if FS.talents[FS.tn["Black Arrow"]] > 0 then
		local timeLeft = 0
		if FS.debuffs[FS.sn["Black Arrow"]] then
			if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= FS.debuffs[FS.sn["Black Arrow"]]["EXP"] then
				timeLeft = 0
			else
				if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 15) then
					timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - FS.debuffs[FS.sn["Black Arrow"]]["EXP"]
				else
					timeLeft = now + duration - FS.debuffs[FS.sn["Black Arrow"]]["EXP"]
				end
			end
		else
			if FS.data.tarTTL[FS.data.unitGUID]["TTL"] <= (now + 15) then
				timeLeft = FS.data.tarTTL[FS.data.unitGUID]["TTL"] - now
			else
				timeLeft = 15
			end
		end
		FS.shots[FS.sn["Black Arrow"]]["DMG"] = FS.shots[FS.sn["Black Arrow"]]["DP3"] * floor(timeLeft / 3) + 240 * timeLeft
	end
end

-- Shows the selected shot
function FS:DisplayShot()
	FS.TSLU.frameDraw = 0
	now = GetTime()

	if FaceShooterdb.displayMethod == "default" then
		-- if last frame differs from new frame draw the shot frame
		if FS.data.nextSpellName ~= nil then
			if FS.data.lastFrameDrawn ~= FS.data.nextSpellName or IsSpellInRange(FS.data.nextSpellName, "target") ~= FS.data.lastSpellRange then
				FS.textureList["nextShot"]:SetTexture(GetSpellTexture(FS.data.nextSpellName))
				FS.data.lastSpellRange = IsSpellInRange(FS.data.nextSpellName, "target")
				if FS.data.lastSpellRange == 1 then FS.textureList["nextShot"]:SetVertexColor(1, 1, 1)
				else FS.textureList["nextShot"]:SetVertexColor(1, 0.15, 0.15)
				end
			end
		else
			FS.textureList["nextShot"]:SetTexture(nil)
		end
		
		FS.data.lastFrameDrawn = FS.data.nextSpellName

		-- delay drawing the cooldownframe if couldn´t be calculated yet
		if FS.data.nextSpellTime ~= nil then
		
			-- if next spell is one of those waited for adjust nextSpellTime if neccessary
			if FS.data.nextSpellName == FS.sn["Kill Shot"] and FS.shots[FS.sn["Kill Shot"]]["CD"] > FS.data.nextSpellTime then FS.shots[FS.sn["Kill Shot"]]["CD"] = FS.data.nextSpellTime
			elseif FS.data.nextSpellName == FS.sn["Chimera Shot"] and FS.shots[FS.sn["Chimera Shot"]]["CD"] > FS.data.nextSpellTime then FS.shots[FS.sn["Chimera Shot"]]["CD"] = FS.data.nextSpellTime
			elseif FS.data.nextSpellName == FS.sn["Explosive Shot"] and FS.shots[FS.sn["Explosive Shot"]]["CD"] > FS.data.nextSpellTime then FS.shots[FS.sn["Explosive Shot"]]["CD"] = FS.data.nextSpellTime
			end
			
			local TimeToNextSpell = FS.data.nextSpellTime - now
			if TimeToNextSpell < 0 then TimeToNextSpell = 0 end

			-- draw the cooldown frame
			if TimeToNextSpell == 0 or FS.data.nextSpellName == nil then
				FS.cooldownFrame:SetAlpha(0)
			else
				FS.cooldownFrame:SetAlpha(1)
				FS.cooldownFrame:SetCooldown(FS.data.lastSpellTime, TimeToNextSpell)
			end
		end
		
	elseif FaceShooterdb.displayMethod == "rotating" then
		FS.data.lastFrameDrawn = FS.data.nextSpellName

		-- if next spell is one of those waited for adjust nextSpellTime if neccessary
		local TimeToNextSpell = nil
		local TimeSinceLastSpell = nil
		
		if FS.data.nextSpellTime then TimeToNextSpell = FS.data.nextSpellTime - now end
		if TimeToNextSpell < 0 then TimeToNextSpell = 0 end
		if FS.data.lastPrioSpellTime then TimeSinceLastSpell = now - FS.data.lastPrioSpellTime end
		
		local newNextScale = nil
		local newNextPos = nil
		local newLastScale = nil
		local newLastPos = nil
		
		if TimeToNextSpell == nil then
		elseif TimeToNextSpell == 0 then
			newNextScale = 1
			newNextPos = 0
		else
			newNextScale = 1 - 0.4 * ( TimeToNextSpell / 1.5 )^2
			newNextPos = (TimeToNextSpell / 1.5)^0.5 * 50
		end
		
		if TimeSinceLastSpell == nil then
		elseif TimeSinceLastSpell == 0 then
			newLastScale = 1
			newLastPos = 0
		elseif TimeSinceLastSpell < 1.5 then
			newLastScale = 1 - 0.4 * ( TimeSinceLastSpell / 1.5 )^2
			newLastPos = (TimeSinceLastSpell / 1.5)^0.5 * -50
		elseif TimeSinceLastSpell >= 1.5 then
			newLastScale = nil
			newLastPos = nil
		end
		
		-- draw the shot frame
		if FS.data.nextSpellName ~= nil and newNextScale and newNextPos then
			if newNextScale <= 0 then newNextScale = 0.01 end
			FS.nextShot:SetScale(newNextScale)
			FS.nextShot:SetPoint("CENTER", newNextPos, 0)
			FS.textureList["nextShot"]:SetTexture(GetSpellTexture(FS.data.nextSpellName))
			FS.data.lastSpellRange = IsSpellInRange(FS.data.nextSpellName, "target")
			if FS.data.lastSpellRange == 1 then FS.textureList["nextShot"]:SetVertexColor(1, 1, 1)
			else FS.textureList["nextShot"]:SetVertexColor(1, 0.15, 0.15)
			end
		else
			FS.textureList["nextShot"]:SetTexture(nil)
		end
		
		if FS.data.lastSpellName ~= nil and newLastScale ~= nil and newLastPos then
			if newLastScale <= 0 then newLastScale = 0.01 end
			FS.lastShot:SetScale(newLastScale)
			FS.lastShot:SetPoint("CENTER", newLastPos, 0)
			FS.data.lastSpellVisible = true
			FS.textureList["lastShot"]:SetTexture(GetSpellTexture(FS.data.lastPrioSpellName))			
		else
			FS.data.lastSpellVisible = false
			FS.textureList["lastShot"]:SetTexture(nil)
		end		
	end
end

-- Triggers the decision finding process for the next and last shot frame
function FS:Scheduler()
	now = GetTime()
	
	-- if last known state was dismounted and player is mounted now change the state and hide the frames
	if not FS.data.onMount and IsMounted() then
		FS.data.onMount = true
		FS:ChangeFrameVisibility(false)
	end
	
	-- if last known state was mounted and player is dismounted now check if other conditions for frame showing are met and show accordingly
	if FS.data.onMount and not IsMounted() then
		FS.data.onMount = false
		if FS:ShowCheck() then FS:ChangeFrameVisibility(true) end
	end
	
	-- if FS is in idle state nothing needs to be calculated
	if FS.data.startState == "idle" then
	 return true
	end

	-- if targets TTL array hasn´t been created yet do so now
	if FS.data.tarTTL[FS.data.unitGUID] == nil then
		FS:EstimateTTL()
	end

	-- delayed call of GetCombatStats
	if FS.data.checkStatsAt <= now and FS.data.checkStatsAt > 0 then
		FS:GetCombatStats()
	end
	
	-- delayed check for spell interrupts
	if FS.data.checkCastAt <= now and FS.data.checkCastAt > 0 and FaceShooterdb.enableShots then
		if FS:CheckSpellList() then
			FS:CollectData()
			FS:SpellFind()
			FS:DisplayShot()
			if FS.data["GCD"] > 0 or FS.data.nextSpellTime > now then FS.data.endState = "busy"
			else FS.data.endState = "ready"
			end
		end
	end

	-- delayed Tooltip checking
	if FS.data.checkTooltipAt <= now and FS.data.checkTooltipIndex >= 0 then
		FS:ScanItems()
	end
	
	-- if player has finished the cast check for GCD
	if FS.data.startState == "busy" and now >= FS.data.nextSpellTime and FaceShooterdb.enableShots then
		FS:GetGCD(now)
		if FS.data["GCD"] == 0 then FS.data.endState = "ready" end
	end
	
	-- if player is not in GCD and last spellcast has finished reevaluate next spell once every 0.25s
	if FS.data.startState == "ready" and FS.TSLU.spellFind >= 0.25 and FaceShooterdb.enableShots then
		FS:CollectData()
		FS:GetCombatStats()
		FS:SpellFind()
	end

	-- if a new target has been selected or something about the showing conditions changed reevaluate next spell
	if (FS.data.startState == "reEvaluate" or FS.data.startState == "fail" or FS.data.ccs) and FaceShooterdb.enableShots then
		FS.data.ccs = false
		FS:CheckDebuffs()
		FS:GetCombatStats()
		FS:CollectData()
		FS:SpellFind()
		FS:DisplayShot()
		if FS.data["GCD"] > 0 or FS.data.nextSpellTime > now then FS.data.endState = "busy"
		else FS.data.endState = "ready"
		end
	end
	
	-- if a spell has just been cast calculate the next spell
	if FS.data.startState == "spellCast" and FaceShooterdb.enableShots then
		FS:CollectData()
		FS:GetCombatStats()
		FS:SpellFind()
		FS:DisplayShot()
		FS.data.endState = "busy"
	end
	
	-- collect data points and calculate the estimated TTL of target twice every second
	if FS.TSLU.estimateTTL >= 0.5 then
		FS:EstimateTTL()
	end
	
	-- if the last frame that has been drawn differs from the next one to be drawn draw it
	if FS.data.lastFrameDrawn ~= FS.data.nextSpellName or (FS.data.nextSpellName ~= nil and IsSpellInRange(FS.data.nextSpellName, "target") ~= FS.data.lastSpellRange) and FaceShooterdb.enableShots then
		FS:DisplayShot()
	end
	
	-- if the rotating display method is beeing used, animate the shot frame with ~25 fps
	if FaceShooterdb.displayMethod == "rotating" and (FS.data.nextSpellTime >= now or FS.data.lastSpellVisible) and FS.TSLU.frameDraw >= 0.04 and FaceShooterdb.enableShots then
		FS:DisplayShot()
	end

	-- check for sniper training buff once every quater second
	if FaceShooterdb.enableSniper and FS.talents[FS.tn["Sniper Training"]] > 0 and FS.TSLU.sniperFrame >=0.25 then
		FS:SniperCheck()
	end
	
	-- check for chimera adjustments once every quater second
	if FaceShooterdb.enableChimera and FS.talents[FS.tn["Chimera Shot"]] > 0 and FS.TSLU.chimeraFrame >=0.25 then
		if FS.data.constSpSAdj_now[tarGUID] == nil or FS.data.constSpSAdj[tarGUID] == nil then FS:GetCombatStats() end
		FS:ChimeraCheck()
	end

	-- collect data points and calculate the estimated mps twice every second
	if FaceShooterdb.enableAspects and FS.TSLU.estimateMPS >= 5 then
		FS:EstimateMPS()
	end

	-- check for aspect thresholds once every half second
	if FaceShooterdb.enableAspects and FS.TSLU.aspectsFrame >=0.25 then
		FS:AspectsCheck()
	end

	-- if scheduler has finished update startState to the new state
	FS.data.startState = FS.data.endState
end

---------------------------------------
--<< Start of event funtions block >>--
---------------------------------------

-- Initialize the addon.
function FS.events.ADDON_LOADED(addon)
	if addon ~= "FaceShooter" then
		return nil
	end

	FS.baseFrame:UnregisterEvent("ADDON_LOADED") -- unregistering the AddOn Loaded event as it´s no longer needed
	FS.baseFrame:SetScript("OnUpdate", function(this, elapsed) FS:OnUpdate(elapsed) end) -- Registering the OnUpdate event as AddOn Base Time
	
	-- loading/creating the Savedvariables
	FS:InitSavedVariables()
	
	-- initialise all global variables and register all events necessary for the shots frame

	-- Time since last update for each frame
	FS.TSLU = {
		["dataCollect"] = 0,
		["combatStats"] = 0,
		["spellFind"] = 0,
		["frameDraw"] = 0,
		["estimateTTL"] = 0,
		["estimateMPS"] = 0,
		["sniperFrame"] = 0,
		["chimeraFrame"] = 0,
		["aspectsFrame"] = 0
	}

	-- Misc global variables that need initialisation
	FS.data = {
		["OOC"] = true,
		["numPlayers"] = 1,
		["numHunters"] = 1,
		["unitGUID"] = nil,
		["tarTTL"] = {},
		["tarDeviation"] = {},
		["baseSpSTick_now"] = {},
		["baseSpSTick"] = {},
		["constSpSAdj_now"] = {},
		["constSpSAdj"] = {},
		["constBAAdj_now"] = {},
		["constBAAdj"] = {},
		["constESAdj_now"] = {},
		["constESAdj"] = {},
		["spsAdjStr_now"] = {},
		["spsAdjStr"] = {},
		["esAdjStr_now"] = {},
		["esAdjStr"] = {},
		["baAdjStr_now"] = {},
		["baAdjStr"] = {},
		["refreshSpSCrit"] = {},
		["baseBATick"] = {},
		["constBAAdj"] = {},
		["minESTick"] = {},
		["maxESTick"] = {},
		["constESAdj"] = {},
		["spellList"] = {},
		["startState"] = "idle",
		["endState"] = "idle",
		["castingTime"] = 0,
		["lastFrameDrawn"] = nil,
		["lastSpellVisible"] = false,
		["lastSpellName"] = nil,
		["lastSpellTime"] = 0,
		["lastPrioSpellName"] = nil,
		["lastPrioSpellTime"] = 0,
		["lastSpellRange"] = true,
		["nextSpellTime"] = 0,
		["GCD"] = 0,
		["ES_LNL"] = false,
		["STBug"] = false,
		["autoadj"] = {},
		["SpS_Last_Exp"] = 0,
		["BA_Last_Exp"] = 0,
		["ccs"] = false,
		["checkTooltipIndex"] = -1,
		["checkStatsAt"] = 0,
		["checkCastAt"] = 0,
		["checkTooltipAt"] = 0
	}

	-- Using Spell IDs so the AddOn works in diffrent languages
	FS.sn = {
		-- Shots
		["Auto Shot"] = GetSpellInfo(75),
		["Wyvern Sting"] = GetSpellInfo(49012),
		["Viper Sting"] = GetSpellInfo(3034),
		["Scorpid Sting"] = GetSpellInfo(3043),
		["Serpent Sting"] = GetSpellInfo(49001),
		["Chimera Shot"] = GetSpellInfo(53209),
		["Chimera Shot - Serpent"] = GetSpellInfo(53353),
		["Black Arrow"] = GetSpellInfo(3674),
		["Explosive Shot"] = GetSpellInfo(60053),
		["Steady Shot"] = GetSpellInfo(49052),
		["Aimed Shot"] = GetSpellInfo(49050),
		["Multi-Shot"] = GetSpellInfo(49048),
		["Arcane Shot"] = GetSpellInfo(49045),
		["Kill Shot"] = GetSpellInfo(61006),
		-- Aspects
		["Aspect of the Viper"] = GetSpellInfo(34074),
		["Aspect of the Cheetah"] = GetSpellInfo(5118),
		["Aspect of the Pack"] = GetSpellInfo(13159),
		["Aspect of the Wild"] = GetSpellInfo(49071),
		["Aspect of the Dragonhawk"] = GetSpellInfo(61847),
		-- Misc
		["Volley"] = GetSpellInfo(58434),
		["Lock and Load"] = GetSpellInfo(56453),
		["Kill Command"] = GetSpellInfo(34026),
		["Master's Call"] = GetSpellInfo(53271),
		["Deterrence"] = GetSpellInfo(19263),
		["Disengage"] = GetSpellInfo(781),
		["The Beast Within"] = GetSpellInfo(34692),
		["Feign Death"] = GetSpellInfo(5384),
		["Sniper Training"] = GetSpellInfo(53304),
		-- Haste Buffs
		["Rapid Fire"] = GetSpellInfo(3045),
		["Quick Shots"] = GetSpellInfo(6150),
		["Heroism"] = GetSpellInfo(32182),
		["Bloodlust"] = GetSpellInfo(2825),
		-- RAP Buffs
		["Hunter's Mark"] = GetSpellInfo(53338),
		["Expose Weakness"] = GetSpellInfo(34501),
		["Trueshot Aura"] = GetSpellInfo(19506),
		["Unleashed Rage"] = GetSpellInfo(30809),
		["Abomination's Might"] = GetSpellInfo(53138),
		-- Hit Chance
		["Heroic Presence"] = GetSpellInfo(28878),
		-- Armor Debuffs
		["Sunder Armor"] = GetSpellInfo(58567),
		["Expose Armor"] = GetSpellInfo(8647),
		["Acid Spit"] = GetSpellInfo(55754),
		["Curse of Weakness"] = GetSpellInfo(50511),
		["Faerie Fire"] = GetSpellInfo(770),
		["Faerie Fire (Feral)"] = GetSpellInfo(16857),
		["Sting"] = GetSpellInfo(56631),
		-- Spelldamage Debuffs
		["Curse of Elements"] = GetSpellInfo(47865),
		["Earth and Moon"] = GetSpellInfo(48511),
		["Ebon Plaguebringer"] = GetSpellInfo(51161),
		["Singed"] = GetSpellInfo(65280),
		-- Damage Buffs
		["Ferocious Inspiration"] = GetSpellInfo(34460),
		["Improved Steady Shot"] = GetSpellInfo(53220),
		["Exploit Weakness"] = GetSpellInfo(70728),
		["Culling the Herd"] = GetSpellInfo(52858),
		["Tricks of the Trade"] = GetSpellInfo(57934),
		["Hysteria"] = GetSpellInfo(49016),
		["Essence of the Blood Queen"] = GetSpellInfo(70867),
		["Shadow Crash"] = GetSpellInfo(63277),
		["Rune of Power"] = GetSpellInfo(64320),
		["Arcane Empowerment"] = GetSpellInfo(31583),
		["Strength of Wrynn"] = GetSpellInfo(73762),
		["Hellscream's Warsong"] = GetSpellInfo(73816),
		-- Bleed Damage
		["Mangle (Bear)"] = GetSpellInfo(48564),
		["Mangle (Cat)"] = GetSpellInfo(48566),
		["Trauma"] = GetSpellInfo(57393),
		["Stampede"] = GetSpellInfo(46857)
	}

	-- Shots table containing all the shots statistics
	FS.shots = {
		[FS.sn["Chimera Shot"]] = {["CD"] = 0},
		[FS.sn["Black Arrow"]] = {["CD"] = 0},
		[FS.sn["Aimed Shot"]] = {["CD"] = 0},
		[FS.sn["Multi-Shot"]] = {["CD"] = 0},
		[FS.sn["Explosive Shot"]] = {["CD"] = 0},
		[FS.sn["Arcane Shot"]] = {["CD"] = 0},
		[FS.sn["Kill Shot"]] = {["CD"] = 0},
		[FS.sn["Hunter's Mark"]] = {["CD"] = 0},
		[FS.sn["Steady Shot"]] = {["CD"] = 0},
		[FS.sn["Serpent Sting"]] = {["CD"] = 0}
	}

	-- Buffs that need to be watched in order to evaluate the shot priorities
	FS.buffs = {
		-- Aspects
		[FS.sn["Aspect of the Viper"]] = false,
		[FS.sn["Aspect of the Cheetah"]] = false,
		[FS.sn["Aspect of the Pack"]] = false,
		[FS.sn["Aspect of the Wild"]] = false,
		[FS.sn["Aspect of the Dragonhawk"]] = false,
		-- Ranged Haste effects
		[FS.sn["Rapid Fire"]] = false,
		[FS.sn["Quick Shots"]] = false,
		[FS.sn["Heroism"]] = false,
		[FS.sn["Bloodlust"]] = false,
		-- Attack Power
		[FS.sn["Trueshot Aura"]] = false,
		[FS.sn["Unleashed Rage"]] = false,
		[FS.sn["Abomination's Might"]] = false,
		[FS.sn["Expose Weakness"]] = false,
		-- Hit Chance
		[FS.sn["Heroic Presence"]] = false,
		-- Misc
		[FS.sn["The Beast Within"]] = false,
		[FS.sn["Ferocious Inspiration"]] = false,
		[FS.sn["Lock and Load"]] = false,
		[FS.sn["Sniper Training"]] = false,
		[FS.sn["Improved Steady Shot"]] = false,
		[FS.sn["Exploit Weakness"]] = false,
		[FS.sn["Culling the Herd"]] = false,
		[FS.sn["Arcane Empowerment"]] = false,
		[FS.sn["Tricks of the Trade"]] = false,
		[FS.sn["Hysteria"]] = false,
		[FS.sn["Strength of Wrynn"]] = false,
		[FS.sn["Hellscream's Warsong"]] = false,
	}
	
	-- Debuffs on player that need to be watched
	FS.pdebuffs = {
		[FS.sn["Essence of the Blood Queen"]] = false,
		[FS.sn["Shadow Crash"]] = false,
		[FS.sn["Rune of Power"]] = false
--		[FS.sn["EBQ2"]] = false,
--		[FS.sn["EBQ3"]] = false,
--		[FS.sn["EBQ4"]] = false,
--		[FS.sn["EBQ5"]] = false,
--		[FS.sn["EBQ6"]] = false
	}

	-- Debuffs on targets that need to be watched in order to evaluate the shot priorities
	FS.debuffs = {
		-- DoTs
		[FS.sn["Serpent Sting"]] = false,
		[FS.sn["Viper Sting"]] = false,
		[FS.sn["Scorpid Sting"]] = false,
		[FS.sn["Wyvern Sting"]] = false,
		[FS.sn["Black Arrow"]] = false,
		[FS.sn["Explosive Shot"]] = false,
		-- RAP
		[FS.sn["Hunter's Mark"]] = false,
		-- Armor
		[FS.sn["Sunder Armor"]] = false,
		[FS.sn["Expose Armor"]] = false,
		[FS.sn["Acid Spit"]] = false,
		[FS.sn["Curse of Weakness"]] = false,
		[FS.sn["Faerie Fire"]] = false,
		[FS.sn["Faerie Fire (Feral)"]] = false,
		[FS.sn["Sting"]] = false,	
		-- Spelldamage
		[FS.sn["Curse of Elements"]] = false,
		[FS.sn["Earth and Moon"]] = false,
		[FS.sn["Ebon Plaguebringer"]] = false,
		[FS.sn["Singed"]] = false,
		-- Bleed Damage
		[FS.sn["Mangle (Bear)"]] = false,
		[FS.sn["Mangle (Cat)"]] = false,
		[FS.sn["Trauma"]] = false,
		[FS.sn["Stampede"]] = false
	}
	
	-- Create enabled frames
	FS:CreateScanTooltip()
	FS:CreateConfigFrame()
	if FaceShooterdb.enableShots then FS:CreateShotsFrame() end
	if FaceShooterdb.enableTTL then FS:CreateTTLFrame() end
	if FaceShooterdb.enableSniper then FS:CreateSniperFrame() end
	if FaceShooterdb.enableChimera then FS:CreateChimeraFrame() end
	if FaceShooterdb.enableAspects then FS:CreateAspectsFrame() end
	
	-- Register events needed for all frames
	FS.baseFrame:RegisterEvent("PLAYER_ALIVE")
	FS.baseFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	FS.baseFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
	FS.baseFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
	FS.baseFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	FS.baseFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
	FS.baseFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
	FS.baseFrame:RegisterEvent("UNIT_FACTION")
	FS.baseFrame:RegisterEvent("UNIT_INVENTORY_CHANGED")
	
	if not UnitInVehicle("player") then FS.baseFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
	else FS.baseFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
	end

	-- Register slash commands
	SlashCmdList["FaceShooter"] = FS.Options
	SLASH_FaceShooter1 = "/faceshooter"
	SLASH_FaceShooter2 = "/fs"	
end

-- AddOn Time Base
function FS:OnUpdate(elapsed)
	local index = next(FS.TSLU)
	while index do -- Incrementing every timeindex by the time elapsed
		FS.TSLU[index] = FS.TSLU[index] + elapsed
		index = next(FS.TSLU, index)
	end
	FS:Scheduler()
end

-- Test player's spec once when player is alive (client start)
function FS.events.PLAYER_ALIVE()
	FS:ReInitialize()
	FS.baseFrame:UnregisterEvent("PLAYER_ALIVE")
end

-- Fired whenever a loading screen appears
function FS.events.PLAYER_ENTERING_WORLD()
	now = GetTime()
	if reload then FS:ReInitialize() reload = false end
	FS.data.checkTooltipAt = now
	FS.data.checkTooltipIndex = 15
end

-- Reevaluate spec if talents are changed
function FS.events.PLAYER_TALENT_UPDATE()
	FS:ReInitialize()
end

-- Turn off FS frames when entering a vehicle
function FS.events.UNIT_ENTERED_VEHICLE(unit)
	if unit == "player" then
		FS.baseFrame:UnregisterEvent("UNIT_ENTERED_VEHICLE")
		FS.baseFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
		FS.data.inVehicle = true
		FS:ChangeFrameVisibility(false)
	end
end

-- Check target for eligibility if exiting a vehicle
function FS.events.UNIT_EXITED_VEHICLE(unit)
	if unit == "player" then
		FS.baseFrame:UnregisterEvent("UNIT_EXITED_VEHICLE")
		FS.baseFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
		FS.data.inVehicle = false
		if FS:ShowCheck() then FS:ChangeFrameVisibility(true) end
	end
end

-- Set flag to out of combat
function FS.events.PLAYER_REGEN_ENABLED()
	FS.data.OOC = true
	FS.data.ccs = true
end

-- Set flag to in combat
function FS.events.PLAYER_REGEN_DISABLED()
	FS.data.OOC = false
	FS.data.ccs = true
end

-- Check if player is solo, in party or raid and get the Numer of players in party/raid
function FS.events.PARTY_MEMBERS_CHANGED()
	if UnitInRaid("player") then
		FS.data.numPlayers = GetNumRaidMembers()
		-- if player has just entered a raid check agains showing conditions and show/hide accordingly
		if FS.data.partyStatus ~= "raid" then
			FS.data.partyStatus = "raid"
			if FS:ShowCheck() then
				if FS.data.startState == "idle" then FS:ChangeFrameVisibility(true) end
			else
				if FS.data.startState ~= "idle" then FS:ChangeFrameVisibility(false) end
			end
		end
	elseif GetNumPartyMembers() > 0 then
		FS.data.numPlayers = GetNumPartyMembers()
		if FS.data.partyStatus ~= "party" then
			FS.data.partyStatus = "party"
			if FS:ShowCheck() then
				if FS.data.startState == "idle" then FS:ChangeFrameVisibility(true) end
			else
				if FS.data.startState ~= "idle" then FS:ChangeFrameVisibility(false) end
			end
		end
	else
		FS.data.numPlayers = 1
		if FS.data.partyStatus ~= "solo" then
			FS.data.partyStatus = "solo"
			if FS:ShowCheck() then
				if FS.data.startState == "idle" then FS:ChangeFrameVisibility(true) end
			else
				if FS.data.startState ~= "idle" then FS:ChangeFrameVisibility(false) end
			end
		end
	end
	
	FS.data.numHunters = 1
	if FS.data.partyStatus == "party" then
		local i = 1
		for i = 1, 4 do
			local _, playerClass = UnitClass("party"..i)
			if playerClass == "HUNTER" then FS.data.numHunters = FS.data.numHunters + 1 end
		end
	elseif FS.data.partyStatus == "raid" then
		local i = 1
		for i = 1, 40 do
			local _, playerClass = UnitClass("raid"..i)
			if playerClass == "HUNTER" then FS.data.numHunters = FS.data.numHunters + 1
			elseif playerClass == nil then break
			end
		end
		FS.data.numHunters = FS.data.numHunters - 1
	end
end

-- Fired whenever some of your combatratings change
function FS.events.COMBAT_RATING_UPDATE()
	FS.data.checkStatsAt = GetTime()
	FS:Scheduler()
end

-- Initiates a unitcheck whenever target has changed
function FS.events.PLAYER_TARGET_CHANGED()
	FS.data.unitGUID = UnitGUID("target")
	if FS:ShowCheck() then
		if FS.data.startState == "idle" then FS:ChangeFrameVisibility(true)
		else
			FS.data.startState = "reEvaluate"
			FS.data.endState = "reEvaluate"
			FS:Scheduler()
		end
	else
		if FS.data.startState ~= "idle" then FS:ChangeFrameVisibility(false) end
	end
end

-- Initiates a unitcheck whenever targets faction has changed
function FS.events.UNIT_FACTION()
	if FS:ShowCheck() then
		if FS.data.startState == "idle" then FS:ChangeFrameVisibility(true) end
	else
		if FS.data.startState ~= "idle" then FS:ChangeFrameVisibility(false) end
	end
end

-- Fires whenever a unit gains or looses a buff
function FS.events.UNIT_AURA(unitID)
	now = GetTime()
	if unitID == "player" then
		FS:CheckBuffs()
		if FS.data.checkStatsAt ~= 0 then
			FS.data.checkStatsAt = now
			FS:Scheduler()
		end
		FS.data.checkStatsAt = now + 1
	end
	
	if unitID == "target" then
		FS:CheckDebuffs()
		if FS.data.checkStatsAt ~= 0 then
			FS.data.checkStatsAt = now
			FS:Scheduler()
		end
		FS.data.checkStatsAt = now + 1
	end
end

-- Fires whenever equipment is changed
function FS.events.UNIT_INVENTORY_CHANGED(unitID)
	now = GetTime()
	if unitID == "player" and FS.data.checkTooltipAt < (now + FS.data.checkTooltipIndex) then
		FS:ScanItems()
	end
end

-- Get type and time of the last cast
function FS.events.UNIT_SPELLCAST_SENT(srcUnit, spellName, spellRank, dstUnit)
	-- save name and time of last cast
	if srcUnit == "player" then
		-- MS registers as three spellcasts - ignore all but one of them
		if spellName == FS.sn["Multi-Shot"] and FS.data.lastSpellName == FS.sn["Multi-Shot"] and (now - FS.data.lastSpellTime <= 0.001) then return end
		now = GetTime()
		FS.data.secondToLastSpellName = FS.data.lastSpellName
		FS.data.lastSpellName = spellName
		FS.data.secondToLastSpellTime = FS.data.lastSpellTime
		FS.data.lastSpellTime = now
		FS.data.spellList[spellName] = now
		if not FS.data.latency then FS.data.latency = 0.5 end
		if FS.data.checkCastAt == 0 then FS.data.checkCastAt = now + FS.data.latency end

		-- detection of instant casts and calculation of casttime for non-instant casts (treat MS as instant)
		local _, _, _, _, _, _, castingTime, _, _ = GetSpellInfo(spellName)
		if castingTime == nil or now < FS.data.nextSpellTime or spellName == FS.sn["Multi-Shot"] then
		elseif castingTime < 0 and now > FS.data.nextSpellTime or spellName == FS.sn["Multi-Shot"] then
			FS.data.castingTime = 0
		elseif now > FS.data.nextSpellTime then
			local rangedAttackSpeed, lowDmg, hiDmg, posBuff, negBuff, percent = UnitRangedDamage("player")
			local haste = FS.data.weaponSpeed / rangedAttackSpeed
			FS.data.castingTime = castingTime / 1000
			if spellName == FS.sn["Steady Shot"] then FS.data.SScastingTime = FS.data.castingTime end
		end
		
		-- if the spell beeing cast is assoziated with a priority save name, time of cast and target's GUID
		if spellName == FS.sn["Hunter's Mark"] or spellName == FS.sn["Serpent Sting"] or spellName == FS.sn["Chimera Shot"] or spellName == FS.sn["Black Arrow"] or spellName == FS.sn["Explosive Shot"] or spellName == FS.sn["Steady Shot"] or spellName == FS.sn["Aimed Shot"] or spellName == FS.sn["Multi-Shot"] or spellName == FS.sn["Arcane Shot"] or spellName == FS.sn["Kill Shot"] then
			FS.data.secondToLastPrioSpellTime = FS.data.lastPrioSpellTime
			FS.data.lastPrioSpellTime = now
			FS.data.secondToLastPrioSpellName = FS.data.lastPrioSpellName
			FS.data.lastPrioSpellName = spellName
			FS.data.secondToLastGUID = FS.data.lastGUID
			FS.data.lastGUID = UnitGUID("target")
		end
	end
end

-- Fires whenever a cast has been recognized as succeeded by the server
function FS.events.UNIT_SPELLCAST_SUCCEEDED(srcUnit, spellName)
	if srcUnit == "player" then
		now = GetTime()
		tarGUID = FS.data.unitGUID
		
		-- if the spell is still on the spell list waiting for confirmation nil it
		-- and save the time since the spellcast has been sent as latency (plus some leeway)
		if FS.data.spellList[spellName] then
			FS.data.latency = FS.data.spellList[spellName] + 0.1
			FS.data.spellList[spellName] = nil
			if not next(FS.data.spellList) then FS.data.checkCastAt = 0 end
		end
		
		-- if the spell cast was an serpent sting update base tick and constant adjustments
		if spellName == FS.sn["Serpent Sting"] then
			FS.data.constSpSAdj[tarGUID] = FS.data.constSpSAdj_now[tarGUID]
			FS.data.baseSpSTick[tarGUID] = FS.data.baseSpSTick_now[tarGUID]
			if FS.calcFeedback then FS.data.spsAdjStr[tarGUID] = FS.data.spsAdjStr_now[tarGUID] end
		-- if the spell cast was an chimera shot just update the base tick and keep the old constant adjustments
		elseif spellName == FS.sn["Chimera Shot"] then
			FS.data.baseSpSTick[tarGUID] = FS.data.baseSpSTick_now[tarGUID]
		end
	end
end

-- Fires whenever a cast start has been recognized by the server
function FS.events.UNIT_SPELLCAST_START(srcUnit, spellName)
	if srcUnit == "player" then

		-- if the spell is still on the spell list waiting for confirmation nil it
		-- and save the time since the spellcast has been sent as latency (plus some leeway)
		now = GetTime()
		if FS.data.spellList[spellName] then
			FS.data.latency = FS.data.spellList[spellName] + 0.1
			FS.data.spellList[spellName] = nil
			if not next(FS.data.spellList) then FS.data.checkCastAt = 0 end
		end
	end
end

-- Fires whenever a spell cooldown starts
function FS.events.SPELL_UPDATE_COOLDOWN()
	now = GetTime()
	FS:GetGCD(now)
	
	-- all prio spells have GCD so if it´s been less than 1s (hasted Hunter's Mark) since the last prio spell FS assumes it´s been interrupted
	if FS.data["GCD"] == 0 and (now - FS.data.lastPrioSpellTime) < 1 then
		FS.shots[FS.data.lastPrioSpellName]["CD"] = -1
		if FS.data.spellList[FS.data.lastPrioSpellName] then FS.data.spellList[FS.data.lastPrioSpellName] = nil end
		FS.data.lastPrioSpellTime = FS.data.secondToLastPrioSpellTime
		FS.data.lastPrioSpellName = FS.data.secondToLastPrioSpellName
		FS.data.lastSpellTime = FS.data.secondToLastSpellTime
		FS.data.lastSpellName = FS.data.secondToLastSpellName
		FS.data.lastGUID = FS.data.secondToLastGUID
		FS.data.nextSpellTime = now
		FS.data.startState = "fail"
		FS.data.endState = "fail"
		FS:Scheduler()
		
	-- if a nextSpellTime is later than GCD and last cast wasn´t a steady shot we assume it has been interrupted
	elseif FS.data["GCD"] == 0 and now < FS.data.nextSpellTime and FS.data.lastSpellName ~= FS.sn["Steady Shot"] then
		FS.data.startState = "fail"
		FS.data.endState = "fail"
		FS.data.lastSpellTime = FS.data.secondToLastSpellTime
		FS.data.lastSpellName = FS.data.secondToLastSpellName
		FS.data.nextSpellTime = now
		FS:Scheduler()
	
	-- enter no GCD	state
	elseif FS.data["GCD"] == 0 and now > FS.data.nextSpellTime and FS.data.startState == "busy" then
		FS.data.startState = "ready"
		FS.data.endState = "ready"
		FS:Scheduler()
	
	-- if it's been less than 0.025s since last recorded spell ~> spell has just been cast
	elseif (now - FS.data.lastSpellTime) <= 0.025 then
		FS.data.startState = "spellCast"
		FS.data.endState = "spellCast"
		if FS.data["GCD"] > FS.data["castingTime"] or FS.data.lastSpellName ~= FS.sn["Steady Shot"] then
			FS.data.nextSpellTime = now + FS.data["GCD"]
		else
			FS.data.nextSpellTime = now + FS.data["castingTime"]
		end
		if FS.data.nextSpellName == FS.sn["Kill Shot"] and FS.shots[FS.sn["Kill Shot"]]["CD"] > FS.data.nextSpellTime then
			FS.data.nextSpellTime = FS.shots[FS.sn["Kill Shot"]]["CD"]
		elseif FS.data.nextSpellName == FS.sn["Chimera Shot"] and FS.shots[FS.sn["Chimera Shot"]]["CD"] > FS.data.nextSpellTime then
			FS.data.nextSpellTime = FS.shots[FS.sn["Chimera Shot"]]["CD"]
		elseif FS.data.nextSpellName == FS.sn["Explosive Shot"] and FS.shots[FS.sn["Explosive Shot"]]["CD"] > FS.data.nextSpellTime then
			FS.data.nextSpellTime = FS.shots[FS.sn["Explosive Shot"]]["CD"]
		end
		FS:Scheduler()
		
	-- if GCD is greater 0 and state isn't already busy set it to busy
	elseif FS.data["GCD"] > 0 and FS.data.startState ~= "busy" then
		FS.data.startState = "busy"
		FS.data.endState = "busy"
	end
end

-- Fires whenever a combat log event has been registered
function FS.events.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventName, srcGUID, srcName, srcFlags, tarGUID, dstName, dstFlags, ...)
	if srcGUID == FS.data.myGUID and tarGUID == FS.data.unitGUID then
		local _, _, prefix, suffix = string.find(eventName, "(%w+)_?(.*)")
		if prefix == "RANGE" or prefix == "SPELL" then 
			if suffix == "DAMAGE" or suffix == "PERIODIC_DAMAGE" then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
				local damage = amount
				local low, high = nil, nil
				local deviation = nil
				if FS.shots[spellName] and (FS.shots[spellName]["MIN"] or FS.shots[spellName]["TICK"] or FS.shots[spellName]["SPSTICK"] or FS.shots[spellName]["MINTICK"]) then
					if not critical then
						if blocked then return end
						if resisted then damage = damage + resisted	end
						if spellName == FS.sn["Black Arrow"] then					
							local baTick = FS.data.baseBATick[tarGUID] * FS.data.constBAAdj[tarGUID] * FS.data.instantBAAdj
							if baTick > damage then
								if abs(damage / baTick - 1) > 0.01 then deviation = "below" end
							elseif baTick < damage then
								if abs(damage / baTick - 1) > 0.01 then deviation = "over" end
							end
						elseif spellName == FS.sn["Serpent Sting"] then
							local spsTick = FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj
							if spsTick > damage then
								if abs(damage / spsTick - 1) > 0.01 then deviation = "below" end
							elseif spsTick < damage then
								if abs(damage / spsTick - 1) > 0.01 then deviation = "over" end
							end
						elseif spellName == FS.sn["Explosive Shot"] then
							local minESTick = FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj
							local maxESTick = FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj
							if minESTick > damage then
								if abs(damage / minESTick - 1) > 0.01 then deviation = "below" end
							elseif maxESTick < damage then
								if abs(damage / maxESTick - 1) > 0.01 then deviation = "over" end
							end
						elseif spellName == FS.sn["Arcane Shot"] then
							if FS.shots[spellName]["MIN"] > damage then
								if abs(damage / FS.shots[spellName]["MIN"] - 1) > 0.01 then deviation = "below" end
							elseif FS.shots[spellName]["MIN"] < damage then
								if abs(damage / FS.shots[spellName]["MIN"] - 1) > 0.01 then deviation = "over" end
							end
						else
							if FS.shots[spellName]["MIN"] > damage then
								if abs(damage / FS.shots[spellName]["MIN"] - 1) > 0.01 then deviation = "below" end
							elseif FS.shots[spellName]["MAX"] < damage then
								if abs(damage / FS.shots[spellName]["MAX"] - 1) > 0.01 then deviation = "over" end
							end
						end
						if deviation then FS:CalcDeviation(spellName, "hit", damage, amount, blocked, resisted)
						elseif FS.data.tarDeviation[tarGUID] and FS.data.tarDeviation[tarGUID][spellName] then FS.data.tarDeviation[tarGUID][spellName] = nil
						end
					else
						if blocked then
							return
--							if spellName == FS.sn["Aimed Shot"] or FS.sn["Arcane Shot"] or FS.sn["Steady Shot"] or FS.sn["Kill Shot"] or FS.sn["Chimera Shot"] then damage = damage + blocked * critMfDAdj
--							else damage = damage + blocked * critAdj
--							end
						end
						if resisted then
							return
--							if spellName == FS.sn["Arcane Shot"] or spellName == FS.sn["Chimera Shot"] then damage = damage + resisted * critMfDAdj
--							elseif spellName == FS.sn["Serpent Sting"] then damage = damage + resisted * critSerpAdj
--							else damage = damage + resisted * critAdj
--							end
						end
						if spellName == FS.sn["Serpent Sting"] then
							local critSpSTick = FS.data.baseSpSTick[tarGUID] * FS.data.constSpSAdj[tarGUID] * FS.data.instantSpSAdj * critSerpAdj
							if critSpSTick > damage then
								if abs(damage / critSpSTick - 1) > 0.01 then deviation = "below" end
							elseif critSpSTick < damage then
								if abs(damage / critSpSTick - 1) > 0.01 then deviation = "over" end
							end
						elseif spellName == FS.sn["Explosive Shot"] then
							local critMinESTick = FS.data.minESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj
							local critMaxESTick = FS.data.maxESTick[tarGUID] * FS.data.constESAdj[tarGUID] * FS.data.instantESAdj * critAdj
							if critMinESTick > damage then
								if abs(damage / critMinESTick - 1) > 0.01 then deviation = "below" end
							elseif critMaxESTick < damage then
								if abs(damage / critMaxESTick - 1) > 0.01 then deviation = "over" end
							end
						elseif spellName == FS.sn["Arcane Shot"] then
							if FS.shots[spellName]["CRITMIN"] > damage then
								if abs(damage / FS.shots[spellName]["CRITMIN"] - 1) > 0.01 then deviation = "below" end
							elseif FS.shots[spellName]["CRITMIN"] < damage then
								if abs(damage / FS.shots[spellName]["CRITMIN"] - 1) > 0.01 then deviation = "over" end
							end
						else
							if FS.shots[spellName]["CRITMIN"] > damage then
								if abs(damage / FS.shots[spellName]["CRITMIN"] - 1) > 0.01 then deviation = "below" end
							elseif FS.shots[spellName]["CRITMAX"] < damage then
								if abs(damage / FS.shots[spellName]["CRITMAX"] - 1) > 0.01 then deviation = "over" end
							end
						end
						if deviation then FS:CalcDeviation(spellName, "crit", damage, amount, blocked, resisted)
						elseif FS.data.tarDeviation[tarGUID] and FS.data.tarDeviation[tarGUID][spellName] then FS.data.tarDeviation[tarGUID][spellName] = nil
						end
					end
				end
			end
		end
	end
end