﻿-- Initialize the Savedvariables or fill gaps
function FS:InitSavedVariables()
	if not FaceShooterdb then FaceShooterdb = {} end
	if FaceShooterdb.locked == nil then FaceShooterdb.locked = false end
	if FaceShooterdb.showInRaid == nil then FaceShooterdb.showInRaid = true end
	if FaceShooterdb.showInParty == nil then FaceShooterdb.showInParty = true end
	if FaceShooterdb.showWhenSolo == nil then FaceShooterdb.showWhenSolo = true end
	if FaceShooterdb.maxWaitDelay == nil then FaceShooterdb.maxWaitDelay = 5 end
	if FaceShooterdb.enableShots == nil then FaceShooterdb.enableShots = true end
	if FaceShooterdb.scaleShots == nil then FaceShooterdb.scaleShots = 100 end
	if FaceShooterdb.alphaShots == nil then FaceShooterdb.alphaShots = 100 end
	if FaceShooterdb.displayMethod == nil then FaceShooterdb.displayMethod = "default" end
	if FaceShooterdb.enableTTL == nil then FaceShooterdb.enableTTL = false end
	if FaceShooterdb.practiseMode == nil then FaceShooterdb.practiseMode = true end
	if FaceShooterdb.scaleTTL == nil then FaceShooterdb.scaleTTL = 100 end
	if FaceShooterdb.alphaTTL == nil then FaceShooterdb.alphaTTL = 100 end
	if FaceShooterdb.enableSniper == nil then FaceShooterdb.enableSniper = true end
	if FaceShooterdb.scaleSniper == nil then FaceShooterdb.scaleSniper = 100 end
	if FaceShooterdb.alphaSniper == nil then FaceShooterdb.alphaSniper = 100 end
	if FaceShooterdb.enableChimera == nil then FaceShooterdb.enableChimera = true end
	if FaceShooterdb.scaleChimera == nil then FaceShooterdb.scaleChimera = 100 end
	if FaceShooterdb.alphaChimera == nil then FaceShooterdb.alphaChimera = 100 end
	if FaceShooterdb.enableAspects == nil then FaceShooterdb.enableAspects = false end
	if FaceShooterdb.scaleAspects == nil then FaceShooterdb.scaleAspects = 100 end
	if FaceShooterdb.alphaAspects == nil then FaceShooterdb.alphaAspects = 100 end
	if FaceShooterdb.ignoreHuntersMark == nil then FaceShooterdb.ignoreHuntersMark = false end
	if FaceShooterdb.ignoreArcaneShot == nil then FaceShooterdb.ignoreArcaneShot = false end
	if FaceShooterdb.weaveLnL == nil then FaceShooterdb.weaveLnL = false end
	if FaceShooterdb.saveISS == nil then FaceShooterdb.saveISS = false end
	if FaceShooterdb.minThresholdAspects == nil then FaceShooterdb.minThresholdAspects = 20 end
	if FaceShooterdb.maxThresholdAspects == nil then FaceShooterdb.maxThresholdAspects = 80 end
	if FaceShooterdb.minHMTTL == nil then FaceShooterdb.minHMTTL = 0 end
end

-- Rounds the number to the given number of digits
function FS:Round(num, digits)
	if num == nil then return 0 end
	local mult = 10 ^ (digits or 0)
	return floor(num * mult + 0.5) / mult
end

-- Creates a scanning tooltip
function FS:CreateScanTooltip()
	FaceShooterItemTooltip = CreateFrame("GameTooltip", "FaceShooterItemTooltip");
	FaceShooterItemTooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
	FaceShooterItemTooltip:AddFontStrings(FaceShooterItemTooltip:CreateFontString("$parentTextLeft1", nil, "GameTooltipText"), FaceShooterItemTooltip:CreateFontString("$parentTextRight1", nil, "GameTooltipText"));
end

-- Creates the frames that hold the next and last shot (depending on displayMethod)
function FS:CreateShotsFrame()
	if not FS.textureList then FS.textureList = {} end
	
	-- Anchor Frame for the shot rotation textures
	FS.shotsMover = CreateFrame("Frame","shotsMover", UIParent)
	FS.shotsMover:SetFrameStrata("BACKGROUND")
	FS.shotsMover:SetWidth(40)
	FS.shotsMover:SetHeight(40)
	FS.shotsMover:SetScale(FaceShooterdb.scaleShots/100)
	FS.shotsMover:SetAlpha(FaceShooterdb.alphaShots/100)
	FS.shotsMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,})
	FS.shotsMover:SetMovable(true)
	FS.shotsMover:SetClampedToScreen(true)
	FS.shotsMover:SetPoint("CENTER", 0, 0)

	-- Hide anchor frame if shot proposal is locked
	if FaceShooterdb.locked then
		FS.shotsMover:SetBackdropColor(0, 0, 0, 0)
		FS.shotsMover:EnableMouse(false)
		FS.shotsMover:SetScript("OnMouseDown", nil)
		FS.shotsMover:SetScript("OnMouseUp", nil)
		FS.shotsMover:SetScript("OnDragStop", nil)

	-- Otherwise show and make it moveable
	else
		FS.shotsMover:SetBackdropColor(0, 0, 0, .4)
		FS.shotsMover:EnableMouse(true)
		FS.shotsMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		FS.shotsMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		FS.shotsMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	end

	-- Setup the frame for the proposed next shot texture
	FS.nextShot = CreateFrame("Button","nextShot", shotsMover)
	FS.nextShot:SetWidth(32)
	FS.nextShot:SetHeight(32)
	FS.nextShot:EnableMouse(false)
	FS.nextShot:SetPoint("CENTER", 0, 0)
	FS.nextShot.texture = FS.nextShot:CreateTexture(nil,"BACKGROUND")
	FS.nextShot.texture:SetTexture(nil)
	FS.nextShot.texture:ClearAllPoints()
	FS.nextShot.texture:SetAllPoints(FS.nextShot)
	FS.textureList["nextShot"] = FS.nextShot.texture

	if FaceShooterdb.displayMethod == "default" then
		FS.shotsMover:SetWidth(40)
		FS.cooldownFrame = CreateFrame("Cooldown","cooldownFrame", FS.nextShot)	-- Cooldown frame - only needed for the old display method
		FS.cooldownFrame:SetHeight(32)
		FS.cooldownFrame:SetWidth(32)
		FS.cooldownFrame:ClearAllPoints()
		FS.cooldownFrame:SetPoint("CENTER", nextShot, "CENTER", 0, 0)
	elseif FaceShooterdb.displayMethod == "rotating" then
		FS.shotsMover:SetWidth(100)
		FS.lastShot = CreateFrame("Button","lastShot", shotsMover)	-- Setup the frame for the last shot texture (only required for rotating display method)
		FS.lastShot:SetWidth(32)
		FS.lastShot:SetHeight(32)
		FS.lastShot:EnableMouse(false)
		FS.lastShot:SetPoint("CENTER", 0, 0)
		FS.lastShot.texture = FS.lastShot:CreateTexture(nil,"BACKGROUND")
		FS.lastShot.texture:SetTexture(nil)
		FS.lastShot.texture:ClearAllPoints()
		FS.lastShot.texture:SetAllPoints(FS.lastShot)
		FS.textureList["lastShot"] = FS.lastShot.texture
	end
end

-- Creates the frame that holds the TTL and (raid) DPS informations
function FS:CreateStatsFrame()
	-- Anchor frame for the ttl frame
	FS.statsMover = CreateFrame("Frame","statsMover", UIParent)
	FS.statsMover:SetWidth(10)
	FS.statsMover:SetHeight(10)
	FS.statsMover:SetClampedToScreen()
	FS.statsMover:SetFrameStrata("HIGH")
	FS.statsMover:SetPoint("LEFT", UIParent, "LEFT", 0, 0)
	FS.statsMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})


	-- Otherwise show and make it moveable
	FS.statsMover:SetBackdropColor(0, 0, 0, 0)
	FS.statsMover:EnableMouse(true)
	FS.statsMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
	FS.statsMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
	FS.statsMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

	FS.statsFrame = CreateFrame("Frame", "statsFrame", FS.statsMover)
	FS.statsFrame:SetPoint("LEFT", FS.statsMover, "LEFT", 0, 0)
	FS.statsFrame:SetAllPoints()

	FS.statsFrame.text = FS.statsFrame:CreateFontString("statsFrameText", "ARTWORK", "GameFontNormal")
	FS.statsFrame.text:SetFont(GameFontNormal:GetFont(), 12)
	FS.statsFrame.text:SetJustifyH("LEFT")
	FS.statsFrame.text:SetJustifyV("TOP")
	FS.statsFrame.text:SetPoint("LEFT", FS.statsFrame, "LEFT", 0, 0)
	FS.statsFrame.text:SetTextColor(1, 1, 1, 1)
end

-- Creates the frame that holds the TTL and (raid) DPS informations
function FS:CreateTTLFrame()
	-- Anchor frame for the ttl frame
	FS.ttlMover = CreateFrame("Frame","ttlMover", UIParent)
	FS.ttlMover:SetWidth(135)
	FS.ttlMover:SetHeight(20)
	FS.ttlMover:SetScale(FaceShooterdb.scaleTTL/100)
	FS.ttlMover:SetAlpha(FaceShooterdb.alphaTTL/100)
	FS.ttlMover:SetMovable(true)
	FS.ttlMover:SetClampedToScreen()
	FS.ttlMover:SetFrameStrata("HIGH")
	FS.ttlMover:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	FS.ttlMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})

	-- Hide anchor frame if TTL frame is locked
	if FaceShooterdb.locked then
		FS.ttlMover:SetBackdropColor(0, 0, 0, 0)
		FS.ttlMover:EnableMouse(false)
		FS.ttlMover:SetScript("OnMouseDown", nil)
		FS.ttlMover:SetScript("OnMouseUp", nil)
		FS.ttlMover:SetScript("OnDragStop", nil)

	-- Otherwise show and make it moveable
	else
		FS.ttlMover:SetBackdropColor(0, 0, 0, .4)
		FS.ttlMover:EnableMouse(true)
		FS.ttlMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		FS.ttlMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		FS.ttlMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	end

	FS.ttlFrame = CreateFrame("Frame", "ttlFrame", FS.ttlMover)
	FS.ttlFrame:SetPoint("CENTER", FS.ttlMover, "CENTER", 0, 0)
	FS.ttlFrame:SetAllPoints()

	FS.ttlFrame.text = FS.ttlFrame:CreateFontString("ttlFrameText", "ARTWORK", "GameFontNormal")
	FS.ttlFrame.text:SetFont(GameFontNormal:GetFont(), 12)
	FS.ttlFrame.text:SetJustifyH("CENTER")
	FS.ttlFrame.text:SetPoint("CENTER", FS.ttlFrame, "CENTER", 0, 0)
	FS.ttlFrame.text:SetTextColor(1, 1, 1, 1)
end

-- Creates the frames that hold the sniper training indicator
function FS:CreateSniperFrame()
	if not FS.textureList then FS.textureList = {} end
	
	-- Anchor Frame for the sniper training texture
	FS.sniperMover = CreateFrame("Frame","sniperMover", UIParent)
	FS.sniperMover:SetFrameStrata("BACKGROUND")
	FS.sniperMover:SetWidth(40)
	FS.sniperMover:SetHeight(40)
	FS.sniperMover:SetScale(FaceShooterdb.scaleSniper/100)
	FS.sniperMover:SetAlpha(FaceShooterdb.alphaSniper/100)
	FS.sniperMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,})
	FS.sniperMover:SetMovable(true)
	FS.sniperMover:SetClampedToScreen(true)
	FS.sniperMover:SetPoint("CENTER", 0, 0)

	-- Hide anchor frame if sniper training indicator is locked
	if FaceShooterdb.locked then
		FS.sniperMover:SetBackdropColor(0, 0, 0, 0)
		FS.sniperMover:EnableMouse(false)
		FS.sniperMover:SetScript("OnMouseDown", nil)
		FS.sniperMover:SetScript("OnMouseUp", nil)
		FS.sniperMover:SetScript("OnDragStop", nil)

	-- Otherwise show and make it moveable
	else
		FS.sniperMover:SetBackdropColor(0, 0, 0, .4)
		FS.sniperMover:EnableMouse(true)
		FS.sniperMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		FS.sniperMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		FS.sniperMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	end

	-- Setup the frame for the sniper training texture
	FS.sniperFrame = CreateFrame("Frame","sniperFrame", sniperMover)
	FS.sniperFrame:SetWidth(32)
	FS.sniperFrame:SetHeight(32)
	FS.sniperFrame:SetPoint("CENTER", 0, 0)
	FS.sniperFrame.texture = FS.sniperFrame:CreateTexture(nil,"BACKGROUND")
	FS.sniperFrame.texture:SetTexture(nil)
	FS.sniperFrame.texture:ClearAllPoints()
	FS.sniperFrame.texture:SetAllPoints(FS.sniperFrame)
	FS.textureList["sniperFrame"] = FS.sniperFrame.texture
end

-- Creates the frames that hold the chimera indicator
function FS:CreateChimeraFrame()
	if not FS.textureList then FS.textureList = {} end
	
	-- Anchor Frame for the chimera frame texture
	FS.chimeraMover = CreateFrame("Frame","chimeraMover", UIParent)
	FS.chimeraMover:SetFrameStrata("BACKGROUND")
	FS.chimeraMover:SetWidth(40)
	FS.chimeraMover:SetHeight(40)
	FS.chimeraMover:SetScale(FaceShooterdb.scaleChimera/100)
	FS.chimeraMover:SetAlpha(FaceShooterdb.alphaChimera/100)
	FS.chimeraMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,})
	FS.chimeraMover:SetMovable(true)
	FS.chimeraMover:SetClampedToScreen(true)
	FS.chimeraMover:SetPoint("CENTER", 0, 0)

	-- Hide anchor frame if sniper training indicator is locked
	if FaceShooterdb.locked then
		FS.chimeraMover:SetBackdropColor(0, 0, 0, 0)
		FS.chimeraMover:EnableMouse(false)
		FS.chimeraMover:SetScript("OnMouseDown", nil)
		FS.chimeraMover:SetScript("OnMouseUp", nil)
		FS.chimeraMover:SetScript("OnDragStop", nil)

	-- Otherwise show and make it moveable
	else
		FS.chimeraMover:SetBackdropColor(0, 0, 0, .4)
		FS.chimeraMover:EnableMouse(true)
		FS.chimeraMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		FS.chimeraMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		FS.chimeraMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	end

	-- Setup the frame for the chimera training texture
	FS.chimeraFrame = CreateFrame("Frame","chimeraFrame", chimeraMover)
	FS.chimeraFrame:SetWidth(32)
	FS.chimeraFrame:SetHeight(32)
	FS.chimeraFrame:SetPoint("CENTER", 0, 0)
	FS.chimeraFrame.texture = FS.chimeraFrame:CreateTexture(nil,"BACKGROUND")
	FS.chimeraFrame.texture:SetTexture(nil)
	FS.chimeraFrame.texture:ClearAllPoints()
	FS.chimeraFrame.texture:SetAllPoints(FS.chimeraFrame)
	FS.textureList["chimeraFrame"] = FS.chimeraFrame.texture

	FS.chimeraFrame.text = FS.chimeraFrame:CreateFontString("chimeraFrameText", "ARTWORK", "GameFontNormal")
	FS.chimeraFrame.text:SetFont(GameFontNormal:GetFont(), 10)
	FS.chimeraFrame.text:SetJustifyH("CENTER")
	FS.chimeraFrame.text:SetJustifyV("TOP")
	FS.chimeraFrame.text:SetPoint("CENTER", FS.chimeraFrame, "CENTER", 0, 0)
	FS.chimeraFrame.text:SetTextColor(1, 0.15, 0.15, 1)
end

-- Creates the frames that hold the aspects indicator
function FS:CreateAspectsFrame()
	if not FS.textureList then FS.textureList = {} end
	
	-- Anchor Frame for the aspects texture
	FS.aspectsMover = CreateFrame("Frame","aspectsMover", UIParent)
	FS.aspectsMover:SetFrameStrata("BACKGROUND")
	FS.aspectsMover:SetWidth(40)
	FS.aspectsMover:SetHeight(40)
	FS.aspectsMover:SetScale(FaceShooterdb.scaleAspects/100)
	FS.aspectsMover:SetAlpha(FaceShooterdb.alphaAspects/100)
	FS.aspectsMover:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,})
	FS.aspectsMover:SetMovable(true)
	FS.aspectsMover:SetClampedToScreen(true)
	FS.aspectsMover:SetPoint("CENTER", 0, 0)

	-- Hide anchor frame if aspects training indicator is locked
	if FaceShooterdb.locked then
		FS.aspectsMover:SetBackdropColor(0, 0, 0, 0)
		FS.aspectsMover:EnableMouse(false)
		FS.aspectsMover:SetScript("OnMouseDown", nil)
		FS.aspectsMover:SetScript("OnMouseUp", nil)
		FS.aspectsMover:SetScript("OnDragStop", nil)

	-- Otherwise show and make it moveable
	else
		FS.aspectsMover:SetBackdropColor(0, 0, 0, .4)
		FS.aspectsMover:EnableMouse(true)
		FS.aspectsMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		FS.aspectsMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		FS.aspectsMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	end

	-- Setup the frame for the aspects training texture
	FS.aspectsFrame = CreateFrame("Frame","aspectsFrame", aspectsMover)
	FS.aspectsFrame:SetWidth(32)
	FS.aspectsFrame:SetHeight(32)
	FS.aspectsFrame:SetPoint("CENTER", 0, 0)
	FS.aspectsFrame.texture = FS.aspectsFrame:CreateTexture(nil,"BACKGROUND")
	FS.aspectsFrame.texture:SetTexture(nil)
	FS.aspectsFrame.texture:ClearAllPoints()
	FS.aspectsFrame.texture:SetAllPoints(FS.aspectsFrame)
	FS.textureList["aspectsFrame"] = FS.aspectsFrame.texture
end

-- Find a textpattern in a tooltip
function FS:PatternInTooltip(pattern, skip, complete)
	local numLines = FaceShooterItemTooltip:NumLines()
	local found = 0
	if skip == nil then skip = 0 end
	if not numLines then return nil end
	local i = 1
	for i = 1, numLines do
		line = getglobal("FaceShooterItemTooltipTextLeft"..i):GetText()
		if complete and line == pattern then
			if found == skip then return true
			else found = found + 1
			end
		elseif not complete and line and string.find(line, pattern, 1, true) then
			if found == skip then return line
			else found = found + 1
			end
		end
		line = getglobal("FaceShooterItemTooltipTextRight"..i):GetText()
		if complete and line == pattern then
			if found == skip then return true
			else found = found + 1
			end
		elseif not complete and line and string.find(line, pattern, 1, true) then
			if found == skip then return line
			else found = found + 1
			end
		end
	end
	return false
end

-- Scans Player equipment for required stats
function FS:ScanItems()
	local readable, messaged = true, false

	-- check if any of the relevant items have been changed
	local index = 0
	local changed = false
	if not FS.equipment then FS.equipment = {} end
	for index = 0, 18 do
		if FS.equipment[index] ~= GetInventoryItemLink("player", index) then
			changed = true
			FS.equipment[index] = GetInventoryItemLink("player", index)
		end
	end
	if not changed then return false end
	-- Ammo
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 0)
	-- Ammo DPS
	local ammoDPS = FS:PatternInTooltip(FS.L["ADDS"])
	if ammoDPS then
		FS.data.ammoDPS = ""
		for index in string.gmatch(ammoDPS, "%d+%p?") do
			FS.data.ammoDPS = FS.data.ammoDPS..index
		end
	elseif ammoDPS == nil then
		print("DEBUG: Face Shooter couldn't find your ammo tooltip.")
	else
		FS.data.ammoDPS = 1
		if FS.data.checkTooltipIndex >= 0 then
			FS.data.checkTooltipIndex = FS.data.checkTooltipIndex - 1
			readable = false
		elseif not messaged then
			print("DEBUG: Face Shooter couldn't read your ammo tooltip properly! Ammo dps set to 1. If you want to help fixing this bug report your locale "..GetLocale().." and any typos in the word \""..FS.L["ADDS"].."\" (adds) at WoWInterface.com.")
			messaged, readable = true, false
		end
	end
	
	-- Head
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 1)
	-- Head Metagem
	local critMeta = FS:PatternInTooltip(FS.L["CRIT_META"])
	if critMeta then FS.data.critMeta = true end -- Note: FaceShooter assumes meta requirements are met (no check)!
	-- Set Item
	FS.data.t8Items = 0
	FS.data.t9Items = 0
	if FS:PatternInTooltip(FS.L["T8"]) then FS.data.t8Items = FS.data.t8Items + 1 end
	if FS:PatternInTooltip(FS.L["T9"]) then FS.data.t9Items = FS.data.t9Items + 1 end

	-- Shoulder
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 3)
	-- Set Item
	if FS:PatternInTooltip(FS.L["T8"]) then FS.data.t8Items = FS.data.t8Items + 1 end
	if FS:PatternInTooltip(FS.L["T9"]) then FS.data.t9Items = FS.data.t9Items + 1 end
	
	-- Chest
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 5)
	-- Set Item
	if FS:PatternInTooltip(FS.L["T8"]) then FS.data.t8Items = FS.data.t8Items + 1 end
	if FS:PatternInTooltip(FS.L["T9"]) then FS.data.t9Items = FS.data.t9Items + 1 end

	-- Legs
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 7)
	-- Set Item
	if FS:PatternInTooltip(FS.L["T8"]) then FS.data.t8Items = FS.data.t8Items + 1 end
	if FS:PatternInTooltip(FS.L["T9"]) then FS.data.t9Items = FS.data.t9Items + 1 end

	-- Hands
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 10)
	-- Set Item
	if FS:PatternInTooltip(FS.L["T8"]) then FS.data.t8Items = FS.data.t8Items + 1 end
	if FS:PatternInTooltip(FS.L["T9"]) then FS.data.t9Items = FS.data.t9Items + 1 end

	-- Weapon
	FaceShooterItemTooltip:ClearLines()
	FaceShooterItemTooltip:SetInventoryItem("player", 18)

	-- Weapon Speed
	local weaponSpeed = FS:PatternInTooltip(FS.L["SPEED"])
	if weaponSpeed then 
		local strStart = string.find(weaponSpeed, FS.L["SPEED"]) + #FS.L["SPEED"] + 1
		FS.data.weaponSpeed = string.sub(weaponSpeed, strStart)
	elseif weaponSpeed == nil then
		print("DEBUG: Face Shooter couldn't find your weapon tooltip.")
	else
		FS.data.weaponSpeed = 2.8
		if FS.data.checkTooltipIndex >= 0 then
			if readable then
				FS.data.checkTooltipIndex = FS.data.checkTooltipIndex - 1
				readable = false
			end
		elseif not messaged then
			print("DEBUG: Face Shooter couldn't read your weapon tooltip properly! Weapon speed set to 2.8. If you want to help fixing this bug report your locale "..GetLocale().." and any typos in the word \""..FS.L["SPEED"].."\" (speed) at WoWInterface.com.")
			messaged, readable = true, false
		end
	end
	-- Weapon DPS
	local weaponDPS = FS:PatternInTooltip(FS.L["DMG"])
	if weaponDPS and string.find(weaponDPS, " - ") then
		local lowerEnd, upperEnd
		for index in string.gmatch(weaponDPS, "%d+") do
			if not lowerEnd then lowerEnd = index
			elseif not upperEnd then upperEnd = index
			end
		end
		if tonumber(upperEnd) == nil then upperEnd = lowerEnd end
		FS.data.minDMG = lowerEnd
		FS.data.maxDMG = upperEnd
		FS.data.weaponDPS = (lowerEnd + upperEnd) / (2 * FS.data.weaponSpeed)
		if not tonumber(FS.data.minDMG) and not messaged then
			print("DEBUG: Face Shooter couldn't read your weapon tooltip properly! Min and max damage set to 1. If you want to help fixing this bug report your locale "..GetLocale().." at WoWInterface.com.")
		end
	elseif weaponDPS == nil then
		print("DEBUG: Face Shooter couldn't find your weapon tooltip.")
	else
		FS.data.weaponDPS = 1
		FS.data.minDMG = 1
		FS.data.maxDMG = 1
		if FS.data.checkTooltipIndex >= 0 then
			if readable then
				FS.data.checkTooltipIndex = FS.data.checkTooltipIndex - 1
				readable = false
			end
		elseif not messaged then
			print("DEBUG: Face Shooter couldn't read your weapon tooltip properly! Weapon DPS set to 1. If you want to help fixing this bug report your locale "..GetLocale().." and any typos in the word \""..FS.L["DMG"].."\" (damage) at WoWInterface.com.")
			messaged, readbale = true, false
		end
	end
end

-- Checks is the given creatureType is trackable or not
function FS:IsTrackable(creatureType)
	if creatureType == FS.L["BEAST"] or
		creatureType == FS.L["DEMON"] or
		creatureType == FS.L["DRAGONKIN"] or 
		creatureType == FS.L["ELEMENTAL"] or 
		creatureType == FS.L["GIANT"] or
		creatureType == FS.L["HUMANOID"] or
		creatureType == FS.L["UNDEAD"] then
		return true
	end
	return false
end

-- Reads players Glyphs, Talents etc
function FS:ReInitialize()
	-- Find out which talents are available to the player
	local tab = 0
	local empty = true
	for tab = 1, 3 do
		local numTalents = GetNumTalents(tab)
		if numTalents > 0 then empty = false end
		local talent = 0
		for talent = 1, numTalents do
			if not FS.talents then FS.talents = {} end
			local nameTalent, _, _, _, currentRank, _, _, _ = GetTalentInfo(tab, talent)
			FS.talents[nameTalent] = currentRank
		end
	end
	
	if not empty then
	-- Using Talent IDs so the AddOn works in diffrent languages
		FS.tn = {
			-- BM
			["Improved Aspect of the Hawk"] = GetTalentInfo(1, 1),
			["Endurance Training"] = GetTalentInfo(1, 2),
			["Focused Fire"] = GetTalentInfo(1, 3),
			["Improved Aspect of the Monkey"] = GetTalentInfo(1, 4),
			["Thick Hide"] = GetTalentInfo(1, 5),
			["Improved Revive Pet"] = GetTalentInfo(1, 6),
			["Pathfinding"] = GetTalentInfo(1, 7),
			["Aspect Mastery"] = GetTalentInfo(1, 8),
			["Unleashed Fury"] = GetTalentInfo(1, 9),
			["Improved Mend Pet"] = GetTalentInfo(1, 10),
			["Ferocity"] = GetTalentInfo(1, 11),
			["Spirit Bond"] = GetTalentInfo(1, 12),
			["Intimidation"] = GetTalentInfo(1, 13),
			["Bestial Discipline"] = GetTalentInfo(1, 14),
			["Animal Handler"] = GetTalentInfo(1, 15),
			["Frenzy"] = GetTalentInfo(1, 16),
			["Ferocious Inspiration"] = GetTalentInfo(1, 17),
			["Bestial Wrath"] = GetTalentInfo(1, 18),
			["Catlike Reflexes"] = GetTalentInfo(1, 19),
			["Invigoration"] = GetTalentInfo(1, 20),
			["Serpent's Swiftness"] = GetTalentInfo(1, 21),
			["Longevity"] = GetTalentInfo(1, 22),
			["The Beast Within"] = GetTalentInfo(1, 23),
			["Cobra Strikes"] = GetTalentInfo(1, 24),
			["Kindred Spirits"] = GetTalentInfo(1, 25),
			["Beast Mastery"] = GetTalentInfo(1, 26),
			-- MM
			["Improved Concussive Shot"] = GetTalentInfo(2, 1),
			["Focused Aim"] = GetTalentInfo(2, 2),
			["Lethal Shots"] = GetTalentInfo(2, 3),
			["Careful Aim"] = GetTalentInfo(2, 4),
			["Improved Hunter's Mark"] = GetTalentInfo(2, 5),
			["Mortal Shots"] = GetTalentInfo(2, 6),
			["Go for the Throat"] = GetTalentInfo(2, 7),
			["Improved Arcane Shot"] = GetTalentInfo(2, 8),
			["Aimed Shot"] = GetTalentInfo(2, 9),
			["Rapid Killing"] = GetTalentInfo(2, 10),
			["Improved Stings"] = GetTalentInfo(2, 11),
			["Efficiency"] = GetTalentInfo(2, 12),
			["Concussive Barrage"] = GetTalentInfo(2, 13),
			["Readiness"] = GetTalentInfo(2, 14),
			["Barrage"] = GetTalentInfo(2, 15),
			["Combat Expirience"] = GetTalentInfo(2, 16),
			["Ranged Weapon Specialization"] = GetTalentInfo(2, 17),
			["Piercing Shots"] = GetTalentInfo(2, 18),
			["Trueshot Aura"] = GetTalentInfo(2, 19),
			["Improved Barrage"] = GetTalentInfo(2, 20),
			["Master Marksman"] = GetTalentInfo(2, 21),
			["Rapid Recuperation"] = GetTalentInfo(2, 22),
			["Wild Quiver"] = GetTalentInfo(2, 23),
			["Silencing Shot"] = GetTalentInfo(2, 24),
			["Improved Steady Shot"] = GetTalentInfo(2, 25),
			["Marked for Death"] = GetTalentInfo(2, 26),
			["Chimera Shot"] = GetTalentInfo(2, 27),
			-- SV
			["Improved Tracking"] = GetTalentInfo(3, 1),
			["Hawk Eye"] = GetTalentInfo(3, 2),
			["Savage Strikes"] = GetTalentInfo(3, 3),
			["Surefooted"] = GetTalentInfo(3, 4),
			["Entrapment"] = GetTalentInfo(3, 5),
			["Trap Mastery"] = GetTalentInfo(3, 6),
			["Survival Instincts"] = GetTalentInfo(3, 7),
			["Survivalist"] = GetTalentInfo(3, 8),
			["Scatter Shot"] = GetTalentInfo(3, 9),
			["Deflection"] = GetTalentInfo(3, 10),
			["Survival Tactics"] = GetTalentInfo(3, 11),
			["T.N.T."] = GetTalentInfo(3, 12),
			["Lock and Load"] = GetTalentInfo(3, 13),
			["Hunter vs. Wild"] = GetTalentInfo(3, 14),
			["Killer Instinct"] = GetTalentInfo(3, 15),
			["Counterattack"] = GetTalentInfo(3, 16),
			["Lightning Reflexes"] = GetTalentInfo(3, 17),
			["Resourcefulness"] = GetTalentInfo(3, 18),
			["Expose Weakness"] = GetTalentInfo(3, 19),
			["Wyvern Sting"] = GetTalentInfo(3, 20),
			["Thrill of the Hunt"] = GetTalentInfo(3, 21),
			["Master Tactician"] = GetTalentInfo(3, 22),
			["Noxious Stings"] = GetTalentInfo(3, 23),
			["Point of No Escape"] = GetTalentInfo(3, 24),
			["Black Arrow"] = GetTalentInfo(3, 25),
			["Sniper Training"] = GetTalentInfo(3, 26),
			["Hunting Party"] = GetTalentInfo(3, 27),
			["Explosive Shot"] = GetTalentInfo(3, 28)
		}
	end

	-- Get player Glyphs
	FS.usedGlyphs = {}
	for index = 1, 6 do
		local _, _, glyphSpell, _ = GetGlyphSocketInfo(index, GetActiveTalentGroup())
		if glyphSpell == 56832 then FS.usedGlyphs["Serpent Sting"] = true end
		if glyphSpell == 63065 then FS.usedGlyphs["Chimera Shot"] = true end
		if glyphSpell == 56826 then FS.usedGlyphs["Steady Shot"] = true end
		if glyphSpell == 63067 then FS.usedGlyphs["Kill Shot"] = true end
		if glyphSpell == 63066 then FS.usedGlyphs["Explosive Shot"] = true end
		if glyphSpell == 56829 then FS.usedGlyphs["Hunter's Mark"] = true end
		if glyphSpell == 56824 then FS.usedGlyphs["Aimed Shot"] = true end
		if glyphSpell == 56836 then FS.usedGlyphs["Multi-Shot"] = true end
		if glyphSpell == 56842 then FS.usedGlyphs["Trueshot Aura"] = true end
	end

	-- Get item stats
	FS:ScanItems()
	
	-- Get the players GUID
	if not FS.data.myGUID then FS.data.myGUID = UnitGUID("player") end
	
	-- Check if player is mounted, in a vehicle and if he´s in a grp
	FS.data.onMount = IsMounted()
	FS.data.inVehicle = UnitInVehicle("player")
	if UnitInRaid("player") then
		FS.data.numPlayers = GetNumRaidMembers()
		FS.data.partyStatus = "raid"
	elseif GetNumPartyMembers() > 0 then
		FS.data.numPlayers = GetNumPartyMembers()
		FS.data.partyStatus = "party"
	else
		FS.data.numPlayers = 1
		FS.data.partyStatus = "solo"
	end

	-- Show/hide frames that ain´t eligible for other specs
	if not empty then
		if FS.sniperMover and FS.talents[FS.tn["Sniper Training"]] == 0 then
			FS.sniperMover:Hide()
			FS.sniperFrame:Hide()
		elseif FS.talents[FS.tn["Sniper Training"]] > 0 and FaceShooterdb.enableSniper then
			if FS.sniperMover then
				FS.sniperMover:Show()
				if FS:ShowCheck() then FS.sniperFrame:Show() end
			else
				FS:CreateSniperFrame()
			end
		end
		if FS.chimeraMover and FS.talents[FS.tn["Chimera Shot"]] == 0 then
			FS.chimeraMover:Hide()
			FS.chimeraFrame:Hide()
		elseif FS.talents[FS.tn["Chimera Shot"]] > 0 and FaceShooterdb.enableChimera then
			if FS.chimeraMover then
				FS.chimeraMover:Show()
				if FS:ShowCheck() then FS.chimeraFrame:Show() end
			else
				FS:CreateChimeraFrame()
			end
		end
	end
end

-- Checks wether conditions to show FS frames are met
function FS:ShowCheck()
	-- if player has no target, target is friendly, target is dead or a player character
	if UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 or UnitIsPlayer("target") then
		return false
	-- if player is in raid and showInRaid is false or player in party and showInParty is false etc.
	elseif (FS.data.partyStatus == "raid" and not FaceShooterdb.showInRaid) or (FS.data.partyStatus == "party" and not FaceShooterdb.showInParty) or (FS.data.partyStatus == "solo" and not FaceShooterdb.showWhenSolo) then
		return false
	-- if player is mounted or in a vehicle
	elseif FS.data.onMount or FS.data.inVehicle then
		return false
	-- if target level is boss below 70
	elseif UnitLevel("target") > 0 and UnitLevel("target") < 70 then
		return false
	else
		return true
	end
end