local cb_lock, cb_raid, cb_party, cb_solo
local cb_shots, sl_scale_shots, sl_alpha_shots, cb_ihm, cb_ias, cb_wlnl, cb_dm, cb_siss, sl_minHM_shots, sl_maxWaitDelay_shots
local cb_TTL, sl_scale_TTL, sl_alpha_TTL, cb_practise
local cb_aspects, sl_scale_aspects, sl_alpha_aspects, sl_min_aspects, sl_max_aspects
local cb_sniper, sl_scale_sniper, sl_alpha_sniper
local cb_chimera, sl_scale_chimera, sl_alpha_chimera

-- Debug function options
function FS:Debug(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)")
	if command == "stats" then
		if not FS.statsFrame then
			FS:CreateStatsFrame()
--			FS:GetCombatStats()
		elseif FS.statsFrame:IsVisible() then
			FS.statsFrame:Hide()
		else
			FS.statsFrame:Show()
		end
	elseif command == "feedback" then
		if not FS.calcFeedback then
			FS.calcFeedback = true
			print("DEBUG: Shot damage deviation feedback turned on")
		else
			FS.calcFeedback = false
			print("DEBUG: Shot damage deviation feedback turned off")
		end
	end
end

-- Setup function to toggle movable frames on/off
function FS:ToggleLocked()
	if FaceShooterdb.locked then
		FaceShooterdb.locked = false
		print("FS: Face Shooter frames unlocked.")
		if FS.shotsMover then
			FS.shotsMover:SetBackdropColor(0, 0, 0, .4)
			FS.shotsMover:EnableMouse(true)
			FS.shotsMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
			FS.shotsMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
			FS.shotsMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		end
		if FS.sniperMover then
			FS.sniperMover:SetBackdropColor(0, 0, 0, .4)
			FS.sniperMover:EnableMouse(true)
			FS.sniperMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
			FS.sniperMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
			FS.sniperMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		end
		if FS.chimeraMover then
			FS.chimeraMover:SetBackdropColor(0, 0, 0, .4)
			FS.chimeraMover:EnableMouse(true)
			FS.chimeraMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
			FS.chimeraMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
			FS.chimeraMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		end
		if FS.ttlMover then
			FS.ttlMover:SetBackdropColor(0, 0, 0, .4)
			FS.ttlMover:EnableMouse(true)
			FS.ttlMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
			FS.ttlMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
			FS.ttlMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		end
		if FS.aspectsMover then
			FS.aspectsMover:SetBackdropColor(0, 0, 0, .4)
			FS.aspectsMover:EnableMouse(true)
			FS.aspectsMover:SetScript("OnMouseDown", function(self) self:StartMoving() end)
			FS.aspectsMover:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
			FS.aspectsMover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		end
	else
		print("FS: Face Shooter frames locked.")
		FaceShooterdb.locked = true
		if FS.shotsMover then
			FS.shotsMover:SetBackdropColor(0, 0, 0, 0)
			FS.shotsMover:EnableMouse(false)
			FS.shotsMover:SetScript("OnMouseDown", nil)
			FS.shotsMover:SetScript("OnMouseUp", nil)
			FS.shotsMover:SetScript("OnDragStop", nil)
		end
		if FS.sniperMover then
			FS.sniperMover:SetBackdropColor(0, 0, 0, 0)
			FS.sniperMover:EnableMouse(false)
			FS.sniperMover:SetScript("OnMouseDown", nil)
			FS.sniperMover:SetScript("OnMouseUp", nil)
			FS.sniperMover:SetScript("OnDragStop", nil)
		end
		if FS.chimeraMover then
			FS.chimeraMover:SetBackdropColor(0, 0, 0, 0)
			FS.chimeraMover:EnableMouse(false)
			FS.chimeraMover:SetScript("OnMouseDown", nil)
			FS.chimeraMover:SetScript("OnMouseUp", nil)
			FS.chimeraMover:SetScript("OnDragStop", nil)
		end
		if FS.ttlMover then
			FS.ttlMover:SetBackdropColor(0, 0, 0, 0)
			FS.ttlMover:EnableMouse(false)
			FS.ttlMover:SetScript("OnMouseDown", nil)
			FS.ttlMover:SetScript("OnMouseUp", nil)
			FS.ttlMover:SetScript("OnDragStop", nil)
		end
		if FS.aspectsMover then
			FS.aspectsMover:SetBackdropColor(0, 0, 0, 0)
			FS.aspectsMover:EnableMouse(false)
			FS.aspectsMover:SetScript("OnMouseDown", nil)
			FS.aspectsMover:SetScript("OnMouseUp", nil)
			FS.aspectsMover:SetScript("OnDragStop", nil)
		end
	end
end

-- Setup function to toggle frame showing in raid on/off
function FS:ToggleShowInRaid()
	if FaceShooterdb.showInRaid then
		print("FS: Not showing frames in raid.")
		FaceShooterdb.showInRaid = false
		if FS.data.partyStatus == "raid" then FS:ChangeFrameVisibility(false) end
	else
		print("FS: Showing frames in raid.")
		FaceShooterdb.showInRaid = true
		if FS.data.partyStatus == "raid" then FS:ChangeFrameVisibility(FS:ShowCheck()) end
	end
end

-- Setup function to toggle frame showing in party on/off
function FS:ToggleShowInParty()
	if FaceShooterdb.showInParty then
		print("FS: Not showing frames in party.")
		FaceShooterdb.showInParty = false
		if FS.data.partyStatus == "party" then FS:ChangeFrameVisibility(false) end
	else
		print("FS: Showing frames in party.")
		FaceShooterdb.showInParty = true
		if FS.data.partyStatus == "party" then FS:ChangeFrameVisibility(FS:ShowCheck()) end
	end
end

-- Setup function to toggle frame showing when solo on/off
function FS:ToggleShowWhenSolo()
	if FaceShooterdb.showWhenSolo then
		print("FS: Not showing frames when solo.")
		FaceShooterdb.showWhenSolo = false
		if FS.data.partyStatus == "solo" then FS:ChangeFrameVisibility(false) end
	else
		print("FS: Showing frames when solo.")
		FaceShooterdb.showWhenSolo = true
		if FS.data.partyStatus == "solo" then FS:ChangeFrameVisibility(FS:ShowCheck()) end
	end
end

-- Setup function to toggle the new display method for the shot frame on/off
function FS:ToggleDisplayMethod()
	if FaceShooterdb.displayMethod == "default" then
		FaceShooterdb.displayMethod = "rotating"
		print("FS: Rotating display method enabled")
		if FS.cooldownFrame then FS.cooldownFrame:Hide() end
		if FS.shotsMover then FS.shotsMover:SetWidth(100) end
		if not FS.lastShot then
			FS.lastShot = CreateFrame("Frame","lastShot", shotsMover)	-- Setup the frame for the last shot texture (only required for rotating display method)
			FS.lastShot:SetWidth(32)
			FS.lastShot:SetHeight(32)
			FS.lastShot:SetAlpha(FaceShooterdb.alphaShots/100)
			FS.lastShot:SetPoint("CENTER", 0, 0)
			FS.lastShot.texture = FS.lastShot:CreateTexture(nil,"BACKGROUND")
			FS.lastShot.texture:SetTexture(nil)
			FS.lastShot.texture:ClearAllPoints()
			FS.lastShot.texture:SetAllPoints(FS.lastShot)
			FS.textureList["lastShot"] = FS.lastShot.texture
		end
	else
		FaceShooterdb.displayMethod = "default"
		print("FS: Default display method enabled")
		if FS.lastShot then FS.lastShot:Hide() end
		FS.textureList["lastShot"] = nil
		if FS.shotsMover then FS.shotsMover:SetWidth(40) end
		if FS.nextShot then FS.nextShot:SetPoint("CENTER", 0, 0) end
		if not FS.cooldownFrame then
			FS.cooldownFrame = CreateFrame("Cooldown","cooldownFrame", FS.nextShot)	-- Cooldown frame - only needed for the default display method
			FS.cooldownFrame:SetHeight(32)
			FS.cooldownFrame:SetWidth(32)
			FS.cooldownFrame:ClearAllPoints()
			FS.cooldownFrame:SetPoint("CENTER", nextShot, "CENTER", 0, 0)
		end
	end
end

-- Setup function to toggle the shots frame on/off
function FS:ToggleShots()
	if FaceShooterdb.enableShots then
		FaceShooterdb.enableShots = false
		print("FS: Face Shooter shots frame turned off.")
		FS.shotsMover:Hide()
		FS.nextShot:Hide()
		if FaceShooterdb.displayMethod == "rotating" then FS.lastShot:Hide() end
	else
		FaceShooterdb.enableShots = true
		print("FS: Face Shooter shots frame turned on.")
		if FS.shotsMover then
			FS.shotsMover:Show()
			if FS.data.unitGUID then FS.nextShot:Show() end
			if FS.data.unitGUID and FaceShooterdb.displayMethod == "rotating" then FS.lastShot:Show() end
		else
			FS:CreateShotsFrame()
		end
		if FS.data.unitGUID then FS:Scheduler() end
	end
end

-- Setup function to toggle the TTL frame on/off
function FS:ToggleTTL()
	if FaceShooterdb.enableTTL then
		FaceShooterdb.enableTTL = false
		print("FS: Face Shooter TTL frame turned off.")
		FS.ttlMover:Hide()
	else
		FaceShooterdb.enableTTL = true
		print("FS: Face Shooter TTL frame turned on.")
		if FS.ttlMover then
			if FS.data.unitGUID then FS.ttlMover:Show() end
		else
			FS:CreateTTLFrame()
		end
	end
end

-- Setup function to toggle practise mode on/off
function FS:TogglePractise()
	if FaceShooterdb.practiseMode then
		FaceShooterdb.practiseMode = false
		print("FS: Face Shooter practise mode turned off.")
	else
		FaceShooterdb.practiseMode = true
		print("FS: Face Shooter practise mode turned on.")
	end
end

-- Setup function to toggle the sniper training frame on/off
function FS:ToggleSniper()
	if FaceShooterdb.enableSniper then
		FaceShooterdb.enableSniper = false
		print("FS: Face Shooter sniper frame turned off.")
		FS.sniperMover:Hide()
		FS.sniperFrame:Hide()
	else
		FaceShooterdb.enableSniper = true
		print("FS: Face Shooter sniper frame turned on.")
		if FS.sniperMover and FS.talents[FS.tn["Sniper Training"]] > 0 then
			FS.sniperMover:Show()
			if FS:ShowCheck() then FS.sniperFrame:Show() end
		elseif not FS.sniperMover then
			FS:CreateSniperFrame()
			if FS.talents[FS.tn["Sniper Training"]] == 0 then FS.sniperFrame:Hide() end
		end
	end
end

-- Setup function to toggle the chimera frame on/off
function FS:ToggleChimera()
	if FaceShooterdb.enableChimera then
		FaceShooterdb.enableChimera = false
		print("FS: Face Shooter chimera frame turned off.")
		FS.chimeraMover:Hide()
		FS.chimeraFrame:Hide()
	else
		FaceShooterdb.enableChimera = true
		print("FS: Face Shooter chimera frame turned on.")
		if FS.chimeraMover and FS.talents[FS.tn["Chimera Shot"]] > 0 then
			FS.chimeraMover:Show()
			if FS:ShowCheck() then FS.chimeraFrame:Show() end
		elseif not FS.chimeraMover then
			FS:CreateChimeraFrame()
			if FS.talents[FS.tn["Chimera Shot"]] == 0 then FS.chimeraFrame:Hide() end
		end
	end
end

-- Setup function to toggle the aspects frame on/off
function FS:ToggleAspects()
	if FaceShooterdb.enableAspects then
		FaceShooterdb.enableAspects = false
		print("FS: Face Shooter aspects frame turned off.")
		FS.aspectsMover:Hide()
	else
		FaceShooterdb.enableAspects = true
		print("FS: Face Shooter aspects frame turned on.")
		if FS.aspectsMover then
			if FS.data.unitGUID then FS.aspectsMover:Show() end
		else
			FS:CreateAspectsFrame()
		end
	end
end

-- Setup function to make FS not suggest Hunter's Mark if targets TTL is less than the given timespan
function FS:SetMinHM(arg1, arg2)
	if arg2 == nil or tonumber(arg2) == nil or tonumber(arg2) < 0 then
		print("FS: Minimum time to life needs to be a number greater or equal than 0.")
	else 
		FaceShooterdb.minHMTTL = tonumber(arg2)
		if arg1 == "slash" then print("FS: Minimum time to life for Face Shooter to suggest Hunter's Mark set to "..arg2.." seconds.") end
	end
end

-- Setup funtion to set for how long at most FS will wait for ES, CS and KS 
function FS:SetMaxWaitDelay(arg1, arg2)
	if arg2 == nil or arg2 == "" then
		print("FS: Wait delay is currently set to "..(FaceShooterdb.maxWaitDelay / 10)..".")
	elseif tonumber(arg2) == nil or tonumber(arg2) < 0 or tonumber(arg2) > 1.5 then
		print("FS: Wait delay must be a number between 0 and 1.5.")
	else 
		FaceShooterdb.maxWaitDelay = FS:Round(tonumber(arg2) * 10)
		if arg1 == "slash" then print("FS: Wait delay set to "..arg2.." seconds.") end
	end
end

-- Setup function to make FS not suggest Hunter's Mark at all
function FS:ToggleIgnoreHuntersMark()
	if FaceShooterdb.ignoreHuntersMark then
		FaceShooterdb.ignoreHuntersMark = false
		print("FS: Face Shooter will suggest Hunter's Mark in combat.")
	else
		FaceShooterdb.ignoreHuntersMark = true
		print("FS: Face Shooter will not suggest Hunter's Mark in combat.")
	end
end

-- Setup function to make FS not suggest Arcane Shot at all (MM ArPen Spec)
function FS:ToggleIgnoreAS()
	if FaceShooterdb.ignoreArcaneShot then
		FaceShooterdb.ignoreArcaneShot = false
		print("FS: Face Shooter will suggest Arcane Shot.")
	else
		FaceShooterdb.ignoreArcaneShot = true
		print("FS: Face Shooter will not suggest Arcane Shot.")
	end
end

-- Setup function to toggle between suggesting to weave spells between Explosive Shots or not
function FS:ToggleWeaveLnL()
	if FaceShooterdb.weaveLnL then
		FaceShooterdb.weaveLnL = false
		print("FS: Face Shooter will no longer suggest to weave in shots between Explosive Shot with Lock and Load active.")
	else
		FaceShooterdb.weaveLnL = true
		print("FS: Face Shooter will suggest to weave in shots between Explosive Shot with Lock and Load active.")
	end
end

-- Setup function to toggle between saving an ISS proc for Chimera Shot or not
function FS:ToggleSaveISS()
	if FaceShooterdb.saveISS then
		FaceShooterdb.saveISS = false
		print("FS: Face Shooter will no longer suggest to save improved steady shot procs for Chimera Shot.")
	else
		FaceShooterdb.saveISS = true
		print("FS: Face Shooter will suggest to save improved steady shot procs for Chimera Shot.")
	end
end

-- Set frame scale
function FS:SetFrameScale(frame, arg1, arg2)
	local _, _, value = string.find(arg2, "(%w+)%s?(.*)");
	if frame == "shots" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 then
			print("FS: Value is in percent and must be a number greater than 0 (currently set to "..FaceShooterdb.scaleShots.."%).")
		else
			if arg1 == "slash" then print("FS: scale set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.scaleShots = floor(tonumber(value))
			if FS.shotsMover then FS.shotsMover:SetScale((floor(tonumber(value)))/100) end
		end
	elseif frame == "ttl" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 then
			print("FS: Value is in percent and must be a number greater than 0 (currently set to "..FaceShooterdb.scaleTTL.."%).")
		else
			if arg1 == "slash" then print("FS: scale set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.scaleTTL = floor(tonumber(value))
			if FS.ttlMover then FS.ttlMover:SetScale((floor(tonumber(value)))/100) end
		end
	elseif frame == "sniper" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 then
			print("FS: Value is in percent and must be a number greater than 0 (currently set to "..FaceShooterdb.scaleSniper.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." scale set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.scaleSniper = floor(tonumber(value))
			if FS.sniperMover then FS.sniperMover:SetScale((floor(tonumber(value)))/100) end
		end
	elseif frame == "chimera" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 then
			print("FS: Value is in percent and must be a number greater than 0 (currently set to "..FaceShooterdb.scaleChimera.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." scale set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.scaleChimera = floor(tonumber(value))
			if FS.chimeraMover then FS.chimeraMover:SetScale((floor(tonumber(value)))/100) end
		end
	elseif frame == "aspects" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 then
			print("FS: Value is in percent and must be a number greater than 0 (currently set to "..FaceShooterdb.scaleAspects.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." scale set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.scaleAspects = floor(tonumber(value))
			if FS.aspectsMover then FS.aspectsMover:SetScale((floor(tonumber(value)))/100) end
		end
	else
		print("FS: Usage: /fs "..frame.." scale <value>.")
		print("FS: Value is in percent and must be a number greater than 0.")
	end
end

-- Set frame alpha
function FS:SetFrameAlpha(frame, arg1, arg2)
	local _, _, value = string.find(arg2, "(%w+)%s?(.*)");
	if frame == "shots" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 or tonumber(value) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.alphaShots.."%).")
		else
			if arg1 == "slash" then print("FS: alpha set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.alphaShots = floor(tonumber(value))
			if FS.shotsMover then FS.shotsMover:SetAlpha((floor(tonumber(value)))/100) end
		end
	elseif frame == "ttl" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 or tonumber(value) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.alphaTTL.."%).")
		else
			if arg1 == "slash" then print("FS: alpha set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.alphaTTL = floor(tonumber(value))
			if FS.ttlMover then FS.ttlMover:SetAlpha((floor(tonumber(value)))/100) end
		end
	elseif frame == "sniper" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 or tonumber(value) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.alphaSniper.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." alpha set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.alphaSniper = floor(tonumber(value))
			if FS.sniperMover then FS.sniperMover:SetAlpha((floor(tonumber(value)))/100) end
		end
	elseif frame == "chimera" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 or tonumber(value) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.alphaChimera.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." alpha set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.alphaChimera = floor(tonumber(value))
			if FS.chimeraMover then FS.chimeraMover:SetAlpha((floor(tonumber(value)))/100) end
		end
	elseif frame == "aspects" then
		if value == nil or tonumber(value) == nil or tonumber(value) < 0 or tonumber(value) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.alphaAspects.."%).")
		else
			if arg1 == "slash" then print("FS: "..frame.." alpha set to "..(floor(tonumber(value))).."%.") end
			FaceShooterdb.alphaAspects = floor(tonumber(value))
			if FS.aspectsMover then FS.aspectsMover:SetAlpha((floor(tonumber(value)))/100) end
		end
	else
		print("FS: Usage: /fs "..frame.." alpha <value>.")
		print("FS: Value is in percent and must be a number between 0 and 100.")
	end
end

-- Setup funtions for the shots frane
function FS:ShotOptions(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)")
	if command == "toggle" then
		FS:ToggleShots()
	elseif command == "scale" then
		FS:SetFrameScale("shots", "slash", args)
	elseif command == "alpha" then
		FS:SetFrameAlpha("shots", "slash", args)
	elseif command == "dm" then
		FS:ToggleDisplayMethod()
	elseif command == "ihm" then
		FS:ToggleIgnoreHuntersMark()
	elseif command == "ias" then	
		FS:ToggleIgnoreAS()
	elseif command == "wlnl" then
		FS:ToggleWeaveLnL()
	elseif command == "siss" then
		FS:ToggleSaveISS()
	elseif command == "minhm" then
		FS:SetMinHM("slash", args)
	elseif command == "mwd" then
		FS:SetMaxWaitDelay("slash", args)
	else
		print("")
		print("FS: /fs shots toggle - turn shots frame on/off.")
		print("FS: /fs shots scale <value> - set scale value for the shots frame.")
		print("FS: /fs shots alpha <value> - set alpha value for the shots frame.")
		print("FS: /fs shots dm - toggles between default and rotating shots display method.")
		print("FS: /fs shots minhm <seconds> - set a minimum TTL in seconds for Face Shooter to suggest Hunter's Mark.")
		print("FS: /fs shots mwd <seconds> - set a maxiumum wait delay for ES, CS and KS in seconds.")
		print("FS: /fs shots ihm - toggles between suggesting and not suggesting Hunter's Mark while in combat.")
		print("FS: /fs shots ias - toggles between suggesting and not suggesting Arcane Shot.")
		print("FS: /fs shots wlnl - toggles between weaving and not weaving shots between two LnLed Explosive Shots.")
		print("FS: /fs shots siss - toggles between saving improved steady shot procs for chimera and not doing so.")
	end
end

-- Setup functions for the TTL frame
function FS:TTLOptions(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)");
	if command == "toggle" then
		FS:ToggleTTL()
	elseif command == "practise" then
		FS:TogglePractise()
	elseif command == "scale" then
		FS:SetFrameScale("ttl", "slash", args)
	elseif command == "alpha" then
		FS:SetFrameAlpha("ttl", "slash", args)
	else
		print("")
		print("FS: /fs ttl toggle - turn ttl frame on/off.")
		print("FS: /fs ttl practise - toggle practise mode on/off (ignore TTL on dummies)")
		print("FS: /fs ttl scale <value> - set scale value for the ttl frame.")
		print("FS: /fs ttl alpha <value> - set alpha value for the ttl frame.")
	end
end

-- Setup functions for the aspects frame
function FS:AspectsOptions(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)");
	if command == "toggle" then
		FS:ToggleAspects()
	elseif command == "scale" then
		FS:SetFrameScale("aspects", "slash", args)
	elseif command == "alpha" then
		FS:SetFrameAlpha("aspects", "slash", args)
	elseif command == "min" then
		if args == nil or tonumber(args) == nil or tonumber(args) < 0 or tonumber(args) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.minThresholdAspects.."%).")
		elseif tonumber(args) >= FaceShooterdb.maxThresholdAspects then
			print("FS: Minimum threshold for Aspect of the Viper must be below maximum threshold. Maximum threshold is set to "..FaceShooterdb.maxThresholdAspects.."%.")
		else
			print("FS: Minimum threshold set to "..(floor(tonumber(args))).."%.")
			FaceShooterdb.minThresholdAspects = floor(tonumber(args))
		end
	elseif command == "minmenu" then
		FaceShooterdb.minThresholdAspects = floor(tonumber(args))
		sl_max_aspects:SetMinMaxValues(FaceShooterdb.minThresholdAspects, 100)
		getglobal(sl_max_aspects:GetName() .. "Low"):SetText(FaceShooterdb.minThresholdAspects.."%")
		getglobal(sl_max_aspects:GetName() .. "High"):SetText("100%")
		getglobal(sl_max_aspects:GetName() .. "Text"):SetText(FaceShooterdb.maxThresholdAspects.."%")
	elseif command == "max" then
		if args == nil or tonumber(args) == nil or tonumber(args) < 0 or tonumber(args) > 100 then
			print("FS: Value is in percent and must be a number between 0 and 100 (currently set to "..FaceShooterdb.maxThresholdAspects.."%).")
		elseif tonumber(args) <= FaceShooterdb.minThresholdAspects then
			print("FS: Maximum threshold for Aspect of the Viper must be above minimum threshold. Minimum threshold is set to "..FaceShooterdb.minThresholdAspects.."%.")
		else
			print("FS: Maximum threshold set to "..(floor(tonumber(args))).."%.")
			FaceShooterdb.maxThresholdAspects = floor(tonumber(args))
		end
	elseif command == "maxmenu" then
		FaceShooterdb.maxThresholdAspects = floor(tonumber(args))
		sl_min_aspects:SetMinMaxValues(0, FaceShooterdb.maxThresholdAspects)
		getglobal(sl_min_aspects:GetName() .. "Low"):SetText("0%")
		getglobal(sl_min_aspects:GetName() .. "High"):SetText(FaceShooterdb.maxThresholdAspects.."%")
		getglobal(sl_min_aspects:GetName() .. "Text"):SetText(FaceShooterdb.minThresholdAspects.."%")
	else
		print("")
		print("FS: /fs aspects toggle - turn aspects frame on/off.")
		print("FS: /fs aspects scale <value> - set scale value for the aspects frame.")
		print("FS: /fs aspects alpha <value> - set alpha value for the aspects frame.")
		print("FS: /fs aspects min <value> - set minimum threshold for Aspect of the Viper warning.")
		print("FS: /fs aspects max <value> - set maximum threshold for Aspect of the Viper warning.")
	end
end

-- Setup functions for the sniper frame
function FS:SniperOptions(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)");
	if command == "toggle" then
		FS:ToggleSniper()
	elseif command == "scale" then
		FS:SetFrameScale("sniper", "slash", args)
	elseif command == "alpha" then
		FS:SetFrameAlpha("sniper", "slash", args)
	else
		print("")
		print("FS: /fs sniper toggle - turn sniper frame on/off.")
		print("FS: /fs sniper scale <value> - set scale value for the sniper frame.")
		print("FS: /fs sniper alpha <value> - set alpha value for the sniper frame.")
	end
end

-- Setup functions for the chimera frame
function FS:ChimeraOptions(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)");
	if command == "toggle" then
		FS:ToggleChimera()
	elseif command == "scale" then
		FS:SetFrameScale("chimera", "slash", args)
	elseif command == "alpha" then
		FS:SetFrameAlpha("chimera", "slash", args)
	else
		print("")
		print("FS: /fs chimera toggle - turn chimera frame on/off.")
		print("FS: /fs chimera scale <value> - set scale value for the chimera frame.")
		print("FS: /fs chimera alpha <value> - set alpha value for the chimera frame.")
	end
end

-- Create the Config Frame
function FS:CreateConfigFrame()

	---------------------
	-- Main Menu panel --
	---------------------
	
	local mainMenu = CreateFrame("FRAME", "FaceShooterConfig")
	mainMenu.name = "FaceShooter"
	
	-- Toggle frames lock on/off
	local str_lock = mainMenu:CreateFontString("mainMenu_str_lock","OVERLAY","GameFontNormal")
	cb_lock = CreateFrame("CheckButton", "mainMenu_cb_lock", mainMenu, "OptionsCheckButtonTemplate")
	str_lock:SetText("Lock Frames")
	str_lock:SetPoint("TOPLEFT", 10, -10)
	cb_lock:SetWidth(18)
	cb_lock:SetHeight(18)
	cb_lock:SetScript("OnClick", function() FS:ToggleLocked() end)
	cb_lock:SetPoint("TOPRIGHT", -10, -10)
	cb_lock:SetChecked(FaceShooterdb.locked)
	
	-- Show frames in raid on/off
	local str_raid = mainMenu:CreateFontString("mainMenu_str_raid","OVERLAY","GameFontNormal")
	cb_raid = CreateFrame("CheckButton", "cb_raid", mainMenu, "OptionsCheckButtonTemplate")
	str_raid:SetText("Show in raid")
	str_raid:SetPoint("TOPLEFT", 10, -40)
	cb_raid:SetWidth(18)
	cb_raid:SetHeight(18)
	cb_raid:SetScript("OnClick", function() FS:ToggleShowInRaid() end)
	cb_raid:SetPoint("TOPRIGHT", -10, -40)
	cb_raid:SetChecked(FaceShooterdb.showInRaid)
	
	-- Show frames in party on/off
	local str_party = mainMenu:CreateFontString("mainMenu_str_party","OVERLAY","GameFontNormal")
	cb_party = CreateFrame("CheckButton", "cb_party", mainMenu, "OptionsCheckButtonTemplate")
	str_party:SetText("Show in party")
	str_party:SetPoint("TOPLEFT", 10, -60)
	cb_party:SetWidth(18)
	cb_party:SetHeight(18)
	cb_party:SetScript("OnClick", function() FS:ToggleShowInParty() end)
	cb_party:SetPoint("TOPRIGHT", -10, -60)
	cb_party:SetChecked(FaceShooterdb.showInParty)
	
	-- Show frames when solo on/off
	local str_solo = mainMenu:CreateFontString("mainMenu_str_solo","OVERLAY","GameFontNormal")
	cb_solo = CreateFrame("CheckButton", "cb_solo", mainMenu, "OptionsCheckButtonTemplate")
	str_solo:SetText("Show when solo")
	str_solo:SetPoint("TOPLEFT", 10, -80)
	cb_solo:SetWidth(18)
	cb_solo:SetHeight(18)
	cb_solo:SetScript("OnClick", function() FS:ToggleShowWhenSolo() end)
	cb_solo:SetPoint("TOPRIGHT", -10, -80)
	cb_solo:SetChecked(FaceShooterdb.showWhenSolo)
	
	InterfaceOptions_AddCategory(mainMenu)
	
	-------------------------------
	-- Shots configuration panel --
	-------------------------------

	local shotsMenu = CreateFrame("FRAME", "ShotsConfig", FaceShooterConfig)
	shotsMenu.name = "Shots Suggestion"
	shotsMenu.parent="FaceShooter"

	-- Show shot suggestion frame on/off
	local str_shots = shotsMenu:CreateFontString("shotsMenu_str_shots","OVERLAY","GameFontNormal")
	cb_shots = CreateFrame("CheckButton", "cb_shots", shotsMenu, "OptionsCheckButtonTemplate")
	str_shots:SetText("Show shot suggestion frame")
	str_shots:SetPoint("TOPLEFT", 10, -10)
	cb_shots:SetWidth(18)
	cb_shots:SetHeight(18)
	cb_shots:SetScript("OnClick", function() FS:ToggleShots() end)
	cb_shots:SetPoint("TOPRIGHT", -10, -10)
	cb_shots:SetChecked(FaceShooterdb.enableShots)
	
	-- Shot suggestion frame scale
	local str_scale_shots = shotsMenu:CreateFontString("shotsMenu_str_scale","OVERLAY","GameFontNormal")
	sl_scale_shots = CreateFrame("Slider", "sl_scale_shots", shotsMenu, "OptionsSliderTemplate")
	str_scale_shots:SetText("Scale")
	str_scale_shots:SetPoint("TOPLEFT", 10, -40)
	sl_scale_shots:SetMinMaxValues(50, 200)
	sl_scale_shots:SetValue(FaceShooterdb.scaleShots)
	sl_scale_shots:SetValueStep(1)
	sl_scale_shots:SetScript("OnValueChanged", function(self) FS:SetFrameScale("shots", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_scale_shots:GetName() .. "Low"):SetText("50%")
	getglobal(sl_scale_shots:GetName() .. "High"):SetText("200%")
	getglobal(sl_scale_shots:GetName() .. "Text"):SetText(FaceShooterdb.scaleShots.."%")
	sl_scale_shots:SetPoint("TOPRIGHT", -10, -40)
 
	-- Shot suggestion frame alpha
	local str_alpha_shots = shotsMenu:CreateFontString("shotsMenu_str_alpha","OVERLAY","GameFontNormal")
	sl_alpha_shots = CreateFrame("Slider", "sl_alpha_shots", shotsMenu, "OptionsSliderTemplate")
	str_alpha_shots:SetText("Alpha")
	str_alpha_shots:SetPoint("TOPLEFT", 10, -70)
	sl_alpha_shots:SetMinMaxValues(0, 100)
	sl_alpha_shots:SetValue(FaceShooterdb.alphaShots)
	sl_alpha_shots:SetValueStep(1)
	sl_alpha_shots:SetScript("OnValueChanged", function(self) FS:SetFrameAlpha("shots", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_alpha_shots:GetName() .. "Low"):SetText("0%")
	getglobal(sl_alpha_shots:GetName() .. "High"):SetText("100%")
	getglobal(sl_alpha_shots:GetName() .. "Text"):SetText(FaceShooterdb.alphaShots.."%")
	sl_alpha_shots:SetPoint("TOPRIGHT", -10, -70)
  
	-- Ignore Hunter's Mark on/off
	local str_ihm = shotsMenu:CreateFontString("shotsMenu_str_ihm","OVERLAY","GameFontNormal")
	cb_ihm = CreateFrame("CheckButton", "cb_ihm", shotsMenu, "OptionsCheckButtonTemplate")
	str_ihm:SetText("Don't suggest Hunter's Mark in combat")
	str_ihm:SetPoint("TOPLEFT", 10, -120)
	cb_ihm:SetWidth(18)
	cb_ihm:SetHeight(18)
	cb_ihm:SetScript("OnClick", function() FS:ToggleIgnoreHuntersMark() end)
	cb_ihm:SetPoint("TOPRIGHT", -10, -120)
	cb_ihm:SetChecked(FaceShooterdb.ignoreHuntersMark)
	
	-- Ignore Arcane Shot on/off
	local str_ias = shotsMenu:CreateFontString("shotsMenu_str_ias","OVERLAY","GameFontNormal")
	cb_ias = CreateFrame("CheckButton", "cb_ias", shotsMenu, "OptionsCheckButtonTemplate")
	str_ias:SetText("Don't suggest Arcane Shot")
	str_ias:SetPoint("TOPLEFT", 10, -140)
	cb_ias:SetWidth(18)
	cb_ias:SetHeight(18)
	cb_ias:SetScript("OnClick", function() FS:ToggleIgnoreAS() end)
	cb_ias:SetPoint("TOPRIGHT", -10, -140)
	cb_ias:SetChecked(FaceShooterdb.ignoreArcaneShot)
	
	-- Weave other shots between Explosive Shots on/off
	local str_wlnl = shotsMenu:CreateFontString("shotsMenu_str_wlnl","OVERLAY","GameFontNormal")
	cb_wlnl = CreateFrame("CheckButton", "cb_wlnl", shotsMenu, "OptionsCheckButtonTemplate")
	str_wlnl:SetText("Weave other shots between Explosive Shots")
	str_wlnl:SetPoint("TOPLEFT", 10, -160)
	cb_wlnl:SetWidth(18)
	cb_wlnl:SetHeight(18)
	cb_wlnl:SetScript("OnClick", function() FS:ToggleWeaveLnL() end)
	cb_wlnl:SetPoint("TOPRIGHT", -10, -160)
	cb_wlnl:SetChecked(FaceShooterdb.weaveLnL)
	
	-- Save Improved Steady Shot procs for Chimera Shot on/off
	local str_siss = shotsMenu:CreateFontString("shotsMenu_str_siss","OVERLAY","GameFontNormal")
	cb_siss = CreateFrame("CheckButton", "cb_siss", shotsMenu, "OptionsCheckButtonTemplate")
	str_siss:SetText("Save Improved Steady Shot procs for Chimera Shot")
	str_siss:SetPoint("TOPLEFT", 10, -180)
	cb_siss:SetWidth(18)
	cb_siss:SetHeight(18)
	cb_siss:SetScript("OnClick", function() FS:ToggleSaveISS() end)
	cb_siss:SetPoint("TOPRIGHT", -10, -180)
	cb_siss:SetChecked(FaceShooterdb.saveISS)
	
	-- Use Default or Rotating display mode
	local str_dm = shotsMenu:CreateFontString("shotsMenu_str_dm","OVERLAY","GameFontNormal")
	cb_dm = CreateFrame("CheckButton", "cb_dm", shotsMenu, "OptionsCheckButtonTemplate")
	str_dm:SetText("Use Rotating display mode")
	str_dm:SetPoint("TOPLEFT", 10, -200)
	cb_dm:SetWidth(18)
	cb_dm:SetHeight(18)
	cb_dm:SetScript("OnClick", function() FS:ToggleDisplayMethod() end)
	cb_dm:SetPoint("TOPRIGHT", -10, -200)
	if FaceShooterdb.displayMethod == "rotating" then cb_dm:SetChecked(true) else cb_dm:SetChecked(false) end
	
	-- Minimum time to live to suggest HM
	local str_minHM_shots = shotsMenu:CreateFontString("shotsMenu_str_minHM","OVERLAY","GameFontNormal")
	sl_minHM_shots = CreateFrame("Slider", "sl_minHM_shots", shotsMenu, "OptionsSliderTemplate")
	str_minHM_shots:SetText("Minimum TTL to suggest Hunter's Mark")
	str_minHM_shots:SetPoint("TOPLEFT", 10, -230)
	sl_minHM_shots:SetMinMaxValues(0, 120)
	sl_minHM_shots:SetValue(FaceShooterdb.minHMTTL)
	sl_minHM_shots:SetValueStep(1)
	sl_minHM_shots:SetScript("OnValueChanged", function(self) FS:SetMinHM("menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().." sec") end)
	getglobal(sl_minHM_shots:GetName() .. "Low"):SetText("0 sec")
	getglobal(sl_minHM_shots:GetName() .. "High"):SetText("120 sec")
	getglobal(sl_minHM_shots:GetName() .. "Text"):SetText(FaceShooterdb.minHMTTL.." sec")
	sl_minHM_shots:SetPoint("TOPRIGHT", -10, -230)
  
	-- Maximum wait delay for ES, CS and KS
	local str_maxWaitDelay_shots = shotsMenu:CreateFontString("shotsMenu_str_maxWaitDelay","OVERLAY","GameFontNormal")
	sl_maxWaitDelay_shots = CreateFrame("Slider", "sl_maxWaitDelay_shots", shotsMenu, "OptionsSliderTemplate")
	str_maxWaitDelay_shots:SetText("Maximum time to wait for ES, CS and KS")
	str_maxWaitDelay_shots:SetPoint("TOPLEFT", 10, -260)
	sl_maxWaitDelay_shots:SetMinMaxValues(0, 15)
	sl_maxWaitDelay_shots:SetValue(FaceShooterdb.maxWaitDelay)
	sl_maxWaitDelay_shots:SetValueStep(1)
	sl_maxWaitDelay_shots:SetScript("OnValueChanged", function(self) FS:SetMaxWaitDelay("menu", (self:GetValue() / 10)); getglobal(self:GetName() .. "Text"):SetText((self:GetValue() / 10).." sec") end)
	getglobal(sl_maxWaitDelay_shots:GetName() .. "Low"):SetText("0 sec")
	getglobal(sl_maxWaitDelay_shots:GetName() .. "High"):SetText("1.5 sec")
	getglobal(sl_maxWaitDelay_shots:GetName() .. "Text"):SetText((FaceShooterdb.maxWaitDelay / 10).." sec")
	sl_maxWaitDelay_shots:SetPoint("TOPRIGHT", -10, -260)
	
 	InterfaceOptions_AddCategory(shotsMenu)
	
	-----------------------------
	-- TTL configuration panel --
	-----------------------------

	local ttlMenu = CreateFrame("FRAME", "ttlConfig", FaceShooterConfig)
	ttlMenu.name = "Time to Life"
	ttlMenu.parent="FaceShooter"

	-- Show TTL frame on/off
	local str_TTL = ttlMenu:CreateFontString("ttlMenu_str_TTL","OVERLAY","GameFontNormal")
	cb_TTL = CreateFrame("CheckButton", "cb_TTL", ttlMenu, "OptionsCheckButtonTemplate")
	str_TTL:SetText("Show time to life frame")
	str_TTL:SetPoint("TOPLEFT", 10, -10)
	cb_TTL:SetWidth(18)
	cb_TTL:SetHeight(18)
	cb_TTL:SetScript("OnClick", function() FS:ToggleTTL() end)
	cb_TTL:SetPoint("TOPRIGHT", -10, -10)
	cb_TTL:SetChecked(FaceShooterdb.enableTTL)
	
	-- TTL frame scale
	local str_scale_TTL = ttlMenu:CreateFontString("ttlMenu_str_scale","OVERLAY","GameFontNormal")
	sl_scale_TTL = CreateFrame("Slider", "sl_scale_TTL", ttlMenu, "OptionsSliderTemplate")
	str_scale_TTL:SetText("Scale")
	str_scale_TTL:SetPoint("TOPLEFT", 10, -40)
	sl_scale_TTL:SetMinMaxValues(50, 200)
	sl_scale_TTL:SetValue(FaceShooterdb.scaleTTL)
	sl_scale_TTL:SetValueStep(1)
	sl_scale_TTL:SetScript("OnValueChanged", function(self) FS:SetFrameScale("ttl", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_scale_TTL:GetName() .. "Low"):SetText("50%")
	getglobal(sl_scale_TTL:GetName() .. "High"):SetText("200%")
	getglobal(sl_scale_TTL:GetName() .. "Text"):SetText(FaceShooterdb.scaleTTL.."%")
	sl_scale_TTL:SetPoint("TOPRIGHT", -10, -40)
 
	-- TTL frame alpha
	local str_alpha_TTL = ttlMenu:CreateFontString("ttlMenu_str_alpha","OVERLAY","GameFontNormal")
	sl_alpha_TTL = CreateFrame("Slider", "sl_alpha_TTL", ttlMenu, "OptionsSliderTemplate")
	str_alpha_TTL:SetText("Alpha")
	str_alpha_TTL:SetPoint("TOPLEFT", 10, -70)
	sl_alpha_TTL:SetMinMaxValues(0, 100)
	sl_alpha_TTL:SetValue(FaceShooterdb.alphaTTL)
	sl_alpha_TTL:SetValueStep(1)
	sl_alpha_TTL:SetScript("OnValueChanged", function(self) FS:SetFrameAlpha("ttl", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_alpha_TTL:GetName() .. "Low"):SetText("0%")
	getglobal(sl_alpha_TTL:GetName() .. "High"):SetText("100%")
	getglobal(sl_alpha_TTL:GetName() .. "Text"):SetText(FaceShooterdb.alphaTTL.."%")
	sl_alpha_TTL:SetPoint("TOPRIGHT", -10, -70)
  
	-- Turn practise mode on/off
	local str_practise = ttlMenu:CreateFontString("ttlMenu_str_practise","OVERLAY","GameFontNormal")
	cb_practise = CreateFrame("CheckButton", "cb_practise", ttlMenu, "OptionsCheckButtonTemplate")
	str_practise:SetText("Practise mode (ignore TTL on dummies)")
	str_practise:SetPoint("TOPLEFT", 10, -120)
	cb_practise:SetWidth(18)
	cb_practise:SetHeight(18)
	cb_practise:SetScript("OnClick", function() FS:TogglePractise() end)
	cb_practise:SetPoint("TOPRIGHT", -10, -120)
	cb_practise:SetChecked(FaceShooterdb.practiseMode)
	
	InterfaceOptions_AddCategory(ttlMenu)

	---------------------------------
	-- Aspects configuration panel --
	---------------------------------

	local aspectsMenu = CreateFrame("FRAME", "AspectsConfig", FaceShooterConfig)
	aspectsMenu.name = "Aspects"
	aspectsMenu.parent="FaceShooter"

	-- Show Aspects frame on/off
	local str_aspects = aspectsMenu:CreateFontString("aspectsMenu_str_aspects","OVERLAY","GameFontNormal")
	cb_aspects = CreateFrame("CheckButton", "cb_aspects", aspectsMenu, "OptionsCheckButtonTemplate")
	str_aspects:SetText("Show aspects frame")
	str_aspects:SetPoint("TOPLEFT", 10, -10)
	cb_aspects:SetWidth(18)
	cb_aspects:SetHeight(18)
	cb_aspects:SetScript("OnClick", function() FS:ToggleAspects() end)
	cb_aspects:SetPoint("TOPRIGHT", -10, -10)
	cb_aspects:SetChecked(FaceShooterdb.enableAspects)
	
	-- Aspects frame scale
	local str_scale_aspects = aspectsMenu:CreateFontString("aspectsMenu_str_scale","OVERLAY","GameFontNormal")
	sl_scale_aspects = CreateFrame("Slider", "sl_scale_aspects", aspectsMenu, "OptionsSliderTemplate")
	str_scale_aspects:SetText("Scale")
	str_scale_aspects:SetPoint("TOPLEFT", 10, -40)
	sl_scale_aspects:SetMinMaxValues(50, 200)
	sl_scale_aspects:SetValue(FaceShooterdb.scaleAspects)
	sl_scale_aspects:SetValueStep(1)
	sl_scale_aspects:SetScript("OnValueChanged", function(self) FS:SetFrameScale("aspects", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_scale_aspects:GetName() .. "Low"):SetText("50%")
	getglobal(sl_scale_aspects:GetName() .. "High"):SetText("200%")
	getglobal(sl_scale_aspects:GetName() .. "Text"):SetText(FaceShooterdb.scaleAspects.."%")
	sl_scale_aspects:SetPoint("TOPRIGHT", -10, -40)
 
	-- Aspects frame alpha
	local str_alpha_aspects = aspectsMenu:CreateFontString("aspectsMenu_str_alpha","OVERLAY","GameFontNormal")
	sl_alpha_aspects = CreateFrame("Slider", "sl_alpha_aspects", aspectsMenu, "OptionsSliderTemplate")
	str_alpha_aspects:SetText("Alpha")
	str_alpha_aspects:SetPoint("TOPLEFT", 10, -70)
	sl_alpha_aspects:SetMinMaxValues(0, 100)
	sl_alpha_aspects:SetValue(FaceShooterdb.alphaAspects)
	sl_alpha_aspects:SetValueStep(1)
	sl_alpha_aspects:SetScript("OnValueChanged", function(self) FS:SetFrameAlpha("aspects", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_alpha_aspects:GetName() .. "Low"):SetText("0%")
	getglobal(sl_alpha_aspects:GetName() .. "High"):SetText("100%")
	getglobal(sl_alpha_aspects:GetName() .. "Text"):SetText(FaceShooterdb.alphaAspects.."%")
	sl_alpha_aspects:SetPoint("TOPRIGHT", -10, -70)
  
	-- Aspects frame minimum threshold
	local str_min_aspects = aspectsMenu:CreateFontString("aspectsMenu_str_min","OVERLAY","GameFontNormal")
	sl_min_aspects = CreateFrame("Slider", "sl_min_aspects", aspectsMenu, "OptionsSliderTemplate")
	str_min_aspects:SetText("Minimum threshold for AothV warning")
	str_min_aspects:SetPoint("TOPLEFT", 10, -130)
	sl_min_aspects:SetMinMaxValues(0, FaceShooterdb.maxThresholdAspects)
	sl_min_aspects:SetValue(FaceShooterdb.minThresholdAspects)
	sl_min_aspects:SetValueStep(1)
	sl_min_aspects:SetScript("OnValueChanged", function(self) FS:AspectsOptions("minmenu "..self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_min_aspects:GetName() .. "Low"):SetText("0%")
	getglobal(sl_min_aspects:GetName() .. "High"):SetText(FaceShooterdb.maxThresholdAspects.."%")
	getglobal(sl_min_aspects:GetName() .. "Text"):SetText(FaceShooterdb.minThresholdAspects.."%")
	sl_min_aspects:SetPoint("TOPRIGHT", -10, -130)
  
	-- Aspects frame maximum threshold
	local str_max_aspects = aspectsMenu:CreateFontString("aspectsMenu_str_max","OVERLAY","GameFontNormal")
	sl_max_aspects = CreateFrame("Slider", "sl_max_aspects", aspectsMenu, "OptionsSliderTemplate")
	str_max_aspects:SetText("Maximum threshold for AothV warning")
	str_max_aspects:SetPoint("TOPLEFT", 10, -160)
	sl_max_aspects:SetMinMaxValues(FaceShooterdb.minThresholdAspects, 100)
	sl_max_aspects:SetValue(FaceShooterdb.maxThresholdAspects)
	sl_max_aspects:SetValueStep(1)
	sl_max_aspects:SetScript("OnValueChanged", function(self) FS:AspectsOptions("maxmenu "..self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_max_aspects:GetName() .. "Low"):SetText(FaceShooterdb.minThresholdAspects.."%")
	getglobal(sl_max_aspects:GetName() .. "High"):SetText("100%")
	getglobal(sl_max_aspects:GetName() .. "Text"):SetText(FaceShooterdb.maxThresholdAspects.."%")
	sl_max_aspects:SetPoint("TOPRIGHT", -10, -160)
  
	InterfaceOptions_AddCategory(aspectsMenu)

	-----------------------------------------
	-- Sniper Training configuration panel --
	-----------------------------------------

	local sniperMenu = CreateFrame("FRAME", "SniperConfig", FaceShooterConfig)
	sniperMenu.name = "Sniper Training"
	sniperMenu.parent="FaceShooter"

	-- Show Sniper Training Frame on/off
	local str_sniper = sniperMenu:CreateFontString("sniperMenu_str_sniper","OVERLAY","GameFontNormal")
	cb_sniper = CreateFrame("CheckButton", "cb_sniper", sniperMenu, "OptionsCheckButtonTemplate")
	str_sniper:SetText("Show sniper training frame")
	str_sniper:SetPoint("TOPLEFT", 10, -10)
	cb_sniper:SetWidth(18)
	cb_sniper:SetHeight(18)
	cb_sniper:SetScript("OnClick", function() FS:ToggleSniper() end)
	cb_sniper:SetPoint("TOPRIGHT", -10, -10)
	cb_sniper:SetChecked(FaceShooterdb.enableSniper)
	
	-- Sniper frame scale
	local str_scale_sniper = sniperMenu:CreateFontString("sniperMenu_str_scale","OVERLAY","GameFontNormal")
	sl_scale_sniper = CreateFrame("Slider", "sl_scale_sniper", sniperMenu, "OptionsSliderTemplate")
	str_scale_sniper:SetText("Scale")
	str_scale_sniper:SetPoint("TOPLEFT", 10, -40)
	sl_scale_sniper:SetMinMaxValues(50, 200)
	sl_scale_sniper:SetValue(FaceShooterdb.scaleSniper)
	sl_scale_sniper:SetValueStep(1)
	sl_scale_sniper:SetScript("OnValueChanged", function(self) FS:SetFrameScale("sniper", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_scale_sniper:GetName() .. "Low"):SetText("50%")
	getglobal(sl_scale_sniper:GetName() .. "High"):SetText("200%")
	getglobal(sl_scale_sniper:GetName() .. "Text"):SetText(FaceShooterdb.scaleSniper.."%")
	sl_scale_sniper:SetPoint("TOPRIGHT", -10, -40)
 
	-- Sniper frame alpha
	local str_alpha_sniper = sniperMenu:CreateFontString("sniperMenu_str_alpha","OVERLAY","GameFontNormal")
	sl_alpha_sniper = CreateFrame("Slider", "sl_alpha_sniper", sniperMenu, "OptionsSliderTemplate")
	str_alpha_sniper:SetText("Alpha")
	str_alpha_sniper:SetPoint("TOPLEFT", 10, -70)
	sl_alpha_sniper:SetMinMaxValues(0, 100)
	sl_alpha_sniper:SetValue(FaceShooterdb.alphaSniper)
	sl_alpha_sniper:SetValueStep(1)
	sl_alpha_sniper:SetScript("OnValueChanged", function(self) FS:SetFrameAlpha("sniper", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_alpha_sniper:GetName() .. "Low"):SetText("0%")
	getglobal(sl_alpha_sniper:GetName() .. "High"):SetText("100%")
	getglobal(sl_alpha_sniper:GetName() .. "Text"):SetText(FaceShooterdb.alphaSniper.."%")
	sl_alpha_sniper:SetPoint("TOPRIGHT", -10, -70)
  
	InterfaceOptions_AddCategory(sniperMenu)

	-----------------------------------------
	-- Chimera configuration panel --
	-----------------------------------------

	local chimeraMenu = CreateFrame("FRAME", "ChimeraConfig", FaceShooterConfig)
	chimeraMenu.name = "Chimera"
	chimeraMenu.parent="FaceShooter"

	-- Show Chimera frame on/off
	local str_chimera = chimeraMenu:CreateFontString("chimeraMenu_str_chimera","OVERLAY","GameFontNormal")
	cb_chimera = CreateFrame("CheckButton", "cb_chimera", chimeraMenu, "OptionsCheckButtonTemplate")
	str_chimera:SetText("Show chimera frame")
	str_chimera:SetPoint("TOPLEFT", 10, -10)
	cb_chimera:SetWidth(18)
	cb_chimera:SetHeight(18)
	cb_chimera:SetScript("OnClick", function() FS:ToggleChimera() end)
	cb_chimera:SetPoint("TOPRIGHT", -10, -10)
	cb_chimera:SetChecked(FaceShooterdb.enableChimera)
	
	-- Chimera frame scale
	local str_scale_chimera = chimeraMenu:CreateFontString("chimeraMenu_str_scale","OVERLAY","GameFontNormal")
	sl_scale_chimera = CreateFrame("Slider", "sl_scale_chimera", chimeraMenu, "OptionsSliderTemplate")
	str_scale_chimera:SetText("Scale")
	str_scale_chimera:SetPoint("TOPLEFT", 10, -40)
	sl_scale_chimera:SetMinMaxValues(50, 200)
	sl_scale_chimera:SetValue(FaceShooterdb.scaleChimera)
	sl_scale_chimera:SetValueStep(1)
	sl_scale_chimera:SetScript("OnValueChanged", function(self) FS:SetFrameScale("chimera", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_scale_chimera:GetName() .. "Low"):SetText("50%")
	getglobal(sl_scale_chimera:GetName() .. "High"):SetText("200%")
	getglobal(sl_scale_chimera:GetName() .. "Text"):SetText(FaceShooterdb.scaleChimera.."%")
	sl_scale_chimera:SetPoint("TOPRIGHT", -10, -40)
 
	-- Chimera frame alpha
	local str_alpha_chimera = chimeraMenu:CreateFontString("chimeraMenu_str_alpha","OVERLAY","GameFontNormal")
	sl_alpha_chimera = CreateFrame("Slider", "sl_alpha_chimera", chimeraMenu, "OptionsSliderTemplate")
	str_alpha_chimera:SetText("Alpha")
	str_alpha_chimera:SetPoint("TOPLEFT", 10, -70)
	sl_alpha_chimera:SetMinMaxValues(0, 100)
	sl_alpha_chimera:SetValue(FaceShooterdb.alphaChimera)
	sl_alpha_chimera:SetValueStep(1)
	sl_alpha_chimera:SetScript("OnValueChanged", function(self) FS:SetFrameAlpha("chimera", "menu", self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue().."%") end)
	getglobal(sl_alpha_chimera:GetName() .. "Low"):SetText("0%")
	getglobal(sl_alpha_chimera:GetName() .. "High"):SetText("100%")
	getglobal(sl_alpha_chimera:GetName() .. "Text"):SetText(FaceShooterdb.alphaChimera.."%")
	sl_alpha_chimera:SetPoint("TOPRIGHT", -10, -70)
  
	InterfaceOptions_AddCategory(chimeraMenu)
end

-- Update the Config Frame
function FS:UpdateConfigFrame()
	-- Main
	cb_lock:SetChecked(FaceShooterdb.locked)
	cb_raid:SetChecked(FaceShooterdb.showInRaid)
	cb_party:SetChecked(FaceShooterdb.showInParty)
	cb_solo:SetChecked(FaceShooterdb.showWhenSolo)
	-- Shots
	cb_shots:SetChecked(FaceShooterdb.enableShots)
	sl_scale_shots:SetValue(FaceShooterdb.scaleShots)
	sl_alpha_shots:SetValue(FaceShooterdb.alphaShots)
	cb_ihm:SetChecked(FaceShooterdb.ignoreHuntersMark)
	cb_ias:SetChecked(FaceShooterdb.ignoreArcaneShot)
	cb_wlnl:SetChecked(FaceShooterdb.weaveLnL)
	cb_siss:SetChecked(FaceShooterdb.saveISS)
	if FaceShooterdb.displayMethod == "rotating" then cb_dm:SetChecked(true) else cb_dm:SetChecked(false) end
	sl_minHM_shots:SetValue(FaceShooterdb.minHMTTL)
	sl_maxWaitDelay_shots:SetValue(FaceShooterdb.maxWaitDelay)
	-- TTL
	cb_TTL:SetChecked(FaceShooterdb.enableTTL)
	sl_scale_TTL:SetValue(FaceShooterdb.scaleTTL)
	sl_alpha_TTL:SetValue(FaceShooterdb.alphaTTL)
	cb_practise:SetChecked(FaceShooterdb.practiseMode)
	-- Aspects
	cb_aspects:SetChecked(FaceShooterdb.enableAspects)
	sl_scale_aspects:SetValue(FaceShooterdb.scaleAspects)
	sl_alpha_aspects:SetValue(FaceShooterdb.alphaAspects)
	sl_min_aspects:SetValue(FaceShooterdb.minThresholdAspects)
	sl_max_aspects:SetValue(FaceShooterdb.maxThresholdAspects)
	-- Sniper
	cb_sniper:SetChecked(FaceShooterdb.enableSniper)
	sl_scale_sniper:SetValue(FaceShooterdb.scaleSniper)
	sl_alpha_sniper:SetValue(FaceShooterdb.alphaSniper)
	-- Chimera
	cb_chimera:SetChecked(FaceShooterdb.enableChimera)
	sl_scale_chimera:SetValue(FaceShooterdb.scaleChimera)
	sl_alpha_chimera:SetValue(FaceShooterdb.alphaChimera)
end

-- Slash commands
function FS.Options(arg1)
	local _, _, command, args = string.find(arg1, "(%w+)%s?(.*)");
	if command == "lock" then
		FS:ToggleLocked()
	elseif command == "raid" then
		FS:ToggleShowInRaid()
	elseif command == "party" then
		FS:ToggleShowInParty()
	elseif command == "solo" then
		FS:ToggleShowWhenSolo()
	elseif command == "shots" then
		FS:ShotOptions(args)
	elseif command == "ttl" then
		FS:TTLOptions(args)
	elseif command == "sniper" then
		FS:SniperOptions(args)
	elseif command == "chimera" then
		FS:ChimeraOptions(args)
	elseif command == "aspects" then
		FS:AspectsOptions(args)
	elseif command == "debug" then
		FS:Debug(args)
	elseif command == "config" then
		FS:ShowConfigFrame()
	else
		print("")
		print("FS: Face Shooter version "..FS.version)
		print("FS: /fs config - open the FS config GUI")
		print("FS: /fs lock - lock/unlock frames")
		print("FS: /fs solo/party/raid - toggle frames showing when solo, in party or raid on/off")
		print("FS: /fs shots - shots frame commands")
		print("FS: /fs ttl - TTL frame commands")
		print("FS: /fs sniper - sniper training frame commands")
		print("FS: /fs chimera - chimera frame commands")
		print("FS: /fs aspects - aspects frame commands")
	end
	FS:UpdateConfigFrame()
end

-- Displays the config frame
function FS.ShowConfigFrame()
	InterfaceOptionsFrame_OpenToCategory(getglobal("FaceShooterConfig"))
end